;
; utilitaire de visualisation d'images .bmp
;

;
; Directives de l'assembleur
;
.686P											;; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX												;; pour activer les instructions mmx
.XMM												;; pour activer les instructions sse,sse2
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED										;; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP										;; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE									;; optionel: rends les identifiants sensibles  la casse de caractres


;
; Fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \MAsm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \MAsm32\LIB\masm32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; Prototypes
;
GestionnaireMessages			PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoiteDialogue	PROTO :DWORD,:DWORD,:DWORD,:DWORD


.CONST
;
; Constantes
;
Taille_Pile_Processus_Principal	EQU 16

Couleur_Jaune					EQU 0FFDFDF3Fh			;; 223,223,063 (couleur pleine)
Couleur_Noire					EQU 05F000000h			;; 0,0,0 (assez transparent)

; identifiants des ressources
Rsrc_IDI_Icone_32				EQU 532

Rsrc_IDM_MenuPrincipal			EQU 1000
Rsrc_IDM_MenuPrincipal_C			EQU 1001
Rsrc_IDM_Charger				EQU 1002
Rsrc_IDM_Charger_x2				EQU 1003
Rsrc_IDM_Sauver				EQU 1004
Rsrc_IDM_Capturer				EQU 1005

Rsrc_IDM_Centrer				EQU 1021
Rsrc_IDM_Redimensionner			EQU 1022
Rsrc_IDM_Proportions			EQU 1023
Rsrc_IDM_Informations			EQU 1024

Rsrc_IDM_Basc_Hori				EQU 1041
Rsrc_IDM_Basc_Vert				EQU 1042
Rsrc_IDM_Inv_Alpha				EQU 1043
Rsrc_IDM_Inv_Coul				EQU 1044

Rsrc_IDM_Fondre				EQU 1061
Rsrc_IDM_Remplir				EQU 1062
Rsrc_IDM_Pastelliser			EQU 1063
Rsrc_IDM_TonsDeGris				EQU 1064

Rsrc_IDM_Quitter				EQU 1099

Rsrc_IDD_Insuffisant			EQU 2100
Rsrc_IDC_Insuffisant_C			EQU 2101
Rsrc_IDC_Desole				EQU 2102
Rsrc_IDC_Temps_Changer			EQU 2103

Rsrc_IDD_Quitter				EQU 2200
Rsrc_IDC_Quitter_C				EQU 2201
Rsrc_IDC_Vraiment_quitter		EQU 2202
Rsrc_IDC_Hum_Oui				EQU 2203
Rsrc_IDC_Ah_Ca_Non				EQU 2204


.DATA
;
; Definition des STRUCTURES
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT						;; pour un total de 16 octets
	_Instance_			DWORD ?					;; pointeur de l'instance
	_Taille_Initiale_		DWORD ?					;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?					;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?					;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT								;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?					;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?					;; pointeur de la zone utilisable (align sur 16 octets)
	_Inutilise_01_			DWORD ?					;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Bloc_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire spcifique aux crans
_Bloc_Memoire_Ecran_	STRUCT						;; pour un total de 64 octets
	_Largeur_Ecran_X4_		DWORD ?					;; (align 16) largeur de l'cran relle multiplie par 4 (*DWORD) (ajout, parceque souvent utilis, evite donc des shl,2)
	_Largeur_Ecran_		DWORD ?					;; largeur de l'cran (en pixels)
	_Hauteur_Ecran_		DWORD ?					;; (align 8) hauteur de l'cran (en pixels)
	_inutilise_01_			DWORD ?					;; inutilis...
	_Taille_Du_Bloc_		DWORD ?					;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_inutilise_02_			DWORD ?					;; inutilis...
	_inutilise_03_			DWORD ?					;; (align 8) inutilis...
	_inutilise_04_			DWORD ?					;; inutilis...
	_Pointeur_			DWORD ?					;; (align 16) pointeur de la zone utilisable (adresse aligne sur 16 octets)
	_Pointeur_Dbuffer_		DWORD ?					;; pointeur de la zone Dbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Pointeur_Zbuffer_		DWORD ?					;; (align 8) pointeur de la zone Zbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_LimitesFace_	DWORD ?					;; (align 16) pointeur de la zone limites face (zro quand ce n'est pas un cran double)
	_inutilise_05_			DWORD ?					;; inutilis...
	_Temoins_Ecran_		DWORD ?					;; (align 8) tmoins de l'cran... bit 0=cran double buffet utilis
	_inutilise_06_			DWORD ?					;; inutilis...
_Bloc_Memoire_Ecran_	ENDS

; structure pour obtenir les pointeurs relatifs  un fichier bitmap charg dans un bloc mmoire
_Pointeurs_Structure_Bitmap_	STRUCT					;; pour un totals de 16 octets
	_Pointeur_Entete_Bitmap_			DWORD ?			;; position de dbut du fichier bitmap en mmoire (BITMAPFILEHEADER)
	_Pointeur_Informations_Bitmap_	DWORD ?			;; position o se situent les informations relatives au bitmap (BITMAPINFOHEADER ou BITMAPCOREHEADER)
	_Pointeur_Palette_Bitmap_		DWORD ?			;; position o se situe la palette du bitmap
	_Pointeur_Pixels_Du_Bitmap_		DWORD ?			;; position o se situe les pixels du bitmap
_Pointeurs_Structure_Bitmap_	ENDS


.DATA
;
; Variable dfinies
;
;INCLUDE Police_Xx16.inc
INCLUDE Police_LucidaCalligraphy_18_G.inc

ALIGN 16
Largeur_Ecran_Travail			DWORD 800	;1024	;512
Hauteur_Ecran_Travail			DWORD 600	;768	;384
Largeur_Ecran_Final				DWORD ?				;; ) gros ralentissement lorsque la taille diffre du bloc de travail, a cause du retaillage...
Hauteur_Ecran_Final				DWORD ?				;; )
;Largeur_Ecran_Final_Moitiee		DWORD ?
;Hauteur_Ecran_Final_Moitiee		DWORD ?

Largeur_Bitmap_En_Pixels			DWORD ?
Hauteur_Bitmap_En_Pixels			DWORD ?

Sauvegarde_Largeur				DWORD ?
Sauvegarde_Hauteur				DWORD ?

;
; quelques compteurs
;
Compteur_Des_images				DWORD 0


;
; variables diverses
;
Principal_Gestionnaire_Des_Messages	DWORD ?			;; servira pour la clture du programme
Instance_Application			DWORD ?
Instance_Boite_Dialogue			DWORD ?
Pointeur_Ligne_Commandes			DWORD 0
Pointeur_Fenetre				DWORD ?
Pointeur_Menu_Principal			DWORD ?
Pointeur_DC_Ecran				HDC ?
Pointeur_DC_Bitmap				HDC ?
Pointeur_DC_Temp				HDC ?
Pointeur_DIB_Temp				HDC ?
Pointeur_Processus_Principal		DWORD ?

Pointeur_DC_Temporaire			DWORD ?
Pointeur_DC_Compatible			DWORD ?
Pointeur_Nouveau_Dib			DWORD ?

Pointeur_Pixels_Recuperes		DWORD ?

Pointeur_Temporaire				DWORD ?

;Taille_Bitmap					DWORD ?
Decalage_Centrage				DWORD ?


;
; variables 2D (lignes, points, ...)
;
Position_Ecran_X		DWORD ?
Position_Ecran_Y		DWORD ?
Mouvement_Souris_X		DWORD 0
Mouvement_Souris_Y		DWORD 0


;
; quelques tmoins
;
Temoin_Affichage_Ecran			DWORD 0				;; bit 0 = normal/centr, bit 1 = normal/retaill
Temoin_Poursuite_Processus		BYTE 1				;; 0=termin, 1=actif

Temoin_Centrage				BYTE 1				;; 0=pas centr, 1=centr
Temoin_Redimensionnement			BYTE 1				;; 0=pas de redimensionnement, 1=redimensionnement
Temoin_Dimensions_Proportionnelles	BYTE 1				;; 0=pas proportionnel, 1=proportionnel
Temoin_Affichage_Informations		BYTE 0				;; 0=inactives, 1=actives
Temoin_Fondu_Ecran				BYTE 0				;; 0=pas fondu, 1=fondu
Temoin_Remplissage_Fondu			BYTE 0				;; 0=pas d'adoucissement, 1=adoucissement
Temoin_Pastelliser				BYTE 0				;; 0=pas couleurs pastel, 1=couleurs pastel
Temoin_Tons_De_Gris				BYTE 0				;; 0=pas tons de gris, 1=tons de gris

Temoin_Commandes				BYTE 0				;; 0=pas de commandes, 1=commandes
Temoin_Ecran_En_Memoire			BYTE 0				;; 0=inutilis, 1=utilis
Temoin_Fichier_Bmp				BYTE 0				;; 0=rien, 1=fichier bmp charg
Temoin_Bmp_x2					BYTE 0				;; 0=rien, 1=fichier bmp x2 charg
;Temoin_Processus_Pret			BYTE 0
; variables permettant de connaitre  tout moment le statut des boutons de la souris
Temoin_Bouton_Souris_Gauche		BYTE ?
Temoin_Bouton_Souris_Milieu		BYTE ?
Temoin_Bouton_Souris_Droit		BYTE ?


; chaines de caractres
Chaine_Titre_Fenetre			BYTE "Programme",0
Chaine_Type_Fenetre				BYTE "Type Personnalis",0

Chaine_Separation_Ligne_Commande	BYTE '" "',0
Chaine_Fin_Commande				BYTE '"',0
Chaine_Separation_Fichier		BYTE "\",0
Chaine_Extension_Bmp			BYTE ".bmp",0

Chaine_Display					BYTE "DISPLAY",0

Chaine_Images_Seconde				BYTE "Nombre d'images par secondes : "
Chaine_Nombre_Images_Seconde			BYTE 12 DUP (?)
Chaine_Fichier						BYTE "Fichier : "
Chaine_Nom_Fichier					BYTE MAX_PATH DUP (?)		;; MAX_PATH = 260

Chaine_Largeur_Ecran_Travail			BYTE "Largeur : "
Chaine_Valeur_Largeur_Ecran_Travail	BYTE 12 DUP (?)
Chaine_Hauteur_Ecran_Travail			BYTE "Hauteur : "
Chaine_Valeur_Hauteur_Ecran_Travail	BYTE 12 DUP (?)

Chaine_Chargement					BYTE "F1 : Charger un fichier",0
Chaine_Chargement_x2				BYTE "F2 : Charger un fichier et doubler sa taille",0
Chaine_Sauvegarde					BYTE "F4 : Sauvegarder le fichier",0
Chaine_Capture						BYTE "F12 : Capturer l'ecran visible",0

Chaine_Centrage						BYTE "C : Centrage = "
Chaine_Nombre_Centrage					BYTE "1",0
Chaine_Redimensionnement					BYTE "D : Redimensionnement a la taille ecran = "
Chaine_Nombre_Redimensionnement			BYTE "1",0
Chaine_Dimensions_Proportionnelles			BYTE "P : Redimensionnement proportionnel = "
Chaine_Nombre_Dimensions_Proportionnelles	BYTE "1",0
Chaine_Affichage_Informations				BYTE "I : Affichage des informations = "
Chaine_Nombre_Affichage_Informations		BYTE "0",0

Chaine_Fondu_Ecran						BYTE "F : Effet fondu = "
Chaine_Nombre_Fondu_Ecran				BYTE "0",0
Chaine_Remplissage_Fondu					BYTE "R : Remplissage fondu = "
Chaine_Nombre_Remplissage_Fondu			BYTE "0",0
Chaine_Pastelliser						BYTE "E : Pastelliser les couleurs = "
Chaine_Nombre_Pastelliser				BYTE "0",0
Chaine_Tons_De_Gris						BYTE "G : Tons de gris = "
Chaine_Nombre_Tons_De_Gris				BYTE "0",0

Chaine_Filtre_De_Selection_Fichiers_Images		BYTE "Images (*.bmp,*.dib,*.gif,*.jpg,*.raw)",0,"*.bmp;*.dib;*.gif;*.jpg;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
Chaine_Extension_Image_Par_Defaut				BYTE "bmp",0
Chaine_Type_De_Selection_Chargement_Fichier		BYTE "Dfinissez le fichier  charger.",0
Chaine_Type_De_Selection_Sauvegarde_Fichier		BYTE "Dfinissez le fichier  sauvegarder.",0

;; les messages d'erreur
;_Fichier_Chaine_Message_Erreur_NonSelection_		BYTE "aucun fichier n'a t slectionn !",0
;_Fichier_Chaine_Message_Erreur_Taille_			BYTE "le fichier est trop volumineux !",0


ALIGN 16
; definition des variables structures
Instance_Memoire							_Informations_Memoire_ <?>
Tampon_Ecran_Temporaire						_Bloc_Memoire_Ecran_ <?>
Tampon_Ecran_Travail						_Bloc_Memoire_Ecran_ <?>
Tampon_Ecran_Final							_Bloc_Memoire_Ecran_ <?>
Tampon_Table_Redimensionnement_Proportionnelle	_Bloc_Memoire_Ecran_ <?>
Tampon_Table_Redimensionnement				_Bloc_Memoire_Ecran_ <?>
Tampon_Donnees_Image						_Bloc_Memoire_ <?>
Pointeurs_Bitmap_Charge						_Pointeurs_Structure_Bitmap_ <?>

Informations_Fenetre				WNDCLASSEX <?>			;; 12 Dwords
; la structure du fichier  charger
;Entete_Fichier_Bitmap				BITMAPFILEHEADER <?>
; structure BITMAPINFO (elle est dcompose, parcequ'il semble qu'il y ai des difficults pour assembler du code
; lorsque la premire valeur d'une structure est une autre structure...
Entete_Informations_Bitmap			BITMAPINFOHEADER <?>	;; bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords)
Entete_Palette_Bitmap				RGBQUAD 256 dup (<?>)	;; bmiColors (RGBQUAD) (4 octets) * 256
; la structure du fichier  sauvegarder
;Sauvegarder_Entete_Fichier_Bitmap		BITMAPFILEHEADER <?>
Sauvegarder_Entete_Informations_Bitmap	BITMAPINFOHEADER <?>

Informations_Messages_OS				MSG <?>				;; 5 Dwords + 2 Words
Position_Souris					POINT <?>

.CODE
;
; les Macros
;


.CODE
;
; les procdures gnriques utilises
;
INCLUDE GenericProcs.asm


.CODE
;
; les procdures spcifiquemet cres pour le Programme
;


ALIGN 16
;
; procdure d'valuation du temps coul (sert pour les images secondes)
;
EvaluationTemps PROC HWndc:DWORD,uMsg2:DWORD,Periode_Ecoulee:DWORD,dwtime:DWORD

		cmp Periode_Ecoulee,1						;; comparer evnement priodique  1
		jne Label01								;; si c'est diffrent, aller Label01
		pushad									;; sinon, empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov eax,Compteur_Des_images					;; placer le Compteur_Des_images (nombre d'images obtenues) dans eax
		mov esi,OFFSET Chaine_Nombre_Images_Seconde		;; placer l'adresse qui doit contenir la chane du nombre dans esi
		call ConvertirValeurEnChaineDecimale			;; et convertir la valeur en chane dcimale
		mov Compteur_Des_images,0					;; effacer Compteur_Des_images
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label01:
	ret											;; retourner (sortir de la procdure)
EvaluationTemps ENDP


ALIGN 16
;
; ici, on inclus l'indispensable procdure de gestion des messages entre l'application et windows...
;
GestionnaireMessages PROC HWndGM:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD
;LOCAL DessinEcran :PAINTSTRUCT

		cmp Temoin_Poursuite_Processus,-1				;; le processus est arrt ?
		jne GMPasFinApplication						;; si ce n'est pas le cas, aller GMPasFinApplication
		invoke PostQuitMessage,NULL					;; sinon, poster le message de sortie
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
GMPasFinApplication:


		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

; initialisation de la fentre
		cmp eax,WM_CREATE							;; cration de la fentre ?
		jne GMFinInitialisation						;; sinon, aller GMFinInitialisation

; initialiser la slection de fichier
		mov eax,Instance_Boite_Dialogue				;; lire l'instance de l'application
		mov ebx,HWndGM								;; instance fentre
		mov ecx,OFFSET Chaine_Type_De_Selection_Chargement_Fichier	;; titre de la boite de dialogue
		mov edx,OFFSET Chaine_Nom_Fichier				;; dfini par les fonctions Open et Close
		mov esi,OFFSET Chaine_Filtre_De_Selection_Fichiers_Images	;; filtre utilis
		call InitialiserSelectionFichier				;; et initialiser la slection

		mov eax,HWndGM								;; ) sauvegarder le pointeur du gestionnaire, qui sert pour la clture
		mov Principal_Gestionnaire_Des_Messages,eax		;; )
	ret											;; retourner
GMFinInitialisation:


;
; une commande existe ?
;
		cmp Temoin_Commandes,1						;; une commande ?
		jne EviterChargerFichierDepart				;; si ce n'est pas le cas, aller EviterChargerFichierDepart
;		cmp Temoin_Processus_Pret,1					;; processus prt ?
;		jne EviterChargerFichierDepart				;; si ce n'est pas le cas, aller EviterChargerFichierDepart
		mov Temoin_Fichier_Bmp,1						;; positionner le tmoin correspondant  un fichier charg
		mov Temoin_Commandes,0						;; enlever le tmoin

	ret											;; retourner
EviterChargerFichierDepart:


;;
;; dessin de la fentre
;;
;		cmp eax,WM_PAINT
;		jne GMFinMiseAJourEcran						;; sinon, aller GMFinMiseAJourEcran
;		invoke BeginPaint,HWndGM,ADDR DessinEcran
;		mov hDC,eax
;		invoke EndPaint,HWndGM,ADDR DessinEcran
;	Retourner 0									;; retourner
;;GMFinMiseAJourEcran:

;;
;; fermeture de l'application ?
;;
;		cmp eax,WM_CLOSE							;; message de fermeture reu ?
;		jne GMFinFermeture							;; si ce n'est pas le cas, aller GMFinFermeture
;		mov Temoin_Poursuite_Processus,0				;; sinon, on place 0 dans Temoin_Poursuite_Processus
;		xor eax,eax								;; remettre eax  zro
;	ret											;; retourner
;;GMFinFermeture:

;
; fin du processus principal
;
		cmp eax,WM_DESTROY							;; fermeture de l'application par la croix ?
		jne GMFinProcessusTermine					;; si ce n'est pas le cas, aller GMFinProcessusTermine
		mov Temoin_Poursuite_Processus,0				;; sinon, on place 0 dans Temoin_Poursuite_Processus
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
GMFinProcessusTermine:

;;
;; menu popup
;;
;		cmp eax,WM_CONTEXTMENU						;; clic droit de la souris ?
;		jne GMFinAfficherMenu
;; obtenir les position x et y de la souris
;		mov eax,LParam	;if so,show the popup menu			
;		and eax,0ffffh
;		mov ebx,LParam
;		shr ebx,16
;; faire apparaitre le menu pricipal
;		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
;		invoke TrackPopupMenuEx,Pointeur_Menu_Principal,TPM_CENTERALIGN,eax,ebx,HWndGM,NULL
;		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
;	ret											;; retourner
;;GMFinAfficherMenu:

;
; les messages :
; WM_LBUTTONDOWN, WM_LBUTTONUP, WM_LBUTTONDBLCLK,
; WM_MBUTTONDOWN, WM_MBUTTONUP, WM_MBUTTONDBLCLK,
; WM_RBUTTONDOWN, WM_RBUTTONUP, WM_RBUTTONDBLCLK, WM_MOUSEMOVE
; retournent le rsultat obtenu par les boutons et le mouvement de la souris.
;
		cmp eax,WM_LBUTTONDOWN						;; bouton gauche de la souris press ?
		jne GMPasBoutonSourisGauche					;; si c'est diffrent, aller GMPasBoutonSourisGauche
		mov Temoin_Bouton_Souris_Gauche,1				;; placer le tmoin
	ret											;; retourner
GMPasBoutonSourisGauche:
;
		cmp eax,WM_LBUTTONUP						;; bouton gauche de la souris non press ?
		jne GMBoutonSourisGauche						;; si c'est diffrent, aller GMBoutonSourisGauche
		mov Temoin_Bouton_Souris_Gauche,0				;; enlever le tmoin
	ret											;; retourner
GMBoutonSourisGauche:
;;
;		cmp eax,WM_LBUTTONDBLCLK						;; bouton gauche de la souris double clique ?
;		jne GMPasBoutonSourisGaucheDouble				;; si c'est diffrent, aller GMPasBoutonSourisGaucheDouble
;
;	ret											;; retourner
;
;GMPasBoutonSourisGaucheDouble:
;
		cmp eax,WM_MBUTTONDOWN						;; bouton milieu de la souris press ?
		jne GMPasBoutonSourisMilieu					;; si c'est diffrent, aller GMPasBoutonSourisMilieu
		mov Temoin_Bouton_Souris_Milieu,1				;; placer le tmoin
	ret											;; retourner
GMPasBoutonSourisMilieu:
;
		cmp eax,WM_MBUTTONUP						;; bouton milieu de la souris non press ?
		jne GMBoutonSourisMilieu						;; si c'est diffrent, aller GMBoutonSourisMilieu
		mov Temoin_Bouton_Souris_Milieu,0				;; enlever le tmoin
	ret											;; retourner
GMBoutonSourisMilieu:
;;
;		cmp eax,WM_MBUTTONDBLCLK						;; bouton milieu de la souris double clique ?
;		jne GMPasBoutonSourisMilieuDouble				;; si c'est diffrent, aller GMPasBoutonSourisMilieuDouble
;
;	ret											;; retourner
;;GMPasBoutonSourisMilieuDouble:
;
		cmp eax,WM_RBUTTONDOWN						;; bouton droit de la souris press ?
		jne GMPasBoutonSourisDroit					;; si c'est diffrent, aller GMPasBoutonSourisDroit
		mov Temoin_Bouton_Souris_Droit,1				;; placer le tmoin
; obtenir les position x et y de la souris
;		invoke SetCursorPos,Largeur_Ecran_Final_Moitiee,Hauteur_Ecran_Final_Moitiee (optionnel, pour que le menu et le pointeur apparaisse au centre)
		invoke GetCursorPos,ADDR Position_Souris		;; obtenir la position du pointeur souris
; faire apparaitre le menu pricipal
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
		invoke TrackPopupMenuEx,Pointeur_Menu_Principal,TPM_CENTERALIGN,Position_Souris.x,Position_Souris.y,HWndGM,NULL
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
	ret											;; retourner
GMPasBoutonSourisDroit:
;
		cmp eax,WM_RBUTTONUP						;; bouton droit de la souris non press ?
		jne GMBoutonSourisDroit						;; si c'est diffrent, aller GMBoutonSourisDroit
		mov Temoin_Bouton_Souris_Droit,0				;; enlever le tmoin
	ret											;; retourner
GMBoutonSourisDroit:
;;
;		cmp eax,WM_RBUTTONDBLCLK						;; bouton droit de la souris double clique ?
;		jne GMPasBoutonSourisDroitDouble				;; si c'est diffrent, aller GMPasBoutonSourisDroitDouble
;
;	ret											;; retourner
;;GMPasBoutonSourisDroitDouble:

;;
;; mouvement de la souris ?
;;
;		cmp eax,WM_MOUSEMOVE						;; un mouvement de la souris ?
;		jne GMPasMouvementsSouris					;; si ce n'est pas le cas, aller GMPasMouvementsSouris
;; ici, on traite la rotation par rapport  l'axe Y (mouvement souris X)
;		mov eax,LParam								;; sinon on place LParam (Y (word), X (word)) dans eax
;		and eax,00000FFFFh							;; filtrer eax (pour avoir uniquement le X)
;		mov Mouvement_Souris_X,eax					;; sauvegarder le rsultat dans Mouvement_Souris_X (peut tre plac ici, puisque ca ne modifie pas les flags)
;; ici, on traite la rotation par rapport  l'axe X (mouvement souris Y)
;		mov eax,LParam								;; sinon on place LParam (Y (word), X (word)) dans eax
;		shr eax,16								;; dcaler eax  droite de 16 bits (pour avoir l'Y au bon endroit)
;		mov Mouvement_Souris_Y,eax					;; sauvegarder le rsultat dans Mouvement_Souris_Y (peut tre plac ici, puisque ca ne modifie pas les flags)
;;		mov eax,WParam								;; pas utile pour le moment...
;
;	ret											;; retourner
;;GMPasMouvementsSouris:
	
;
; ici, les commandes gnres par la souris sur les menus, ou les controlleurs, grs par windows...
;
		cmp eax,WM_COMMAND							;; un commande est survenue ?
		jne GMFinCommandes							;; si ce n'est pas le cas, aller GMFinCommandes
		mov eax,WParam								;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
;

;
; charger un fichier bmp ?
;
		cmp eax,Rsrc_IDM_Charger						;; charger un fichier ?
		jne GMFinChargerFichier						;; si c'est diffrent, aller GMFinChargerFichier
GMChargerFichier:
; suspendre le processus
		invoke SuspendThread,Pointeur_Processus_Principal	;; suspendre le processus
; faire rapparaitre le pointeur cran
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
; dfinir le type de fichier  charger
		mov eax,HWndGM								;; instance de la fentre
		mov ebx,OFFSET Chaine_Type_De_Selection_Chargement_Fichier	;; titre de la boite de dialogue
		mov ecx,OFFSET Chaine_Nom_Fichier				;; dfini par les fonctions Open et Close
		mov edx,OFFSET Chaine_Filtre_De_Selection_Fichiers_Images	;; les filtres de slection
		mov esi,OFFSET Chaine_Extension_Image_Par_Defaut	;; l'extension par dfaut (elle a dj t dfinie, mais on ne sait jamais)
		call ObtenirNomFichierACharger				;; obtenir les informations
; un fichier  charger ?
		test eax,eax								;; fixer les flags de eax
		jz PasDeFichierACharger						;; si c'est gal  0, aller PasDeFichierACharger
		mov Temoin_Bmp_x2,0							;; enlever le tmoin de la taille double
		mov Temoin_Fichier_Bmp,1						;; positionner le tmoin de fichier charg
PasDeFichierACharger:
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
; reprendre le processus
		invoke ResumeThread,Pointeur_Processus_Principal	;; reprendre le processus

	ret											;; retourner
GMFinChargerFichier:


;
; charger un fichier bmp x2 ?
;
		cmp eax,Rsrc_IDM_Charger_x2					;; charger un fichier x2 ?
		jne GMFinChargerFichierx2					;; si c'est diffrent, aller GMFinChargerFichier
GMChargerFichierx2:
; suspendre le processus
		invoke SuspendThread,Pointeur_Processus_Principal	;; suspendre le processus
; faire rapparaitre le pointeur cran
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
; dfinir le type de fichier  charger
		mov eax,_Fichier_Information_Selection_.hWndOwner	;; instance de la fentre
		mov ebx,OFFSET Chaine_Type_De_Selection_Chargement_Fichier	;; titre de la boite de dialogue
		mov ecx,OFFSET Chaine_Nom_Fichier				;; dfini par les fonctions Open et Close
		mov edx,OFFSET Chaine_Filtre_De_Selection_Fichiers_Images	;; les filtres de slection
		mov esi,OFFSET Chaine_Extension_Image_Par_Defaut	;; l'extension par dfaut (elle a dj t dfinie, mais on ne sait jamais)
		call ObtenirNomFichierACharger				;; obtenir les informations
; un fichier  charger ?
		test eax,eax								;; fixer les flags de eax
		jz PasDeFichierAChargerx2					;; si c'est gal  0, aller PasDeFichierAChargerx2
		mov Temoin_Bmp_x2,1							;; positionner le tmoin de la taille double
		mov Temoin_Fichier_Bmp,1						;; positionner le tmoin de fichier charg
PasDeFichierAChargerx2:
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
; reprendre le processus
		invoke ResumeThread,Pointeur_Processus_Principal	;; reprendre le processus

	ret											;; retourner
GMFinChargerFichierx2:


;
; sauvegarder le fichier ?
;
		cmp eax,Rsrc_IDM_Sauver						;; sauvegarder le fichier ?
		jne GMFinSauvegarderFichier					;; si c'est diffrent, aller GMFinSauvegarderFichier
GMSauvegarderFichier:
; suspendre le processus
		invoke SuspendThread,Pointeur_Processus_Principal	;; suspendre le processus
; faire rapparaitre le pointeur cran
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
; dfinir le type de fichier  sauvegarder
		mov eax,HWndGM								;; instance de la fentre
		mov ebx,OFFSET Chaine_Type_De_Selection_Sauvegarde_Fichier	;; titre de la boite de dialogue
		mov ecx,OFFSET Chaine_Nom_Fichier				;; dfini par les fonctions Open et Close
		mov edx,OFFSET Chaine_Filtre_De_Selection_Fichiers_Images	;; les filtres de slection
		mov esi,OFFSET Chaine_Extension_Image_Par_Defaut	;; l'extension par dfaut (elle a dj t dfinie, mais on ne sait jamais)
		call ObtenirNomFichierASauvegarder				;; obtenir le nom
; un fichier  sauvegarder ?
		test eax,eax								;; fixer les flags de eax
		jz PasDeFichierASauvegarder					;; si c'est gal  0, aller PasDeFichierASauvegarder
; sinon,
		mov ebx,OFFSET Chaine_Nom_Fichier					;; ) sauvegarder le bitmap de l'cran travail
		mov esi,OFFSET Sauvegarder_Entete_Informations_Bitmap	;; )
		mov edi,OFFSET Tampon_Ecran_Travail				;; )
		call SauvegarderFichier_Bmp						;; )
PasDeFichierASauvegarder:
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
; reprendre le processus
		invoke ResumeThread,Pointeur_Processus_Principal	;; reprendre le processus

	ret											;; retourner
GMFinSauvegarderFichier:


;
; capturer l'cran ?
;
		cmp eax,Rsrc_IDM_Capturer					;; charger un fichier ?
		jne GMFinCapturerEcran						;; si c'est diffrent, aller GMFinCapturerEcran
GMCapturerEcran:
; suspendre le processus
		invoke SuspendThread,Pointeur_Processus_Principal	;; suspendre le processus
;
		invoke UpdateWindow,Pointeur_Fenetre
		call CapturerEcran							;; capturer l'cran
; reprendre le processus
		invoke ResumeThread,Pointeur_Processus_Principal	;; reprendre le processus

	ret											;; retourner
GMFinCapturerEcran:


;
; centrer l'affichage ?
;
		cmp eax,Rsrc_IDM_Centrer						;; centrer ?
		jne GMFinCentrerEcran						;; si c'est diffrent, aller GMFinCentrerEcran
GMCentrerEcran:
		xor Temoin_Centrage,1						;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Centrage,1			;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Centrage,1						;; le centrage est activ ?
		je GMCentrerEcran1							;; si c'est le cas, aller GMCentrerEcran1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Centrer,MF_UNCHECKED	;; enlever le marqueur
		jmp GMCentrerEcran2							;; aller GMCentrerEcran2
GMCentrerEcran1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Centrer,MF_CHECKED	;; positionner le marqueur
GMCentrerEcran2:
	ret											;; retourner
GMFinCentrerEcran:


;
; redimensionner l'affichage ?
;
		cmp eax,Rsrc_IDM_Redimensionner				;; redimensionner ?
		jne GMFinRedimensionnerEcran					;; si c'est diffrent, aller GMFinRedimensionnerEcran
GMRedimensionnerEcran:
		xor Temoin_Redimensionnement,1				;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Redimensionnement,1	;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Redimensionnement,1				;; le redimensionnement est activ ?
		je GMRedimensionnerEcran1					;; si c'est le cas, aller GMRedimensionnerEcran1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Redimensionner,MF_UNCHECKED	;; enlever le marqueur
		jmp GMRedimensionnerEcran2					;; aller GMRedimensionnerEcran2
GMRedimensionnerEcran1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Redimensionner,MF_CHECKED	;; positionner le marqueur
GMRedimensionnerEcran2:

	ret											;; retourner
GMFinRedimensionnerEcran:


;
; affichager les informations ?
;
		cmp eax,Rsrc_IDM_Informations					;; informations ?
		jne GMFinAfficherInformations					;; si c'est diffrent, aller GMFinAfficherInformations
GMAfficherInformations:
		xor Temoin_Affichage_Informations,1			;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Affichage_Informations,1	;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Affichage_Informations,1			;; l'affichage des infos est activ ?
		je GMAfficherInformations1					;; si c'est le cas, aller GMAfficherInformations1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Informations,MF_UNCHECKED	;; enlever le marqueur
		jmp GMAfficherInformations2					;; aller GMAfficherInformations2
GMAfficherInformations1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Informations,MF_CHECKED	;; positionner le marqueur
GMAfficherInformations2:

	ret											;; retourner
GMFinAfficherInformations:


;
; conserver les proportions ?
;
		cmp eax,Rsrc_IDM_Proportions					;; proportionner ?
		jne GMFinProportionner						;; si c'est diffrent, aller GMFinProportionner
GMProportionner:
		xor Temoin_Dimensions_Proportionnelles,1		;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Dimensions_Proportionnelles,1	;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Dimensions_Proportionnelles,1		;; conserver les proportions est activ ?
		je GMProportionner1							;; si c'est le cas, aller GMProportionner1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Proportions,MF_UNCHECKED	;; enlever le marqueur
		jmp GMProportionner2						;; aller GMProportionner2
GMProportionner1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Proportions,MF_CHECKED	;; positionner le marqueur
GMProportionner2:

	ret											;; retourner
GMFinProportionner:


;
; basculer horizontalement ?
;
		cmp eax,Rsrc_IDM_Basc_Hori					;; inverser alphas ?
		jne GMFinBasculerHorizontalement				;; si c'est diffrent, aller GMFinBasculerHorizontalement
GMBasculerHorizontalement:
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) inverser les lignes de pixels
		call Mmx_InverserEcranHorizontalement			;; )

	ret											;; retourner
GMFinBasculerHorizontalement:


;
; basculer verticalement ?
;
		cmp eax,Rsrc_IDM_Basc_Vert					;; inverser alphas ?
		jne GMFinBasculerVerticalement				;; si c'est diffrent, aller GMFinBasculerVerticalement
GMBasculerVerticalement:
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) inverser les lignes de pixels
		call Mmx_InverserEcranVerticalement			;; )

	ret											;; retourner
GMFinBasculerVerticalement:


;
; inverser les alphas ?
;
		cmp eax,Rsrc_IDM_Inv_Alpha					;; inverser alphas ?
		jne GMFinInversionAlphas						;; si c'est diffrent, aller GMFinInversionAlphas
GMInverserAlphas:
		mov esi,Tampon_Ecran_Travail._Pointeur_			;; ) sinon, inverser les alphas du bloc
		mov ebx,0FF000000h							;; )
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; )
		call Mmx_InverserBitsBlocMemoire				;; )

	ret											;; retourner
GMFinInversionAlphas:


;
; inverser les couleurs ?
;
		cmp eax,Rsrc_IDM_Inv_Coul					;; inverser couleurs ?
		jne GMFinInversionCouleur					;; si c'est diffrent, aller GMFinInversionCouleur
GMInverserCouleurs:
		mov esi,Tampon_Ecran_Travail._Pointeur_			;; ) sinon, inverser les couleurs du bloc
		mov ebx,000FFFFFFh							;; )
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; )
		call Mmx_InverserBitsBlocMemoire				;; )

	ret											;; retourner
GMFinInversionCouleur:


;
; fondre l'affichage ?
;
		cmp eax,Rsrc_IDM_Fondre						;; fondre ?
		jne GMFinFondreEcran						;; si c'est diffrent, aller GMFinFondreEcran
GMFondreEcran:
		xor Temoin_Fondu_Ecran,1						;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Fondu_Ecran,1		;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Fondu_Ecran,1						;; le fondu est activ ?
		je GMFondreEcran1							;; si c'est le cas, aller GMFondreEcran1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Fondre,MF_UNCHECKED	;; enlever le marqueur
		jmp GMFondreEcran2							;; aller GMFondreEcran2
GMFondreEcran1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Fondre,MF_CHECKED	;; positionner le marqueur
GMFondreEcran2:

	ret											;; retourner
GMFinFondreEcran:


;
; remplissage par fondu ?
;
		cmp eax,Rsrc_IDM_Remplir						;; redimensionner ?
		jne GMFinRemplissageFondu					;; si c'est diffrent, aller GMFinRemplissageFondu
GMRemplissageFondu:
		xor Temoin_Remplissage_Fondu,1				;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Remplissage_Fondu,1	;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Remplissage_Fondu,1				;; le remplissage est activ ?
		je GMRemplissageFondu1						;; si c'est le cas, aller GMRemplissageFondu1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Remplir,MF_UNCHECKED	;; enlever le marqueur
		jmp GMRemplissageFondu2						;; aller GMRemplissageFondu2
GMRemplissageFondu1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Remplir,MF_CHECKED	;; positionner le marqueur
GMRemplissageFondu2:

	ret											;; retourner
GMFinRemplissageFondu:


;
; pastelliser les couleurs
;
		cmp eax,Rsrc_IDM_Pastelliser					;; pastelliser ?
		jne GMFinPastelliser						;; si c'est diffrent, aller GMFinPastelliser
GMPastelliser:
		xor Temoin_Pastelliser,1						;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Pastelliser,1		;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Pastelliser,1						;; les couleurs pastel sont actives ?
		je GMPastelliser1							;; si c'est le cas, aller GMPastelliser1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Pastelliser,MF_UNCHECKED	;; enlever le marqueur
		jmp GMPastelliser2							;; aller GMPastelliser2
GMPastelliser1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_Pastelliser,MF_CHECKED	;; positionner le marqueur
GMPastelliser2:

	ret											;; retourner
GMFinPastelliser:


;
; transformer en tons de gris
;
		cmp eax,Rsrc_IDM_TonsDeGris					;; tons de gris ?
		jne GMFinTonsDeGris							;; si c'est diffrent, aller GMFinTonsDeGris
GMTonsDeGris:
		xor Temoin_Tons_De_Gris,1					;; alterner le tmoin
		xor BYTE PTR Chaine_Nombre_Tons_De_Gris,1		;; alterner le bit de la chane
; mise  jour du menu concern
		cmp Temoin_Tons_De_Gris,1					;; les tons de gris sont activs ?
		je GMTonsDeGris1							;; si c'est le cas, aller GMTonsDeGris1
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_TonsDeGris,MF_UNCHECKED	;; enlever le marqueur
		jmp GMTonsDeGris2							;; aller GMTonsDeGris2
GMTonsDeGris1:
		invoke CheckMenuItem,Pointeur_Menu_Principal,Rsrc_IDM_TonsDeGris,MF_CHECKED	;; positionner le marqueur
GMTonsDeGris2:

	ret											;; retourner
GMFinTonsDeGris:

;
; quitter ?
;
		cmp eax,Rsrc_IDM_Quitter						;; charger un fichier ?
		jne GMFinQuitter							;; si c'est diffrent, aller GMFinQuitter
GMQuitter:
; faire rapparaitre le pointeur cran
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boite_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoiteDialogue,0
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
	ret											;; retourner
GMFinQuitter:


	ret											;; retourner
GMFinCommandes:

;
; ici, les messages concernant les touches prsses
;

; touche presse ?
		cmp eax,WM_KEYDOWN							;; touche presse ?
		jne GMFinTouchePressee						;; si ce n'est pas le cas, aller GMFinTouchePressee
		mov eax,WParam								;; placer le code de la touche dans eax

; Quitter ?
		cmp eax,VK_ESCAPE							;; Quitter ?
		je GMQuitter								;; si c'est le cas, aller GMQuitter
; F1 ? charger
		cmp eax,VK_F1								;; F1 ?
		je GMChargerFichier							;; si c'est le cas, aller GMChargerFichier
; F2 ? charger x2
		cmp eax,VK_F2								;; F2 ?
		je GMChargerFichierx2						;; si c'est le cas, aller GMChargerFichierx2
;; F3 ?
;		cmp eax,VK_F3								;; F3 ?
;		je										;; si c'est le cas, aller
; F4 ? sauvegarder
		cmp eax,VK_F4								;; F4 ?
		je GMSauvegarderFichier						;; si c'est le cas, aller GMSauvegarderFichier
;; F5 ?
;		cmp eax,VK_F5								;; F5 ?
;		je										;; si c'est le cas, aller
;; F6 ?
;		cmp eax,VK_F6								;; F6 ?
;		je										;; si c'est le cas, aller
;; F7 ?
;		cmp eax,VK_F7								;; F7 ?
;		je										;; si c'est le cas, aller
;; F8 ?
;		cmp eax,VK_F8								;; F8 ?
;		je										;; si c'est le cas, aller
;; F9 ?
;		cmp eax,VK_F9								;; F9 ?
;		je										;; si c'est le cas, aller
;; F10 ?
;		cmp eax,VK_F10								;; F10 ?
;		je										;; si c'est le cas, aller
;; F11 ?
;		cmp eax,VK_F11								;; F11 ?
;		je										;; si c'est le cas, aller
; F12 ?
		cmp eax,VK_F12								;; F12 ?
		je GMCapturerEcran							;; si c'est le cas, aller GMCapturerEcran
;; haut ?
;		cmp eax,VK_UP								;; touche haut ?
;		je										;; si c'est le cas, aller
;; bas ?
;		cmp eax,VK_DOWN							;; touche bas ?
;		je										;; si c'est le cas, aller
;; droite ?
;		cmp eax,VK_RIGHT							;; touche droite ?
;		je										;; si c'est le cas, aller
;; gauche ?
;		cmp eax,VK_LEFT							;; touche gauche ?
;		je										;; si c'est le cas, aller

; a ?
		cmp eax,VK_A								;; a ?
		je GMInverserAlphas							;; si c'est le cas, aller GMInverserAlphas
;; b ?
;		cmp eax,VK_B								;; b ?
;		je										;; si c'est le cas, aller
; c ? centrer
		cmp eax,VK_C								;; c ?
		je GMCentrerEcran							;; si c'est le cas, aller GMCentrerEcran
; d ? redimensionnement
		cmp eax,VK_D								;; d ?
		je GMRedimensionnerEcran						;; si c'est le cas, aller GMRedimensionnerEcran
; e ? redimensionnement
		cmp eax,VK_E								;; e ?
		je GMPastelliser							;; si c'est le cas, aller GMPastelliser
; f ?
		cmp eax,VK_F								;; f ?
		je GMFondreEcran							;; si c'est le cas, aller GMFondreEcran
; g ?
		cmp eax,VK_G								;; g ?
		je GMTonsDeGris							;; si c'est le cas, aller GMTonsDeGris
; h ?
		cmp eax,VK_H								;; h ?
		je GMBasculerHorizontalement					;; si c'est le cas, aller GMBasculerHorizontalement
; i?
		cmp eax,VK_I								;; i ?
		je GMInverserCouleurs						;; si c'est le cas, aller GMInverserCouleurs
; o ? affichage informations
		cmp eax,VK_O								;; o ?
		je GMAfficherInformations					;; si c'est le cas, aller GMAfficherInformations
; p ?
		cmp eax,VK_P								;; p ?
		je GMProportionner							;; si c'est le cas, aller GMProportionner
; r ?
		cmp eax,VK_R								;; r ?
		je GMRemplissageFondu						;; si c'est le cas, aller GMRemplissageFondu
;; s ?
;		cmp eax,VK_S								;; s ?
;		je										;; si c'est le cas, aller
;; t ?
;		cmp eax,VK_T								;; t ?
;		je										;; si c'est le cas, aller
;; u ?
;		cmp eax,VK_U								;; u ?
;		je										;; si c'est le cas, aller
; v ?
		cmp eax,VK_V								;; v ?
		je GMBasculerVerticalement					;; si c'est le cas, aller GMBasculerVerticalement
;; w ?
;		cmp eax,VK_W								;; w ?
;		je										;; si c'est le cas, aller
;; x ?
;		cmp eax,VK_X								;; x ?
;		je										;; si c'est le cas, aller
;; y ?
;		cmp eax,VK_Y								;; y ?
;		je										;; si c'est le cas, aller
;; z ?
;		cmp eax,VK_Z								;; z ?
;		je										;; si c'est le cas, aller

;
	ret											;; retourner
GMFinTouchePressee:

;;
;; ici, les messages concernant les touches relaches
;;
;
;; touche relache ?
;		cmp eax,WM_KEYUP
;
;		jne GMFinToucheRelachee
;		mov eax,WParam
;
;; gauche ?
;		cmp eax,VK_LEFT
;		jne GMPasToucheGaucheRelachee					;; sinon, aller GMPasToucheGaucheRelachee
;
;	ret											;; retourner
;;GMPasToucheGaucheRelachee:
;; droite ?
;		cmp eax,VK_RIGHT
;		jne GMPasToucheDroiteRelachee					;; sinon, aller GMPasToucheDroiteRelachee
;
;	ret											;; retourner
;;GMPasToucheDroiteRelachee:
;; haut ?
;		cmp eax,VK_UP
;		jne GMPasToucheHautRelachee					;; sinon, aller GMPasToucheHautRelachee
;
;	ret											;; retourner
;;GMPasToucheHautRelachee:
;; bas ?
;		cmp eax,VK_DOWN
;		jne GMPasToucheBasRelachee					;; sinon, aller GMPasToucheBasRelachee
;
;	ret											;; retourner
;;GMPasToucheBasRelachee:
;
;
;	ret											;; retourner
;;GMFinToucheRelachee:


;
; on finit avec le traitement par dfaut
;
		invoke DefWindowProc,HWndGM,Message,WParam,LParam
	ret
GestionnaireMessages ENDP


ALIGN 16
;
; gestionnaire des messages par boites de dialogue
;
GestionnaireMessagesBoiteDialogue PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)


		cmp eax,WM_COMMAND							;; un commande ?
		jne GMBDFinCommandes						;; si ce n'est pas le cas, aller GMBDFinCommandes
		mov eax,WParam								;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,Rsrc_IDC_Temps_Changer				;; Il est temps d'en changer est cliqu ?
		jne GMBDPasTempsChangerMicro					;; si ce n'est pas le cas, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndDlg,0					;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL					;; et poster le message de sortie
	ret											;; retourner
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,Rsrc_IDC_Hum_Oui						;; Hum... oui est cliqu ?
		jne GMBDPasHumOui							;; si ce n'est pas le cas, aller GMBDPasHumOui
		mov Temoin_Poursuite_Processus,0				;; sinon, stoper le processus en cours
		invoke EndDialog,HWndDlg,0					;; et fermer la boite de dialogue
	ret											;; retourner
GMBDPasHumOui:

; Ah a non !
		cmp eax,Rsrc_IDC_Ah_Ca_Non					;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon							;; si ce n'est pas le cas, aller GMBDPasAhCaNon
		invoke EndDialog,HWndDlg,0					;; sinon, fermer la boite de dialogue
	ret											;; retourner
GMBDPasAhCaNon:


;
; traitement par dfaut pour les boites de dialogue
;
GMBDFinCommandes:
		xor eax,eax								;; effacer eax (ce sera le traitement par dfaut des messages)
	ret											;; retourner
GestionnaireMessagesBoiteDialogue ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Processus principal -> les effets 2D de l'intro
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ProcessusPrincipal PROC


;
; ici, on alloue les blocs mmoires ncessaires
;

; ici, il y a (ou il y aura) un redimensionnement, on defini l'cran final
		mov eax,Largeur_Ecran_Final					;; ) allouer un espace mmoire pour notre tampon ecran final
		mov ebx,Hauteur_Ecran_Final					;; )
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call CreerEcran							;; )
; crer l'cran travail
		mov eax,Largeur_Ecran_Travail					;; ) allouer un espace mmoire pour notre tampon ecran travail
		mov ebx,Hauteur_Ecran_Travail					;; )
;		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Ecran_Travail			;; )
		call CreerEcran							;; )
; ici, on cr la table de redimensionnement proportionnelle
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;; ) dfinir la taille de redimensionnement
		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;; )
		mov ecx,Tampon_Ecran_Final._Largeur_Ecran_		;; )
		mov edx,Tampon_Ecran_Final._Hauteur_Ecran_		;; )
		call DefinirTaillesRedimensionnement			;; )
;		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;;	) dfinir la table de redimensionnement (la mmoire est alloue avec)
;		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;;	)
;		mov ecx,Tampon_Ecran_Final._Largeur_Ecran_		;;	)
;		mov edx,Tampon_Ecran_Final._Hauteur_Ecran_		;;	)
;		mov esi,OFFSET Instance_Memoire				;;	)
		mov edi,OFFSET Tampon_Table_Redimensionnement_Proportionnelle	;;	)
		call DefinirTableDeRedimensionnement_Turbo		;;	)
; ici, on cr la table de redimensionnement
;		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;;	) dfinir la table de redimensionnement (la mmoire est alloue avec)
;		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;;	)
		mov ecx,Tampon_Ecran_Final._Largeur_Ecran_		;;	)
		mov edx,Tampon_Ecran_Final._Hauteur_Ecran_		;;	)
;		mov esi,OFFSET Instance_Memoire				;;	)
		mov edi,OFFSET Tampon_Table_Redimensionnement	;;	)
		call DefinirTableDeRedimensionnement_Turbo		;;	)

; mettre a jour les chanes concernant les tailles, obtenir la chane pour la largeur
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_			;; ) transformer la largeur en chane
		mov esi,OFFSET Chaine_Valeur_Largeur_Ecran_Travail	;; )
		call ConvertirValeurEnChaineDecimale				;; )
; obtenir la chane pour la hauteur
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_			;; ) transformer la hauteur en chane
		mov esi,OFFSET Chaine_Valeur_Hauteur_Ecran_Travail	;; )
		call ConvertirValeurEnChaineDecimale				;; )
;; placer le tmoin de fin d'initialisation du processus
;		mov Temoin_Processus_Pret,1					;; positionner le tmoin processus prt


;
; dbut de la boucle qui sera le processus
;
DebutBoucleProcessus:

;
; avant tout, on regarde si on doit rcuprer les pixels d'une nouvelle image bmp
;
		cmp Temoin_Fichier_Bmp,1						;; un fichier bmp est charg ?
		jne EviterRecupererPixels					;; si ce n'est pas le cas, aller EviterRecupererPixels

		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;; ) sauvegarder la largeur et la hauteur de l'cran travail en cours
		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;; )
		mov Sauvegarde_Largeur,eax					;; )
		mov Sauvegarde_Hauteur,ebx					;; )

; purger la mmoire si c'est ncessaire
		cmp Temoin_Ecran_En_Memoire,0					;; le tmoin n'est pas positionn ?
		je EviterPurgerMemoire						;; si c'est le cas, aller EviterPurgerMemoire
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure dans esi
		mov edi,OFFSET Tampon_Donnees_Image			;; placer l'adresse de la structure dans edi
		call SupprimerBlocMemoire					;; supprimer le bloc prcdement cr
		mov Temoin_Ecran_En_Memoire,0					;; mettre  jour le tmoin
EviterPurgerMemoire:
		mov ebx,_Fichier_Information_Selection_.lpstrFile	;; placer l'adresse de la chane qui contient le nom du fichier
		mov ecx,OFFSET Pointeurs_Bitmap_Charge			;; placer la liste des pointeurs  dfinir dans ecx
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure dans esi
		mov edi,OFFSET Tampon_Donnees_Image			;; placer l'adresse de la structure dans edi
		call ChargerFichier_Bmp
		cmp eax,0									;; comparer eax  0
		jle EviterRecupererPixels					;; si c'est infrieur ou gal  0, aller EviterRecupererPixels
		mov Temoin_Ecran_En_Memoire,1					;; sinon, mettre  jour le tmoin

		mov ebx,(_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Informations_Bitmap_
; obtenir la largeur et la hauteur du DIB (Device Independant Bitmap)
		cmp (BITMAPINFOHEADER PTR [ebx]).biSize,SIZEOF BITMAPCOREHEADER	;; structure BITMAPCOREHEADER ?
		jne TraitementParBMI						;; si ce n'est pas le cas, aller TraitementParBMI
TraitementParBCH:
; ici, la largeur et la hauteur sont des WORDs (fichier constitu de triples octets)
		movzx eax,(BITMAPCOREHEADER PTR [ebx]).bcWidth	;; ) obtenir la largeur du bitmap
		mov Largeur_Bitmap_En_Pixels,eax				;; )
		movzx eax,(BITMAPCOREHEADER PTR [ebx]).bcHeight	;;	) obtenir la hauteur du bitmap
		mov Hauteur_Bitmap_En_Pixels,eax				;;	)
		jmp TaillesBitmapDefinies					;; aller TaillesBitmapDefinies
TraitementParBMI:
; ici, la largeur et la hauteur sont des DWORDs (fichier constitu de quadruples octets)
		mov eax,(BITMAPINFOHEADER PTR [ebx]).biWidth		;; ) obtenir la largeur du bitmap
		mov Largeur_Bitmap_En_Pixels,eax				;; )
		mov eax,(BITMAPINFOHEADER PTR [ebx]).biHeight	;;	) obtenir la hauteur du bitmap
		test eax,eax								;;	)
		jns EviterRendrePositif						;;	)
		neg eax									;;	)
EviterRendrePositif:
		mov Hauteur_Bitmap_En_Pixels,eax				;;	)
TaillesBitmapDefinies:

; premirement on s'assure que les valeurs de division ne sont pas gales  0
		mov eax,Largeur_Bitmap_En_Pixels				;; ) s'assurer que la largeur n'est pas gale  0
		test eax,eax								;; )
		jz EviterRecupererPixels						;; )
		mov ebx,Hauteur_Bitmap_En_Pixels				;;	) s'assurer que la hauteur n'est pas gale  0
		test ebx,ebx								;;	)
		jz EviterRecupererPixels						;;	)
; on va doubler les tailles (uniquement si c'est ncessaire...)
		cmp Temoin_Bmp_x2,1							;; le tmoin pour les crans doubls est positionn ?
		jne EviterDoublerTailles						;; si ce n'est pas le cas, aller EviterDoublerTailles
		shl eax,1									;; ) multiplier les tailles par 2
		shl ebx,1									;; )
EviterDoublerTailles:

; ici, on va tester si c'est ncessaire de redfinir le bloc cran et les tables de redimensionnement
		cmp eax,Sauvegarde_Largeur					;; ) changement en largeur ?
		jne TaillesModifiees						;; )
		cmp ebx,Sauvegarde_Hauteur					;;	) changement en hauteur ?
		jne TaillesModifiees						;;	)
		jmp EviterRedefinirBlocs						;; sinon, aller EviterRedefinirBlocs
TaillesModifiees:

; sinon, c'est qu'il y a des pixels  rcuprer, on commence par supprimer l'ancien cran travail
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Ecran_Travail			;; )
		call SupprimerEcran							;; )
; supprimer l'ancienne table de redimensionnement proportionnelle
;		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure instance mmoire dans esi
		mov edi,OFFSET Tampon_Table_Redimensionnement_Proportionnelle	;; ) supprimer l'espace mmoire pour la table de redimensionnement
		call SupprimerTableDeRedimensionnement			;; )
; supprimer l'ancienne table de redimensionnement
;		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure instance mmoire dans esi
		mov edi,OFFSET Tampon_Table_Redimensionnement	;; ) supprimer l'espace mmoire pour la table de redimensionnement
		call SupprimerTableDeRedimensionnement			;; )
; crer le nouvel cran travail
;		mov eax,Largeur_Bitmap_En_Pixels				;;	) fait prcdement
;		mov ebx,Hauteur_Bitmap_En_Pixels				;;	)
;		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Ecran_Travail			;; )
		call CreerEcran							;; )
; ici, on cr la table de redimensionnement proportionnelle
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;; ) dfinir la taille de redimensionnement
		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;; )
		mov ecx,Tampon_Ecran_Final._Largeur_Ecran_		;; )
		mov edx,Tampon_Ecran_Final._Hauteur_Ecran_		;; )
		call DefinirTaillesRedimensionnement			;; )
;		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;;	) dfinir la table de redimensionnement (la mmoire est alloue avec)
;		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;;	)
;		mov ecx,Tampon_Ecran_Final._Largeur_Ecran_		;;	)
;		mov edx,Tampon_Ecran_Final._Hauteur_Ecran_		;;	)
;		mov esi,OFFSET Instance_Memoire				;;	)
		mov edi,OFFSET Tampon_Table_Redimensionnement_Proportionnelle	;;	)
		call DefinirTableDeRedimensionnement_Turbo		;;	)
; ici, on cr la table de redimensionnement
;		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;;	) dfinir la table de redimensionnement (la mmoire est alloue avec)
;		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;;	)
		mov ecx,Tampon_Ecran_Final._Largeur_Ecran_		;;	)
		mov edx,Tampon_Ecran_Final._Hauteur_Ecran_		;;	)
;		mov esi,OFFSET Instance_Memoire				;;	)
		mov edi,OFFSET Tampon_Table_Redimensionnement	;;	)
		call DefinirTableDeRedimensionnement_Turbo		;;	)

EviterRedefinirBlocs:
; remplir la structure BITMAPINFOHEADER de sauvegarde (elle va aussi servir pour rcuprer les pixels)
		mov eax,Largeur_Bitmap_En_Pixels				;; )
		mov ebx,Hauteur_Bitmap_En_Pixels				;; )
		mov Sauvegarder_Entete_Informations_Bitmap.biSize,SIZEOF BITMAPINFOHEADER	;; placer la taiile de la structure BITMAPINFOHEADER
		mov Sauvegarder_Entete_Informations_Bitmap.biWidth,eax	;; placer la largeur
		neg ebx											;;	) placer la hauteur
		mov Sauvegarder_Entete_Informations_Bitmap.biHeight,ebx	;;	)
		mov Sauvegarder_Entete_Informations_Bitmap.biPlanes,1		;; nombre de plans (doit tre gal  1)
		mov Sauvegarder_Entete_Informations_Bitmap.biBitCount,32	;; placer le nombre de bits par pixels
		mov Sauvegarder_Entete_Informations_Bitmap.biCompression,BI_RGB	;; placer le format non comprss
		mov Sauvegarder_Entete_Informations_Bitmap.biSizeImage,0		;; ) s'assurer que c'est vide
		mov Sauvegarder_Entete_Informations_Bitmap.biXPelsPerMeter,0	;; )
		mov Sauvegarder_Entete_Informations_Bitmap.biYPelsPerMeter,0	;; )
		mov Sauvegarder_Entete_Informations_Bitmap.biClrUsed,0		;; placer le nombre de couleurs
		mov Sauvegarder_Entete_Informations_Bitmap.biClrImportant,0	;; placer le nombre des couleurs importantes

; rcuprer les pixels du fichier charg en mmoire (ouaip, je sais... les quelques lignes qui suivent ce n'est pas
; vraiment de l'assembleur, mais avec le systme utilis par windows on a pas trop le choix...)
		invoke CreateDC,ADDR Chaine_Display,NULL,NULL,NULL
		mov Pointeur_DC_Temporaire,eax				;; sauvegarder le pointeur obtenu
		invoke CreateCompatibleDC,Pointeur_DC_Temporaire
		mov Pointeur_DC_Compatible,eax				;; sauvegarder le pointeur obtenu
		invoke CreateDIBSection,Pointeur_DC_Compatible,ADDR Sauvegarder_Entete_Informations_Bitmap,DIB_RGB_COLORS,ADDR Pointeur_Pixels_Recuperes,NULL,NULL
		mov Pointeur_Nouveau_Dib,eax
		invoke SelectObject,Pointeur_DC_Compatible,Pointeur_Nouveau_Dib
		invoke SetDIBitsToDevice,Pointeur_DC_Compatible,NULL,NULL,Largeur_Bitmap_En_Pixels,Hauteur_Bitmap_En_Pixels,NULL,NULL,NULL,Hauteur_Bitmap_En_Pixels,Pointeurs_Bitmap_Charge._Pointeur_Pixels_Du_Bitmap_,Pointeurs_Bitmap_Charge._Pointeur_Informations_Bitmap_,DIB_RGB_COLORS

; on va recopier les pixels (en doublant la taille si c'est ncessaire...)
		cmp Temoin_Bmp_x2,1							;; le tmoin pour les crans doubls est positionn ?
		jne EviterDoublerPixels						;; si ce n'est pas le cas, aller EviterDoublerPixels
; sinon on double les pixels, recopier les pixels dans le dernier quart
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; placer la taille de l'cran dans eax
		shr eax,2									;; diviser la taille par 4
		mov esi,Pointeur_Pixels_Recuperes				;; placer l'adresse source
		mov edi,Tampon_Ecran_Travail._Pointeur_			;; placer l'adresse de destination
		add edi,eax								;; ) ajouter les 3/4  l'adresse de destination
		add edi,eax								;; )
		add edi,eax								;; )
		call Mmx_CopierBlocMemoire					;; copier les pixels rcuprs
; et multiplier la taille par 2 avec un remplissage par fondu
		mov edi,OFFSET Tampon_Ecran_Travail			;; l'adresse de la structure
		call Mmx_AgrandirX2_RemplissageFondu_Sur_Place	;; et multilier la taille
; maintenant que les pixels ont t rcuprs, remettre les bonnes tailles dans la structure (essentiel pour la sauvegarde)
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;; )
		mov ebx,Tampon_Ecran_Travail._Hauteur_Ecran_		;; )
		mov Sauvegarder_Entete_Informations_Bitmap.biWidth,eax	;; placer la largeur
		neg ebx											;;	) placer la hauteur
		mov Sauvegarder_Entete_Informations_Bitmap.biHeight,ebx	;;	)
		jmp PixelsRecopies							;; aller PixelsRecopies
EviterDoublerPixels:
; ici, recopier simplement les pixels
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; ) copier le bloc
		mov esi,Pointeur_Pixels_Recuperes				;; )
		mov edi,Tampon_Ecran_Travail._Pointeur_			;; )
		call Mmx_CopierBlocMemoire					;; )
PixelsRecopies:

; supprimer les salets windows dont on n'a plus besoin (c'est pas trop tt...)
		invoke DeleteObject,Pointeur_Nouveau_Dib		;; ) supprimer les pointeurs/devices devenus inutiles
		invoke DeleteDC,Pointeur_DC_Compatible			;; ) (ne peut tre fait tant qu'on a besoin de Pointeur_Pixels_Recuperes)
		invoke DeleteDC,Pointeur_DC_Temporaire			;; )
; mettre  jour les chane de caractres qui concerne la largeur et la hauteur, obtenir la chane pour la largeur
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_			;; ) transformer la largeur en chane
		mov esi,OFFSET Chaine_Valeur_Largeur_Ecran_Travail	;; )
		call ConvertirValeurEnChaineDecimale				;; )
; obtenir la chane pour la hauteur
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_			;; ) transformer la hauteur en chane
		mov esi,OFFSET Chaine_Valeur_Hauteur_Ecran_Travail	;; )
		call ConvertirValeurEnChaineDecimale				;; )
; fixer les tmoins du travail effectu...
		mov Temoin_Fichier_Bmp,0						;; enlever le tmoin de fichier charg
;		mov Temoin_Processus_Pret,0					;; enlever le tmoin qui n'est plus ncessaire
EviterRecupererPixels:


;
; effacer l'cran
;
		mov edi,OFFSET Tampon_Ecran_Final				;;	) effacer l'cran final pour viter de voir apparaitre ce qui tait  l'cran prcdement
		call Mmx_EffacerEcran						;;	)


;
; redimensionner l'cran (si l'option est active)
;
		mov esi,OFFSET Tampon_Ecran_Travail			;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		cmp Temoin_Redimensionnement,1				;; le tmoin est positionn
		jne EviterRedimensionnement					;; si ce n'est pas le cas, aller EviterRedimensionnement
		cmp Temoin_Dimensions_Proportionnelles,1		;; le tmoin est positionn
		jne EviterReproportionner					;; si ce n'est pas le cas, aller EviterReproportionner
		mov eax,OFFSET Tampon_Table_Redimensionnement_Proportionnelle	;; redimensionner proportionnellement
		jmp ProportionsDefinies						;; aller ProportionsDefinies
EviterReproportionner:
		mov eax,OFFSET Tampon_Table_Redimensionnement	;; ) redimensionnement vers l'cran final
ProportionsDefinies:

		cmp Temoin_Centrage,1						;; )
		jne RedimensionnementSansCentrage				;; )
; ici, redimensionnement avec centrage
		mov ebx,eax								;; sauvegarder la table utilise
; on va voir si il y a un dcalage en largeur
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran de destination dans ecx
		sub eax,(_Bloc_Memoire_Ecran_ PTR [ebx])._Largeur_Ecran_X4_	;; soustraire la largeur de l'cran source
		sar eax,1									;; diviser la largeur obtenue par 2 (signe)
		and eax,0FFFFFFFCh							;; ici, c'est pour tre sr que les couleurs soient bien aligns par dwords (si la largeur source est impaire)
		test eax,eax								;; fixer les flags de eax
		jnz AppliquerDecalage						;; si eax est diffrent de 0, aller AppliquerDecalage
; sinon, c'est qu'il y a un dcalage en hauteur...
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; placer la hauteur de l'cran de destination dans ebx
		sub eax,(_Bloc_Memoire_Ecran_ PTR [ebx])._Hauteur_Ecran_	;; soustraire la hauteur de l'cran source
		sar eax,1									;; diviser la hauteur obtenue par 2 (signe)
		mul (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; multiplier la hauteur par la largeur * 4

AppliquerDecalage:
		mov Decalage_Centrage,eax					;; sauvegarder le dcalage
		add (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax	;; ajouter le dcalage au pointeur
		mov eax,ebx								;; restaurer la table
		mov esi,OFFSET Tampon_Ecran_Travail			;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call Redimensionner							;; )
		mov eax,Decalage_Centrage					;; lire le dcalage
		sub (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax	;; enlever le dcalage au pointeur
		jmp EcranTransfere							;; aller EcranTransfere
RedimensionnementSansCentrage:
		mov esi,OFFSET Tampon_Ecran_Travail			;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call Redimensionner							;; )
		jmp EcranTransfere							;; aller EcranTransfere
EviterRedimensionnement:
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) copier vers l'cran final (en centrant si ncessaire)
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		cmp Temoin_Centrage,1						;; )
		je AvecCentrage							;; )
		call Mmx_CopierEcran						;; )
		jmp EcranTransfere							;; )
AvecCentrage:
		call Mmx_CopierEcranCentre					;; )
EcranTransfere:


;
; fondu de l'cran (si l'option est active)
;
		cmp Temoin_Fondu_Ecran,1						;; le tmoin est positionn ?
		jne EviterFonduEcran						;; si ce n'est pas le cas, aller EviterFonduEcran
		mov eax,Tampon_Ecran_Final._Largeur_Ecran_		;; ) fondre l'cran (hormis pour les pixels du pourtour)
		mov ebx,Tampon_Ecran_Final._Hauteur_Ecran_		;; )
		sub eax,2									;; )
		sub ebx,2									;; )
		mov ecx,1									;; )
		mov edx,1									;; )
		mov esi,OFFSET Tampon_Ecran_Final				;; )
		call Mmx_EffetFonduPartielStatique				;; )
EviterFonduEcran:


;
; remplissage par fondu (si l'option est active, on lit 1/4 des pixels, et on recalcule les autres en pratiquant un fondu...)
;
		cmp Temoin_Remplissage_Fondu,1				;; le tmoin est positionn ?
		jne EviterRemplissageFondu					;; si ce n'est pas le cas, aller EviterRemplissageFondu
		mov edi,OFFSET Tampon_Ecran_Final				;; ) recalculer les pixels "de remplisage" par un fondu
		call Mmx_RemplissageFondu					;; )
EviterRemplissageFondu:


;
; pastelliser les couleurs pour obtenir des couleurs proches du gris
;
		cmp Temoin_Pastelliser,1						;; le tmoin est positionn ?
		jne EviterPastelliser						;; si ce n'est pas le cas, aller EviterPastelliser
		mov esi,OFFSET Tampon_Ecran_Final				;; ) transformer les couleurs
		call Mmx_PastelliserEcran					;; )
EviterPastelliser:


;
; altrer les couleurs pour obtenir les tons de gris correspondant aux couleurs
;
		cmp Temoin_Tons_De_Gris,1					;; le tmoin est positionn ?
		jne EviterTonsDeGris						;; si ce n'est pas le cas, aller EviterTonsDeGris
		mov esi,OFFSET Tampon_Ecran_Final				;; ) transformer les couleurs
		call Mmx_GriserEcran						;; )
EviterTonsDeGris:


;
; afficher les informations (si l'option est active)
;
		cmp Temoin_Affichage_Informations,0			;; on compare Temoin_Affichage_Informations  0
		je FinAffichageChaines						;; si c'est gal (rien  afficher), aller FinAffichageChaines
; ici on dfini la couleur par dfaut des textes  afficher dans l'cran (fait hors boucle, pour une question de vitesse)
		mov eax,Couleur_Jaune						;; ) dfinir les couleurs police + fond
		mov ebx,Couleur_Noire						;; )
		call DefinirCouleursChaine					;; )

; le nombre d'images par seconde
		xor eax,eax								;; position X (en pixels)
		xor ebx,ebx								;; position Y (en pixels)
		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Images_Seconde			;; adresse de la chane  afficher
		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
;		call AfficherChaineSansFond					;; ) afficher cette chane  la position spcifie
;		call AfficherChaine							;; )
		call Mmx_AfficherChaine_Alpha_Turbo			;; )

; le nom du fichier
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Fichier					;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; largeur
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Largeur_Ecran_Travail		;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; hauteur
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Hauteur_Ecran_Travail		;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; ajouter une ligne de sparation
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y

; chargement fichier
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Chargement				;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; chargement fichier x2
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Chargement_x2			;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; sauvegarde fichier
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)

		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Sauvegarde				;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; capture cran
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Capture					;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; ajouter une ligne de sparation
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y

; centrage
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Centrage				;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; redimensionnement
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Redimensionnement			;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; redimensionnement proportionnel
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Dimensions_Proportionnelles	;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; affichage informations
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Affichage_Informations		;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; ajouter une ligne de sparation
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y

; fondu ecran
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Fondu_Ecran				;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; remplissage fondu
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Remplissage_Fondu			;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; pastelliser
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Pastelliser				;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; tons de gris
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,OFFSET Chaine_Tons_De_Gris				;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie

; ajouter une ligne de sparation
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y

; ligne de commande
;		xor eax,eax								;; position X (en pixels)
;		xor ebx,ebx								;; position Y (en pixels)
		add ebx,DWORD PTR [edx]						;; ajouter la taille de la police  la position Y
;		mov edx,OFFSET Police_LucidaCalligraphy_18_G		;; adresse de la police utilise
		mov esi,_Fichier_Information_Selection_.lpstrFile	;; adresse de la chane  afficher
;		mov edi,OFFSET Tampon_Ecran_Final				;; placer l'adresse du Tampon_Ecran_Final dans edi
		call Mmx_AfficherChaine_Alpha_Turbo			;; afficher cette chane  la position spcifie
FinAffichageChaines:


;
; enfin, envoyer le rsultat  l'affichage (l encore, oblig de passer par une api windows...)
;
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		invoke SetDIBitsToDevice,Pointeur_DC_Ecran,NULL,NULL,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,NULL,NULL,NULL,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,ADDR Entete_Informations_Bitmap,DIB_RGB_COLORS


;
; fin de la boucle
;
		inc Compteur_Des_images						;; une image de plus  t faite, on incrmente donc notre compteur
		cmp Temoin_Poursuite_Processus,0				;; comparer Temoin_Poursuite_Processus  0
		jne DebutBoucleProcessus						;; tant que Temoin_Poursuite_Processus est diffrent de 0, aller DebutBoucleProcessus


;
; supprimer l'espace rserv pour les donnes de l'cran (si existant)
;
		cmp Temoin_Ecran_En_Memoire,0					;; le tmoin n'est pas positionn ?
		je EviterViderMemoire						;; si c'est le cas, aller EviterViderMemoire
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure dans esi
		mov edi,OFFSET Tampon_Donnees_Image			;; placer l'adresse de la structure dans edi
		call SupprimerBlocMemoire					;; supprimer le bloc prcdement cr
EviterViderMemoire:


;
; librer les espaces mmoire
;
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure instance mmoire dans esi
		mov edi,OFFSET Tampon_Table_Redimensionnement	;; ) supprimer l'espace mmoire pour la table de redimensionnement
		call SupprimerTableDeRedimensionnement			;; )
		mov edi,OFFSET Tampon_Table_Redimensionnement_Proportionnelle	;; ) supprimer l'espace mmoire pour la table de redimensionnement proportionnelle
		call SupprimerTableDeRedimensionnement			;; )
		mov edi,OFFSET Tampon_Ecran_Travail			;; ) supprimer l'espace mmoire pour l'ecran travail
		call SupprimerEcran							;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; ) supprimer l'espace mmoire pour l'ecran final
		call SupprimerEcran							;; )
		call SupprimerInstanceMemoire					;; ) supprimer l'intance mmoire


;
; terminer le processus
;
		mov Temoin_Poursuite_Processus,-1				;; processus dfinitivement clos
		invoke SendMessage,Principal_Gestionnaire_Des_Messages,WM_CLOSE,NULL,NULL
;	ret											;; ATTENTION !!! a ne pas activer pour un processus
ProcessusPrincipal ENDP


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ALIGN 16
Programme:
;		invoke GetCurrentProcess						;; ) fixer la priorit de notre application  haute
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS	;; )
		invoke GetCommandLine						;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commandes,eax				;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_Commandes
		invoke GetModuleHandle,NULL					;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax					;; ) et sauvegarder le pointeur obtenu dans Instance_Application
		mov Informations_Fenetre.hInstance,eax			;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL					;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boite_Dialogue,eax				;;	) et sauvegarder le pointeur obtenu dans Instance_Boite_Dialogue
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
		mov esi,OFFSET Instance_Memoire				;; ) obtenir une instance mmoire
		call CreerInstanceMemoire					;; )
		call InitialiserNombresAleatoires				;; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.


;
; dfinir la taille de notre cran  celle de l'cran OS
;
		invoke GetSystemMetrics,SM_CXSCREEN			;; obtenir la taille x de l'ecran os (en pixels)
		mov Largeur_Ecran_Final,eax					;; sauvegarder la largeur de notre ecran final
;		shr eax,1									;; diviser la largeur par 2
;		mov Largeur_Ecran_Final_Moitiee,eax			;; sauvegarder la largeur/2 de notre ecran final
		invoke GetSystemMetrics,SM_CYSCREEN			;; obtenir la taille y de l'ecran os (toujours en pixels)
		mov Hauteur_Ecran_Final,eax					;; sauvegarder la hauteur de notre cran final
;		shr eax,1									;; diviser la hauteur par 2
;		mov Hauteur_Ecran_Final_Moitiee,eax			;; sauvegarder la hauteur/2 de notre ecran final


;
; remplir la structure BITMAPINFO avec les variables requises
;
		mov Entete_Informations_Bitmap.biSize,SIZEOF BITMAPINFOHEADER	;; taille de la structure BITMAPINFOHEADER
		mov eax,Largeur_Ecran_Final					;; ) la largeur
		mov Entete_Informations_Bitmap.biWidth,eax		;; )
		mov eax,Hauteur_Ecran_Final					;;	) la hauteur (ngative, pour que la premire ligne soit celle du haut, et pas celle du bas)
		neg eax									;;	)
		mov Entete_Informations_Bitmap.biHeight,eax		;;	)
		mov Entete_Informations_Bitmap.biPlanes,1		;;
		mov Entete_Informations_Bitmap.biBitCount,32		;; pour des couleurs 32 bits
		mov Entete_Informations_Bitmap.biCompression,BI_RGB	;; (BI_RGB=pas de compression)
		mov Entete_Informations_Bitmap.biSizeImage,0		;; ) s'assurer que c'est vide
		mov Entete_Informations_Bitmap.biXPelsPerMeter,0	;; )
		mov Entete_Informations_Bitmap.biYPelsPerMeter,0	;; )
		mov Entete_Informations_Bitmap.biClrUsed,0		;; placer le nombre de couleurs
		mov Entete_Informations_Bitmap.biClrImportant,0	;; placer le nombre des couleurs importantes


;
; remplir la structure WNDCLASSEX avec les variables requises, et cration de l'cran
;
		invoke LoadIcon,Instance_Application,Rsrc_IDI_Icone_32	;; pointeur sur l'icone (500 = ID de l'icne)
		mov Informations_Fenetre.hIcon,eax				;; sauver le pointeur
		invoke LoadCursor,NULL,IDC_ARROW
		mov Informations_Fenetre.hCursor,eax
; remplir le reste de la structure WNDCLASSEX avec les variables requises
		mov Informations_Fenetre.cbSize,SIZEOF WNDCLASSEX
		mov Informations_Fenetre.style,CS_BYTEALIGNCLIENT or CS_NOCLOSE
		mov Informations_Fenetre.lpfnWndProc,OFFSET GestionnaireMessages
		mov Informations_Fenetre.cbClsExtra,NULL
		mov Informations_Fenetre.cbWndExtra,NULL
		mov Informations_Fenetre.hbrBackground,COLOR_WINDOWTEXT	;; COLOR_BACKGROUND
		mov Informations_Fenetre.lpszMenuName,NULL
		mov Informations_Fenetre.lpszClassName,OFFSET Chaine_Type_Fenetre
		mov Informations_Fenetre.hIconSm,0
		invoke RegisterClassEx,ADDR Informations_Fenetre
; maintenant que tous les parametres sont dfinis, on cr l'cran
		invoke CreateWindowEx,WS_EX_LEFT,ADDR Chaine_Type_Fenetre,ADDR Chaine_Titre_Fenetre,WS_POPUP,NULL,NULL,Largeur_Ecran_Final,Hauteur_Ecran_Final,NULL,NULL,Instance_Application,NULL
		mov Pointeur_Fenetre,eax


;
; ici, on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call DefinirAptitudesDuProcesseur
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
		mov eax,Temoins_Aptitudes_Du_MicroProcesseur		;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b						;; cpuid
;		mov edx,000000000011b						;; cpuid + fpu
;		mov edx,000000010011b						;; cpuid + fpu + cmov
;		mov edx,000001010011b						;; cpuid + fpu + cmov + mmx
		mov edx,000101010011b						;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b						;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b						;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx								;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx								;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant					;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boite_Dialogue,Rsrc_IDD_Insuffisant,0,ADDR GestionnaireMessagesBoiteDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,Vide,Vide,Vide	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,Pointeur_Fenetre,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL								;; comparer eax  zro
		je MicroprocesseurInsuffisant					;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS	;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS	;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessages au moment voulu)
		jmp MicroprocesseurBoucleMessages				;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon, le minimum requis est prsent, alors on cr un pointeur pour le device context
;

;
; on dfini le rpertoire en cours comme tant celui des captures
;
		call DefinirRepertoireCapture					;; on rcupre les informations


;
; ici, on va voir si une commande  t dfinie
;
		mov _Fichier_Information_Selection_.lpstrFile,OFFSET _Fichier_Chaine_Chemin_Temporaire_	;; impratif, pour que le pointeur soit dfini
; ici, on va chercher l'emplacement de la 2me commande (la premire tant l'application elle mme...)
		xor eax,eax								;; commencer ds le dpart
		mov esi,OFFSET Chaine_Separation_Ligne_Commande	;; placer l'adresse de la chane  trouver
		mov edi,Pointeur_Ligne_Commandes				;; placer l'adresse de la chane  scanner
		call ChercherChaineAscii_Ascendante			;; chercher l'occurence de la sparation des arguments d'une ligne de commande
		test eax,eax								;; fixer les flags de eax
		js PasDeCommandes							;; si c'est sign (pas d'arguments trouv), aller PasDeCommandes
; sinon, ici il va falloir tester s'il faut charger un fichier
		mov esi,Pointeur_Ligne_Commandes				;; placer l'adresse de dpart de la ligne de commande
		add esi,(SIZEOF Chaine_Separation_Ligne_Commande)-1	;; ajouter la taille de la chane de sparation des arguments
		add esi,eax								;; ajouter la position trouve
		mov edi,_Fichier_Information_Selection_.lpstrFile	;; placer l'adresse de destination de la chaine dans edi
		call Mmx_CopierChaineAscii					;; recopier l'argument dans le chemin de la structure
; ici, on s'assure qu'il n'y aura que la 2me commande
		xor eax,eax								;; ) chercher le guillemet de clture de l'argument
		mov esi,OFFSET Chaine_Fin_Commande				;; )
		mov edi,_Fichier_Information_Selection_.lpstrFile	;; )
		call ChercherChaineAscii_Ascendante			;; )
		add eax,_Fichier_Information_Selection_.lpstrFile	;; ajouter l'adresse de dpart  la position trouve
		mov BYTE PTR [eax],0						;; remplacer le guillemet par un zro de fin de chane
		mov Pointeur_Temporaire,eax					;; sauvegarder l'adresse de fin de chane
; ici, on s'assure que c'est bien un fichier
		sub eax,_Fichier_Information_Selection_.lpstrFile	;; ) chercher la barre de sparation chemin\fichier
		mov esi,OFFSET Chaine_Separation_Fichier		;; )
		mov edi,_Fichier_Information_Selection_.lpstrFile	;; )
		call ChercherChaineAscii_Descendante			;; )
; "\" n'as pas t trouv ?
		test eax,eax								;;	) ce n'est donc pas un fichier, du coup on sort
		js PasDeCommandes							;;	)
; ici, c'est un fichier, on recopie le nom du fichier dans la structure
		mov esi,_Fichier_Information_Selection_.lpstrFile	;; ) on recopie le nom du fichier dans la structure
		add esi,(SIZEOF Chaine_Separation_Fichier)-1		;; )
		add esi,eax								;; )
		mov edi,OFFSET Chaine_Nom_Fichier				;; )
		call Mmx_CopierChaineAscii					;; )
; ici, on teste si c'est bien un fichier bmp
		mov esi,Pointeur_Temporaire					;; lire l'adresse de fin de chane
		sub esi,4									;; enlever 4 (.bmp)  esi
		mov edi,OFFSET Chaine_Extension_Bmp			;; placer l'adresse de l'extension "crypted" dans edi
		call ComparerChainesAscii_NonSensibleCasse		;; comparer les chanes sans tenir compte de la casse
; eax = -1 si les chanes sont semblables, sinon eax contient la position (l'octet du bloc) o se situe la premire diffrence
		test eax,eax								;; fixer les flags de eax
		jns PasDeCommandes							;; si ce n'est pas sign (extension pas trouve), aller PasDeCommandes
; ici il y a bien un fichier bmp  charger... alors on va positionner le tmoin...
		mov Temoin_Commandes,1						;; positionner le tmoin de commandes
PasDeCommandes:


;
; on cr un pointeur pour le device context
;
		invoke GetDC,Pointeur_Fenetre					;; obtenir un dc
		mov Pointeur_DC_Ecran,eax					;; sauvegarder le pointeur


;
; crer le popup menu
;
		invoke LoadMenu,Instance_Application,Rsrc_IDM_MenuPrincipal	;; charger l'adresse de la resource menu
		invoke GetSubMenu,eax,0						;; obtenir le pointeur du premier (0) sous-menu (pour avoir un popup menu)
		mov Pointeur_Menu_Principal,eax				;; et sauver le pointeur obtenu dans Pointeur_Menu_Principal


;
; dfinir et lancer le processus principal
;
		invoke CreateThread,NULL,Taille_Pile_Processus_Principal*1024,ADDR ProcessusPrincipal,Pointeur_Fenetre,NULL,ADDR Pointeur_Processus_Principal
		mov Pointeur_Processus_Principal,eax			;; sauvegarder le pointeur obtenu
		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_NORMAL	;; laisser la priorit du processus  la normale THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		mov Temoin_Poursuite_Processus,1				;; le processus est maintenant actif


		invoke ShowWindow,Pointeur_Fenetre,SW_SHOWNORMAL
		invoke UpdateWindow,Pointeur_Fenetre
		invoke SetTimer,Pointeur_Fenetre,1,1000,OFFSET EvaluationTemps


;
; boucle a effectuer tant que le message PostQuitMessage n'a pas t reu
;
BoucleMessages:
		invoke GetMessage,ADDR Informations_Messages_OS,Pointeur_Fenetre,NULL,NULL
		cmp eax,NULL
		je FinBoucleMessages
		invoke TranslateMessage,ADDR Informations_Messages_OS
		invoke DispatchMessage,ADDR Informations_Messages_OS
		jmp BoucleMessages
FinBoucleMessages:


;
; par ici la sortie...
;
		invoke KillTimer,Pointeur_Fenetre,1			;; terminer la procdure priodique
;		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_NORMAL	;; baisser la priorit du processus... THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		invoke TerminateThread,Pointeur_Processus_Principal,0	;; terminer le processus
		invoke DestroyMenu,Pointeur_Menu_Principal		;; supprimer le popup menu
		invoke DeleteDC,Pointeur_DC_Ecran				;; supprimer le device context
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
MicroprocesseurInsuffisant:
;		invoke GetCurrentProcess						;;	) remettre la priorit du programme  la normale
;		invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS	;;	)
		invoke ExitProcess,Informations_Messages_OS.wParam	;; sortie de l'application
;
; fin du programme
;
END Programme


