;
; les procdures
;
.DATA
ALIGN 16
;
; ici, ce sont les tmoins concernant les informations du microprocesseur
;
Temoins_Aptitudes_Du_MicroProcesseur	DWORD ?
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
; bit 12 =
.CODE
ALIGN 16
;
; obtenir des informations sur le microprocesseur qui utilise le programme
;
; Rceptionne :
; rien
;
; Retourne :
; la variable Temoins_Aptitudes_Du_MicroProcesseur est dfinie avec les bits positionns
;
; Syntaxe : DefinirAptitudesDuProcesseur
;
DefinirAptitudesDuProcesseur PROC
		pushad									;; empiler tous les registres

		mov Temoins_Aptitudes_Du_MicroProcesseur,0		;; mise  0 de la variable
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd									;; ) copier les flags+flags etendus dans eax et edx
		pop eax									;; )
		mov edx,eax								;; )
		xor eax,200000h							;; inverser le flag ID
		push eax									;; ) et recopier le rsultat dans les flags
		popfd									;; )
		pushfd									;;	) puis on recopie  nouveau les flags dans eax
		pop eax									;;	)
		cmp eax,edx								;; comparer le rsultat  notre prcdente sauvegarde
		je PasSupportCpuid							;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller PasSupportCpuid
		mov Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000001b	;; positionner le bit correspondant dans notre variable

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0									;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;												;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1									;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
												;; (eax contient le type, le model,la famille,...)
												;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0									;; tester le bit 0
		jnc PasSupportFpu							;; si le flag carry n'est pas positionn, aller PasSupportFpu
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000010b	;; positionner le bit correspondant dans notre variable
PasSupportFpu:
; l'instruction rdtsc est disponible ?
		bt edx,4									;; tester le bit 4
		jnc PasSupportRdtsc							;; si le flag carry n'est pas positionn, aller PasSupportRdtsc
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000100b	;; positionner le bit correspondant dans notre variable
PasSupportRdtsc:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8									;; tester le bit 8
		jnc PasSupportCmpXchg8b						;; si le flag carry n'est pas positionn, aller PasSupportCmpXchg8b
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000001000b	;; positionner le bit correspondant dans notre variable
PasSupportCmpXchg8b:
; les instructions cmov sont disponibles ?
		bt edx,15									;; tester le bit 15
		jnc PasSupportCmov							;; si le flag carry n'est pas positionn, aller PasSupportCmov
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000010000b	;; positionner le bit correspondant dans notre variable
PasSupportCmov:
; les instructions clfsh sont disponibles ?
		bt edx,19									;; tester le bit 19
		jnc PasSupportClfsh							;; si le flag carry n'est pas positionn, aller PasSupportClfsh
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000100000b	;; positionner le bit correspondant dans notre variable
PasSupportClfsh:
; les instructions mmx sont disponibles ?
		bt edx,23									;; tester le bit 23
		jnc PasSupportMmx							;; si le flag carry n'est pas positionn, aller PasSupportMmx
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000001000000b	;; positionner le bit correspondant dans notre variable
PasSupportMmx:
; les instructions fxsr sont disponibles ?
		bt edx,24									;; tester le bit 24
		jnc PasSupportFxsr							;; si le flag carry n'est pas positionn, aller PasSupportFxsr
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000010000000b	;; positionner le bit correspondant dans notre variable
PasSupportFxsr:
; les instructions sse sont disponibles ?
		bt edx,25									;; tester le bit 25
		jnc PasSupportSse							;; si le flag carry n'est pas positionn, aller PasSupportSse
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000100000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse:
; les instructions sse2 sont disponibles ?
		bt edx,26									;; tester le bit 26
		jnc PasSupportSse2							;; si le flag carry n'est pas positionn, aller PasSupportSse2
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000001000000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse2:
; les instructions htt sont disponibles ?
		bt edx,28									;; tester le bit 28
		jnc PasSupportHtt							;; si le flag carry n'est pas positionn, aller PasSupportHtt
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000010000000000b	;; positionner le bit correspondant dans notre variable
PasSupportHtt:
; les instructions sse3 sont disponibles ?
		bt ecx,0									;; tester le bit 0
		jnc PasSupportSse3							;; si le flag carry n'est pas positionn, aller PasSupportSse3
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000100000000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse3:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx								;; tester le bit 
;		jnc PasSupportXxx							;; si le flag carry n'est pas positionn, aller
;		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000001000000000000b	;; positionner le bit correspondant dans notre variable
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2									;; ici, on dtermine les infos concernant le cache
;		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
PasSupportCpuid:
		popad									;; dsempiler tous les registres
	ret											;; retourner, sortir de la procdure
DefinirAptitudesDuProcesseur ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gnration de nombres alatoires
; *
; * note : ici je n'ai pas utilis les valeurs que j'utilise habituellement, parcequ'elles font partie de ma
; * signature (et vous ne voudriez pas vous retrouver avec un procs sur le dos, non ?) alors j'en ai mis d'autres
; * qui devrait fonctionner...
; * si ce n'est pas le cas changez les... le systme employ permet un grand ventail de possibilits
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Nombres_Aleatoires_		DWORD ?


.CODE
ALIGN 16
;
; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
;
; Rceptionne :
; rien
;
; Retourne:
; eax = nombre de tick depuis le dmarrage de l'ordi. (mais surtout, la variable _Nombres_Aleatoires_ est dfinie)
;
; syntaxe : InitialiserNombresAleatoires
;
InitialiserNombresAleatoires PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke GetTickCount							;; obtenir les millisecondes depuis le dmarrage
		test eax,eax								;; tester si eax = 0 (si c'est possible ! si vous lancez ce programme 48 jours aprs le dmarrage de l'ordinateur, lol)
		jnz Label1								;; si diffrent aller Label 1
		mov eax,123456789							;; mettre un nombre quelconque (pour eviter une division ultrieure par 0, suivant le gnrateur utilis)
Label1:	mov _Nombres_Aleatoires_,eax					;; sauver le rsultat pour initialiser les nombres alatoires

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
InitialiserNombresAleatoires ENDP


ALIGN 16
;
; generer un nombre aleatoire 32-bits entre 0 et une valeur maximale (exclue)
;
; Rceptionne :
; ebx = la valeur maximale +1 (ne peut pas tre zro, doit imprativement tre suprieur  1 pour une valeur
; situe dans un rang, ou 1 pour gnrer une valeur alatoire 32 bits)
;
; Retourne :
; eax = nombre aleatoire entre 0 et la valeur maximale (exclue), ou un nombre alatoire 32 bits si ebx = 1
;
; syntaxe : GenererNombreAleatoire
;
GenererNombreAleatoire PROC
		push edx									;; empiler edx

		mov eax,987654321							;; placer 987654321 dans eax
		mul _Nombres_Aleatoires_						;; multiplier eax par l'alatoire prcedent
		bswap eax									;; inverser l'ordre des octets pour rendre la valeur plus alatoire
		xor eax,078787878h							;; et pratiquer une inversion de bits (ne peut tre fait avec 0h ou FFFFFFFFh)
		jnz Label1								;; si c'est diffrent de 0, aller Label1
		mov eax,123456789							;; sinon, placer 123456789 dans eax
Label1:	mov _Nombres_Aleatoires_,eax					;; sauvegarder le nouveau nombre alatoire pour la gnration du prochain
; ici, on teste si c'est le cas d'une valeur alatoire 32 bits 
		cmp ebx,1									;; comparer ebx  1
		je Label2									;; si c'est le cas, c'est une valeur alatoire 32 bits, alors aller Label2
; ici, on traite le cas d'une valeur comprise entre 0 et X-1
		mul ebx									;; multiplier ensuite le nombre alatoire par la valeur maximale
		mov eax,edx								;; et placer le dpassement en eax
Label2:
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
GenererNombreAleatoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gestion mmoire/crans (c'est relativement la mme chose...)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; allouer un bloc mmoire  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = taille du bloc mmoire que l'on va crer (en octets)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; eax = adresse du bloc mmoire alig
; et les variables x._Pointeur_, x._Pointeur_A_Liberer_ et x._Taille_Du_Bloc_ sont dfinies
;
; syntaxe : AllouerBlocMemoire
;
AllouerBlocMemoire PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h							;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
AllouerBlocMemoire ENDP


ALIGN 16
;
; allouer un cran (bloc mmoire)  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = largeur de l'cran (en pixels)
; ebx = hauteur de l'cran (en pixels)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (ce sera le tampon de l'cran)
;
; retourne :
; eax = adresse du bloc mmoire align
; et les variables x._Pointeur_, x._Pointeur_A_Liberer_, x._Taille_Du_Bloc_, x._Largeur_Ecran_, x.Hauteur_Ecran_,
; et x._Largeur_Ecran_X4_ sont dfinies
;
; syntaxe : CreerEcran
;
CreerEcran PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,eax	;; placer eax dans x._Largeur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,ebx	;; placer eax dans x._Hauteur_Ecran_
		shl eax,2									;; multiplier la largeur par 4
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_,eax	;; placer eax dans x._Largeur_Ecran_X4_
		mul ebx									;; multiplier _Largeur_Ecran_X4_ par _Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,16								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Zbuffer_,eax	;; sauvegarder eax dans x._Pointeur_Zbuffer_ (ca vite des dsagrments de mauvaise utilisation CreerEcran/CreerEcranAvecZBuffer)

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
CreerEcran ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; eax = l'adresse de l'instance
; et les variables x._Instance_, x._Taille_Initiale_ et x._Taille_Maximale_ sont dfinies
;
; syntaxe : CreerInstanceMemoire
;
CreerInstanceMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_	;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax	;; sauvegarde du pointeur de l'instance

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; librer un bloc mmoire
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; rien
;
; syntaxe : SupprimerBlocMemoire
;
SupprimerBlocMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerBlocMemoire ENDP


ALIGN 16
;
; librer un cran (bloc mmoire)
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_
;
; retourne :
; rien
;
; syntaxe : SupprimerEcran
;
SupprimerEcran PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerEcran ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; rien
;
; syntaxe : SupprimerInstanceMemoire
;
SupprimerInstanceMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_	;; librer l'instance mmoire

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine de traitement d'un bloc mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_GMEE_Mmx_Masque_Alpha_			DWORD 0FF000000h,0FF000000h
_GMEE_Mmx_Masque_RVB_			DWORD 000FFFFFFh,000FFFFFFh
_GMEE_Mmx_Masque_Moitiee_unpck_	DWORD 000800080h,000000080h	;; c'est 000000080h,000800080h il y a inversion des dwords  la lecture
_GMEE_Mmx_CE_Nombre_De_Lignes_	DWORD ?
_GMEE_Sse_IBBM_Valeur_Temporaire_	DWORD ?

.CODE
ALIGN 16
;
; copier un bloc memoire vers un autre bloc memoire
; note : il faut aussi s'assurer que les blocs mmoire ne se chevauchent pas, sinon il faut utiliser
; BougerBlocMemoire... tous les registres MMx sont utiliss
;
; Rceptionne :
; eax = taille  copier en octets
; esi = adresse du bloc source
; edi = adresse du bloc de destination
;
; Retourne :
; rien
;
; syntaxe : Mmx_CopierBlocMemoire
;
Mmx_CopierBlocMemoire PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

; ici on traite les 4x owords
		mov ecx,eax								;; copier eax dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
		nop										;; ) alignement ncessaire pour un meilleur rendement
		nop										;; )
		nop										;; )
		nop										;; )
Label0:	movq MM0,QWORD PTR[esi+ecx]					;; placer esi+ecx dans MM0
		movq MM1,QWORD PTR[esi+ecx+8]					;; placer esi+ecx+8 dans MM1
		movq MM2,QWORD PTR[esi+ecx+16]				;; placer esi+ecx+16 dans MM2
		movq MM3,QWORD PTR[esi+ecx+24]				;; placer esi+ecx+24 dans MM3
		movq MM4,QWORD PTR[esi+ecx+32]				;; placer esi+ecx+32 dans MM4
		movq MM5,QWORD PTR[esi+ecx+40]				;; placer esi+ecx+40 dans MM5
		movq MM6,QWORD PTR[esi+ecx+48]				;; placer esi+ecx+48 dans MM6
		movq MM7,QWORD PTR[esi+ecx+56]				;; placer esi+ecx+56 dans MM7
		movq QWORD PTR[edi+ecx],MM0					;; placer MM0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM1					;; placer MM1 en edi+ecx+8
		movq QWORD PTR[edi+ecx+16],MM2				;; placer MM2 en edi+ecx+16
		movq QWORD PTR[edi+ecx+24],MM3				;; placer MM3 en edi+ecx+24
		movq QWORD PTR[edi+ecx+32],MM4				;; placer MM4 en edi+ecx+32
		movq QWORD PTR[edi+ecx+40],MM5				;; placer MM5 en edi+ecx+40
		movq QWORD PTR[edi+ecx+48],MM6				;; placer MM6 en edi+ecx+48
		movq QWORD PTR[edi+ecx+56],MM7				;; placer MM7 en edi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0

; ici on traite les owords
Label1:	mov ecx,eax								;; copier eax dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label3									;; si ecx est gal  0, aller Label3
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label2:	movq MM0,QWORD PTR[esi+ecx]					;; placer esi+ecx dans MM0
		movq MM1,QWORD PTR[esi+ecx+8]					;; placer esi+ecx+8 dans MM1
		movq QWORD PTR[edi+ecx],MM0					;; placer MM0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM1					;; placer MM1 en edi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label2								;; tant que ecx est diffrent de 0, aller Label2

; ici on traite les dwords
Label3:	mov ecx,eax								;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label5									;; si ecx est gal  0, aller Label5
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label4:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et le recopier en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label4								;; tant que ecx est sign, aller Label4

; ici on traite les octets
Label5:	mov ecx,eax								;; copier eax dans ecx
		and ecx,00000000000000000000000000000011b		;; ne conserver que les bits octets en ecx
		jz Label7									;; si ecx est gal  0, aller Label7
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label6:	mov dl,BYTE PTR [esi+ecx]					;; placer l'octet en esi+edx dans dl
		mov BYTE PTR [edi+ecx],dl					;; et le recopier en edi+ecx
		inc ecx									;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label6								;; tant que ecx est diffrent de 0, aller Label6
Label7:	sub esi,eax								;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		sub edi,eax								;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_CopierBlocMemoire ENDP


ALIGN 16
;
; copier un cran dans un autre
; note : il faut aussi s'assurer que les blocs mmoire ne se chevauchent pas, ne pas oublier de nettoyer l'cran
; au pralable si c'est ncessaire, tous les registres MMx sont utiliss
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel}
; mov edi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination}
; call Mmx_CopierEcran
;
; Retourne :
; rien
;
Mmx_CopierEcran PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebp,edi								;; copier l'adresse de la structure destination dans ebp
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran destination dans eax
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; comparer cette largeur  celle de l'cran source
		jbe Label01										;; si elle est infrieure ou gale, aller Label01
		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; sinon, placer la largeur de l'cran de destination dans eax
Label01:	mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran source dans ebx
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; comparer cette hauteur  celle de l'cran de destination
		jbe Label02										;; si elle est infrieure ou gale, aller Label02
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Hauteur_Ecran_	;; sinon, placer la largeur de l'cran de destination dans ebx
Label02:	mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_		;; placer l'adresse du dbut des pixels de destination dans edi
		mov _GMEE_Mmx_CE_Nombre_De_Lignes_,ebx					;; sauvegarder le compteur de lignes
		mov ebx,esi										;; et placer l'adresse de la structure source dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_		;; placer l'adresse du dbut des pixels source dans esi
; puis on copie les lignes, ici on traite les 4x owords
Label03:	mov ecx,eax								;; copier eax dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label05								;; si ecx est gal  0, aller Label05
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label04:	movq MM0,QWORD PTR[esi+ecx]					;; placer esi+ecx dans MM0
		movq MM1,QWORD PTR[esi+ecx+8]					;; placer esi+ecx+8 dans MM1
		movq MM2,QWORD PTR[esi+ecx+16]				;; placer esi+ecx+16 dans MM2
		movq MM3,QWORD PTR[esi+ecx+24]				;; placer esi+ecx+24 dans MM3
		movq MM4,QWORD PTR[esi+ecx+32]				;; placer esi+ecx+32 dans MM4
		movq MM5,QWORD PTR[esi+ecx+40]				;; placer esi+ecx+40 dans MM5
		movq MM6,QWORD PTR[esi+ecx+48]				;; placer esi+ecx+48 dans MM6
		movq MM7,QWORD PTR[esi+ecx+56]				;; placer esi+ecx+56 dans MM7
		movq QWORD PTR[edi+ecx],MM0					;; placer MM0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM1					;; placer MM1 en edi+ecx+8
		movq QWORD PTR[edi+ecx+16],MM2				;; placer MM2 en edi+ecx+16
		movq QWORD PTR[edi+ecx+24],MM3				;; placer MM3 en edi+ecx+24
		movq QWORD PTR[edi+ecx+32],MM4				;; placer MM4 en edi+ecx+32
		movq QWORD PTR[edi+ecx+40],MM5				;; placer MM5 en edi+ecx+40
		movq QWORD PTR[edi+ecx+48],MM6				;; placer MM6 en edi+ecx+48
		movq QWORD PTR[edi+ecx+56],MM7				;; placer MM7 en edi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label04								;; tant que ecx est diffrent de 0, aller Label04
; ici on traite les owords
Label05:	mov ecx,eax								;; copier eax dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label07								;; si ecx est gal  0, aller Label07
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label06:	movq MM0,QWORD PTR[esi+ecx]					;; placer esi+ecx dans MM0
		movq MM1,QWORD PTR[esi+ecx+8]					;; placer esi+ecx+8 dans MM1
		movq QWORD PTR[edi+ecx],MM0					;; placer MM0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM1					;; placer MM1 en edi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label06								;; tant que ecx est diffrent de 0, aller Label06
; ici on traite les dwords
Label07:	mov ecx,eax								;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label09								;; si ecx est gal  0, aller Label09
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label08:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et le recopier en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label08								;; tant que ecx est sign, aller Label08
; ici on ne traite pas les octets, puisqu'au minimum ce sont des dwords
Label09:
		sub edi,eax								;; soustraire la taille  edi (pour retrouver l'adresse originelle)
		sub esi,eax								;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		add esi,(_Bloc_Memoire_Ecran_ PTR [ebx])._Largeur_Ecran_X4_	;; ajouter une ligne  l'cran source
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter une ligne  l'cran de destination
		dec _GMEE_Mmx_CE_Nombre_De_Lignes_				;; dcrmenter la hauteur cran  copier
		jnz Label03								;; tant que ebx est diffrent de 0, aller Label03

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_CopierEcran ENDP


ALIGN 16
;
; copier un cran dans un autre, en le centrant
; note : il faut aussi s'assurer que les blocs mmoire ne se chevauchent pas, ne pas oublier de nettoyer l'cran
; au pralable si c'est ncessaire, tous les registres MMx sont utiliss
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel}
; mov edi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination}
; call Mmx_CopierEcranCentre
;
; Retourne :
; rien
;
Mmx_CopierEcranCentre PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; on calcul les dcalages en largeur et en hauteur
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; placer la hauteur de l'cran de destination dans ebx
		sub ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; soustraire la hauteur de l'cran source
		sar ebx,1									;; diviser la hauteur obtenue par 2 (signe)
; ici on utilise ecx, et pas directement edx, parceque edx sera mis  0 a cause des mutiplications qui suivent...
		mov ecx,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran de destination dans ecx
		sub ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; soustraire la largeur de l'cran source
		sar ecx,1									;; diviser la largeur obtenue par 2 (signe)
		and ecx,0FFFFFFFCh							;; ici, c'est pour tre sr que les couleurs soient bien aligns par dwords (si la largeur source est impaire)
; maintenant on va calculer et appliquer le dcalage complet (sur la source ou la destination, suivant le cas...)
		test ebx,ebx								;; fixer les flags de ebx
		js Label03								;; si ebx (le dcalage en largeur) est sign, aller Label03
; ici, HauteurDestination >= HauteurSource 
		test ecx,ecx								;; fixer les flags de ecx
		js Label02								;; si ecx (le dcalage en hauteur) est sign, aller Label02
; cas o LargeurDestination >= LargeurSource et HauteurDestination >= HauteurSource
Label01:	mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne destination dans eax
		mul ebx									;; multiplier cette largeur par l'cart en hauteur
		mov edx,ecx								;; copier l'cart en largeur dans edx
		add edx,eax								;; ajouter le rsultat obtenu  l'cart en largeur
		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran source dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran source dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut des pixels source dans esi
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur type de la destination dans ebp
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut des pixels de destination dans edi
		add edi,edx								;; ajouter le dcalage complet  l'cran de destination
		mov ecx,eax								;; placer la largeur type de la source dans ecx
		jmp Label06								;; aller Label06
; cas o LargeurDestination < LargeurSource et HauteurDestination >= HauteurSource
Label02:	mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne destination dans eax
		mul ebx									;; multiplier cette largeur par l'cart en hauteur
		mov ebp,ecx								;; placer l'cart en largeur dans ebp
		mov edx,eax								;; placer le rsultat obtenu dans edx
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran source dans ebx
		mov ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur type de la source dans ecx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut des pixels source dans esi
		sub esi,ebp								;; enlever (puisque ici ebp est ngatif) l'cart en largeur  l'cran source
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran de destination dans eax
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut des pixels de destination dans edi
		add edi,edx								;; ajouter le dcalage en hauteur  l'cran de destination
		mov ebp,eax								;; placer la largeur type de la destination dans ebp
		jmp Label06								;; aller Label06
; ici, HauteurDestination < HauteurSource 
Label03:	neg ebx									;; inverser ebx (qui etait ngatif...)
		test ecx,ecx								;; fixer les flags de ecx
		js Label05								;; si ecx (le dcalage en hauteur) est sign, aller Label05
; cas o LargeurDestination >= LargeurSource et HauteurDestination < HauteurSource
Label04:	mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne source dans eax
		mul ebx									;; multiplier cette largeur par l'cart en hauteur
		mov edx,ecx								;; placer l'cart en largeur dans edx
		mov ebp,eax								;; placer le rsultat obtenu dans ebp
		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran source dans eax
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut des pixels source dans esi
		add esi,ebp								;; ajouter le dcalage en hauteur  l'cran source
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur type de la destination dans ebp
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; placer la largeur de l'cran de destination dans ebx
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut des pixels de destination dans edi
		add edi,edx								;; ajouter le dcalage en largeur  l'cran de destination
		mov ecx,eax								;; placer la largeur type de la source dans ecx
		jmp Label06								;; aller Label06
; cas o LargeurDestination < LargeurSource et HauteurDestination < HauteurSource
Label05:	mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne source dans eax
		mul ebx									;; multiplier cette largeur par l'cart en hauteur
		sub eax,ecx								;; enlever (puisque ici ecx est ngatif) l'cart en largeur au rsultat
		mov edx,eax								;; placer le rsultat obtenu dans edx
		mov ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur type de la source dans ecx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut des pixels source dans esi
		add esi,edx								;; ajouter le dcalage complet  l'cran source
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; sinon, placer la largeur de l'cran de destination dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; sinon, placer la largeur de l'cran de destination dans ebx
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut des pixels de destination dans edi
		mov ebp,eax								;; placer la largeur type de la destination dans ebp
;		jmp Label06								;; aller Label06
; puis on copie les lignes
Label06:	push ecx									;; empiler ecx
; ici on traite les 4x owords
		mov ecx,eax								;; copier eax dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label08								;; si ecx est gal  0, aller Label08
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label07:	movq MM0,QWORD PTR[esi+ecx]					;; placer esi+ecx dans MM0
		movq MM1,QWORD PTR[esi+ecx+8]					;; placer esi+ecx+8 dans MM1
		movq MM2,QWORD PTR[esi+ecx+16]				;; placer esi+ecx+16 dans MM2
		movq MM3,QWORD PTR[esi+ecx+24]				;; placer esi+ecx+24 dans MM3
		movq MM4,QWORD PTR[esi+ecx+32]				;; placer esi+ecx+32 dans MM4
		movq MM5,QWORD PTR[esi+ecx+40]				;; placer esi+ecx+40 dans MM5
		movq MM6,QWORD PTR[esi+ecx+48]				;; placer esi+ecx+48 dans MM6
		movq MM7,QWORD PTR[esi+ecx+56]				;; placer esi+ecx+56 dans MM7
		movq QWORD PTR[edi+ecx],MM0					;; placer MM0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM1					;; placer MM1 en edi+ecx+8
		movq QWORD PTR[edi+ecx+16],MM2				;; placer MM2 en edi+ecx+16
		movq QWORD PTR[edi+ecx+24],MM3				;; placer MM3 en edi+ecx+24
		movq QWORD PTR[edi+ecx+32],MM4				;; placer MM4 en edi+ecx+32
		movq QWORD PTR[edi+ecx+40],MM5				;; placer MM5 en edi+ecx+40
		movq QWORD PTR[edi+ecx+48],MM6				;; placer MM6 en edi+ecx+48
		movq QWORD PTR[edi+ecx+56],MM7				;; placer MM7 en edi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label07								;; tant que ecx est diffrent de 0, aller Label07
; ici on traite les owords
Label08:	mov ecx,eax								;; copier eax dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label10								;; si ecx est gal  0, aller Label10
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label09:	movq MM0,QWORD PTR[esi+ecx]					;; placer esi+ecx dans MM0
		movq MM1,QWORD PTR[esi+ecx+8]					;; placer esi+ecx+8 dans MM1
		movq QWORD PTR[edi+ecx],MM0					;; placer MM0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM1					;; placer MM1 en edi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label09								;; tant que ecx est diffrent de 0, aller Label09
; ici on traite les dwords
Label10:	mov ecx,eax								;; copier eax dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label12								;; si ecx est gal  0, aller Label12
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label11:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et le recopier en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label11								;; tant que ecx est sign, aller Label11
; ici on ne traite pas les octets, puisqu'au minimum ce sont des dwords
Label12:	pop ecx									;; dsempiler ecx

		sub edi,eax								;; soustraire la taille  edi (pour retrouver l'adresse originelle)
		sub esi,eax								;; soustraire la taille  esi (pour retrouver l'adresse originelle)
		add esi,ecx								;; ajouter une ligne  l'cran source
		add edi,ebp								;; ajouter une ligne  l'cran de destination
		dec ebx									;; dcrmenter la hauteur cran  copier
		jnz Label06								;; tant que ebx est diffrent de 0, aller Label06

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_CopierEcranCentre ENDP


ALIGN 16
;
; effacer un bloc memoire (en le remplissant de 0)
; note : MM0 est modifi
;
; Rceptionne :
; eax = taille  ffacer en octets
; esi = adresse du bloc de destination
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffacerBlocMemoire
;
Mmx_EffacerBlocMemoire PROC
		push ecx									;; empiler ecx

; ici on traite les 4x owords
		mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label0:	movq QWORD PTR[esi+ecx],MM0					;; placer 0 en esi+ecx
		movq QWORD PTR[esi+ecx+8],MM0					;; placer 0 en esi+ecx+8
		movq QWORD PTR[esi+ecx+16],MM0				;; placer 0 en esi+ecx+16
		movq QWORD PTR[esi+ecx+24],MM0				;; placer 0 en esi+ecx+24
		movq QWORD PTR[esi+ecx+32],MM0				;; placer 0 en esi+ecx+32
		movq QWORD PTR[esi+ecx+40],MM0				;; placer 0 en esi+ecx+40
		movq QWORD PTR[esi+ecx+48],MM0				;; placer 0 en esi+ecx+48
		movq QWORD PTR[esi+ecx+56],MM0				;; placer 0 en esi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0
; ici on traite les owords
Label1:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label3									;; si ecx est gal  0, aller Label3
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label2:	movq QWORD PTR[esi+ecx],MM0					;; placer 0 en esi+ecx
		movq QWORD PTR[esi+ecx+8],MM0					;; placer 0 en esi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label2								;; tant que ecx est diffrent de 0, aller Label2
; ici on traite les dwords
Label3:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label5									;; si ecx est gal  0, aller Label5
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label4:	mov DWORD PTR [esi+ecx],0					;; placer 0 en esi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label4								;; tant que ecx est diffrent de 0, aller Label4
; ici on traite les octets
Label5:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b		;; ne conserver que les bits octets en ecx
		jz Label7									;; si ecx est gal  0, aller Label7
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label6:	mov BYTE PTR [esi+ecx],0						;; placer 0 en esi+ecx
		inc ecx									;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label6								;; tant que ecx est diffrent de 0, aller Label6
Label7:	sub esi,eax								;; soustraire la taille  esi (pour retrouver l'adresse originelle)

		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_EffacerBlocMemoire ENDP


ALIGN 16
;
; inverser un bloc mmoire par une valeur servant de masque
; note : MM0 et MM1 sont modifis
;
; Syntaxe :
; mov eax,{taille du bloc en octets}
; mov ebx,{valeur du filtre (bits = masque binaire ex: 00001111b, o les 1 sont les bits  inverser et les 0 les bits  conserver)}
; mov esi,{adresse du bloc  filtrer}
; call Mmx_InverserBitsBlocMemoire
;
; Retourne :
; rien
;
Mmx_InverserBitsBlocMemoire PROC
		push ecx									;; empiler ecx

; on place la valeur dans le registre simd
		movd MM0,ebx								;; placer le masque valeur dans MM0
		punpckldq MM0,MM0							;; dupliquer la valeur dans la partie haute du registre
; ici on traite les 4x owords
		mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label0:	movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx]					;; inverser la valeur avec les couleurs en esi+ecx
		movq QWORD PTR[esi+ecx],MM1					;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+8]					;; inverser la valeur avec les couleurs en esi+ecx+8
		movq QWORD PTR[esi+ecx+8],MM1					;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+16]				;; inverser la valeur avec les couleurs en esi+ecx+16
		movq QWORD PTR[esi+ecx+16],MM1				;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+24]				;; inverser la valeur avec les couleurs en esi+ecx+24
		movq QWORD PTR[esi+ecx+24],MM1				;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+32]				;; inverser la valeur avec les couleurs en esi+ecx+32
		movq QWORD PTR[esi+ecx+32],MM1				;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+40]				;; inverser la valeur avec les couleurs en esi+ecx+40
		movq QWORD PTR[esi+ecx+40],MM1				;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+48]				;; inverser la valeur avec les couleurs en esi+ecx+48
		movq QWORD PTR[esi+ecx+48],MM1				;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+56]				;; inverser la valeur avec les couleurs en esi+ecx+56
		movq QWORD PTR[esi+ecx+56],MM1				;; sauvegarder les nouvelles couleurs
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0
; ici on traite les owords
Label1:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label3									;; si ecx est gal  0, aller Label3
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label2:	movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx]					;; inverser la valeur avec les couleurs en esi+ecx
		movq QWORD PTR[esi+ecx],MM1					;; sauvegarder les nouvelles couleurs
		movq MM1,MM0								;; copier le masque dans MM1
		pxor MM1,QWORD PTR[esi+ecx+8]					;; inverser la valeur avec les couleurs en esi+ecx+8
		movq QWORD PTR[esi+ecx+8],MM1					;; sauvegarder les nouvelles couleurs
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label2								;; tant que ecx est diffrent de 0, aller Label2
; ici on traite les dwords
Label3:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label5									;; si ecx est gal  0, aller Label5
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label4:	xor DWORD PTR [esi+ecx],ebx					;; placer ebx en esi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label4								;; tant que ecx est diffrent de 0, aller Label4
; ici on traite les octets
Label5:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b		;; ne conserver que les bits octets en ecx
		jz Label7									;; si ecx est gal  0, aller Label7
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label6:	xor BYTE PTR [esi+ecx],bl					;; placer bl en esi+ecx
		inc ecx									;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label6								;; tant que ecx est diffrent de 0, aller Label6
Label7:	sub esi,eax								;; soustraire la taille  esi (pour retrouver l'adresse originelle)

		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_InverserBitsBlocMemoire ENDP


ALIGN 16
;
; basculer un cran horizontalement (version mmx)
; note : MM0, MM1, MM2 et MM3 sont utiliss
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel}
; call Mmx_InverserEcranHorizontalement
;
; Retourne :
; rien
;
Mmx_InverserEcranHorizontalement PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran source dans ebx
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur x4 dans ebp
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut des pixels dans esi
; ici on va trouver le bon milieu de la chane ascii
Label01:	add esi,ebp								;; ajouter la largeur d'un ligne  esi
		mov eax,ebp								;; placer la largeur de l'cran dans eax
		mov ecx,ebp								;; et dans ecx
		shr ecx,1									;; diviser ecx par 2 (pour obtenir la moitiee d'une ligne)
		mov edx,ecx								;; copier ecx dans edx
		and edx,0FFFFFFF0h							;; conserver les owords de edx
		jz Label03								;; pas de pixel ?, alors aller Label03
		lea edi,[esi-DWORD*4]						;; sinon, dfinir l'adresse du dernier pixel de la ligne dans edi
		sub edi,edx								;; enlever  edi la majeur partie de notre "moitie" de ligne en edx
		neg eax									;; et inverser eax (pour que esi+eax simule une lecture normale)
; maintenant que les paramtres sont tous dfinis, on va substituer les pixels/couleurs
Label02:	movq MM0,QWORD PTR [esi+eax]					;; ) changer les pixels
		movq MM1,QWORD PTR [esi+eax+8]				;; )
		movq MM2,QWORD PTR [edi+edx]					;; )
		movq MM3,QWORD PTR [edi+edx+8]				;; )
		pshufw MM0,MM0,04Eh							;;	) changer les dwords
		pshufw MM1,MM1,04Eh							;;	)
		pshufw MM2,MM2,04Eh							;;	)
		pshufw MM3,MM3,04Eh							;;	)
		movq QWORD PTR [edi+edx],MM1					;; )
		movq QWORD PTR [edi+edx+8],MM0				;; )
		movq QWORD PTR [esi+eax],MM3					;; )
		movq QWORD PTR [esi+eax+8],MM2				;; )
		add eax,16								;; augmenter eax d'un oword (4 pixels)
		add edx,-16								;; dcrementer edx d'un oword (4 pixels)
		jnz Label02								;; tant que edx est diffrent de 0, aller Label02
		and ecx,00000000Ch							;; pour tre sr que ce soit des pixels complets
		jnz Label03								;; des pixels ?, alors aller Label03
; ici, la ligne est termine
		dec ebx									;; dcrmenter la hauteur cran
		jnz Label01								;; tant que ebx est diffrent de 0, aller Label01

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)

Label03:	add edi,DWORD*3							;; pour le passage des owords aux dwords
		sub edi,ecx								;; enlever  edi notre restant de "moitie" de ligne en ecx
; maintenant que les paramtres sont tous dfinis, on va substituer les pixels/couleurs
Label04:	mov edx,DWORD PTR [esi+eax]					;; ) changer les pixels
		xor edx,DWORD PTR [edi+ecx]					;; )
		xor DWORD PTR [edi+ecx],edx					;; )
		xor DWORD PTR [esi+eax],edx					;; )
		add eax,4									;; augmenter eax d'un dword (pixel)
		add ecx,-4								;; dcrementer ecx d'un dword (pixel)
		jnz Label04								;; tant que ecx est diffrent de 0, aller Label03
; ici on ne traite pas les octets, puisqu'au minimum ce sont des dwords
		dec ebx									;; dcrmenter la hauteur cran
		jnz Label01								;; tant que ebx est diffrent de 0, aller Label01

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_InverserEcranHorizontalement ENDP


ALIGN 16
;
; basculer un cran verticalement (version mmx)
; note : MM0, MM1, MM2 et MM3 sont utiliss
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel}
; call Mmx_InverserEcranVerticalement
;
; Retourne :
; rien
;
Mmx_InverserEcranVerticalement PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur x4 de l'cran dans ebp
		mov edi,(_Bloc_Memoire_Ecran_ PTR [esi])._Taille_Du_Bloc_	;; placer la taille de l'cran dans edi
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut des pixels dans esi
		shr ebx,1									;; diviser la hauteur par 2
		add edi,esi								;; ajouter l'adresse de dpart de l'cran  edi
; ici on va trouver le bon milieu de la chane ascii
Label01:	sub edi,ebp								;; enlever une ligne  edi
		mov eax,ebp								;; placer la largeur de l'cran dans eax
		mov ecx,ebp								;; et dans ecx
		and ecx,0FFFFFFF0h							;; conserver les owords de edx
		jz Label03								;; pas de pixel ?, alors aller Label03
		add esi,ecx								;; augmenter esi du nombre de pixel
		add edi,ecx								;; ainsi que edi
		neg ecx									;; et inverser ecx (le nombre de pixel)
; maintenant que les paramtres sont tous dfinis, on va substituer les pixels/couleurs
Label02:	movq MM0,QWORD PTR [esi+ecx]					;; ) changer les pixels
		movq MM1,QWORD PTR [esi+ecx+8]				;; )
		movq MM2,QWORD PTR [edi+ecx]					;; )
		movq MM3,QWORD PTR [edi+ecx+8]				;; )
		movq QWORD PTR [edi+ecx],MM0					;; )
		movq QWORD PTR [edi+ecx+8],MM1				;; )
		movq QWORD PTR [esi+ecx],MM2					;; )
		movq QWORD PTR [esi+ecx+8],MM3				;; )
		add ecx,DWORD*4							;; augmenter ecx d'un oword (4 pixels)
		jnz Label02								;; tant que ecx est diffrent de 0, aller Label02
; ici, on traite les pixels restant (si le nombre de pixels de la ligne n'est pas multiple de 4)
Label03:	and eax,00000000Ch							;; pour tre sr que ce soit des pixels complets
		jz Label05								;; pas de pixel ?, alors aller Label05
		add esi,eax								;; augmenter esi du nombre de pixel restant
		add edi,eax								;; ainsi que edi
		neg eax									;; et inverser eax (le nombre de pixel)
; maintenant que les paramtres sont tous dfinis, on va substituer les pixels/couleurs
Label04:	mov ecx,DWORD PTR [esi+eax]					;; ) changer les pixels
		mov edx,DWORD PTR [edi+eax]					;; )
		mov DWORD PTR [edi+eax],ecx					;; )
		mov DWORD PTR [esi+eax],edx					;; )
		add eax,DWORD								;; augmenter eax d'un dword (pixel)
		jnz Label04								;; tant que eax est diffrent de 0, aller Label04
; enfin, on teste si il y a une autre ligne  traiter
Label05:	sub edi,ebp								;; enlever une ligne  edi
		dec ebx									;; dcrmenter la demi hauteur cran
		jnz Label01								;; tant que ebx est diffrent de 0, aller Label01

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_InverserEcranVerticalement ENDP


ALIGN 16
;
; effacer un bloc memoire (en le remplissant de 0)
; note : MM0 est modifi
;
; Syntaxe :
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_Ecran_}
; call Mmx_EffacerEcran
;
; Retourne :
; eax = taille du bloc ZBuffer en octets
;
Mmx_EffacerEcran PROC
		push ecx									;; empiler ecx
		push edi									;; empiler edi

		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_
		mov esi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_
; ici on traite les 4x owords
		mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
		nop										;; ) alignement ncessaire pour un meilleur rendement 
		nop										;; )
		nop										;; )
		pxor MM0,MM0								;; effacer XMM0
Label0:	movq QWORD PTR[esi+ecx],MM0					;; placer 0 en esi+ecx
		movq QWORD PTR[esi+ecx+8],MM0					;; placer 0 en esi+ecx+8
		movq QWORD PTR[esi+ecx+16],MM0				;; placer 0 en esi+ecx+16
		movq QWORD PTR[esi+ecx+24],MM0				;; placer 0 en esi+ecx+24
		movq QWORD PTR[esi+ecx+32],MM0				;; placer 0 en esi+ecx+32
		movq QWORD PTR[esi+ecx+40],MM0				;; placer 0 en esi+ecx+40
		movq QWORD PTR[esi+ecx+48],MM0				;; placer 0 en esi+ecx+48
		movq QWORD PTR[esi+ecx+56],MM0				;; placer 0 en esi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0

; ici on traite les owords
Label1:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label3									;; si ecx est gal  0, aller Label3
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer XMM0
Label2:	movq QWORD PTR[esi+ecx],MM0					;; placer 0 en esi+ecx
		movq QWORD PTR[esi+ecx+8],MM0					;; placer 0 en esi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label2								;; tant que ecx est diffrent de 0, aller Label2

; ici on traite les dwords
Label3:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label5									;; si ecx est gal  0, aller Label5
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label4:	mov DWORD PTR [esi+ecx],0					;; placer 0 en esi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label4								;; tant que ecx est diffrent de 0, aller Label4

; ici on ne traite pas les octets (puisqu'au minimum ce sont des dwords)
Label5:
		pop edi									;; dsempiler edi
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_EffacerEcran ENDP


ALIGN 16
;
; agrandir un cran (en multipliant sa taille par 2, avec un remplissage par fondu, sauf pour la dernire ligne) en version SSE
; l'cran originel doit tre multiple de 4 car les pixels sont, ici, traits par quatre
; videment, les deux blocs mmoire doivent avoir les tailles correspondantes... et doivent tre aligns sur 16 octets
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel}
; mov edi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination}
; call Mmx_AgrandirX2_RemplissageFondu
;
; Retourne :
; rien
;
Mmx_AgrandirX2_RemplissageFondu PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran originel dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut de la zone originelle dans esi
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut de la zone de destination dans edi
		neg ebx									;; on inverse ebx, qui sera notre compteur de boucle pour les lignes
		pxor MM7,MM7								;; effacer MM7
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
Label0:	lea edx,[edi+ebp]							;; edx = _Pointeur_ + _Largeur_Ecran_X4_
		lea edi,[edi+2*ebp]							;; edi = _Pointeur_ + _Largeur_Ecran_X4_*2
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, on traite la premire ligne (que l'on va doubler)
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label1:	movd MM1,DWORD PTR [ecx+esi]					;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq QWORD PTR [2*ecx+edx],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		add ecx,DWORD								;; augmenter ecx d'1 dword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
		inc ebx									;; incrmener ebx d'une ligne
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )

; maintenant que la premire ligne (double) a t calcule, on va pouvoir calculer les lignes intermediaires en plus...
Label2:	mov eax,edi								;; copier edi dans eax
		lea edx,[edi+ebp]							;; edx = _Pointeur_ + _Largeur_Ecran_X4_
		lea edi,[edi+2*ebp]							;; edi = _Pointeur_ + _Largeur_Ecran_X4_*2
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes

; ici, on traite les lignes
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label3:	movd MM1,DWORD PTR [ecx+esi]					;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		movq MM2,MM0								;; faire une copie de MM0 en MM2 (qui servira pour les lignes intermdiaires)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0

; ici, on traite les lignes intermediaires (les lignes juste au dessus de celles qui viennent d'tre traites)
		movq MM3,QWORD PTR [2*ecx+eax]				;; placer le qword de 2 lignes avant dans MM3
		movq MM4,MM3								;; recopier MM3 dans MM4
		punpcklbw MM3,MM7							;; placer 00XX00XX00XX00XX dans MM3
		punpckhbw MM4,MM7							;; placer 00XX00XX00XX00XX dans MM4
		paddw MM3,MM2								;; ajouter en parallle MM2  MM3
		paddw MM4,MM1								;; ajouter en parallle MM1  MM4
		psrlw MM3,1								;; diviser en parallle les words en MM3 par 2 (par un dcalage  droite de 2 bits)
		psrlw MM4,1								;; diviser en parallle les words en MM4 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM3,MM4							;; compacter les words de MM3 et MM4 en octets dans MM3
		movq QWORD PTR [2*ecx+edx],MM3				;; et recopier les deux couleurs casses dans edx+(ecx*2) (la ligne prcdente)
Label4:	add ecx,DWORD								;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
		inc ebx									;; incrmener ebx d'une ligne
		jnz Label2								;; tant que ebx est diffrent de 0, aller Label2

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AgrandirX2_RemplissageFondu ENDP


ALIGN 16
;
; agrandir un cran (en multipliant sa taille par 2, avec un remplissage par fondu, sauf pour la dernire ligne) en version SSE
; l'cran originel doit tre multiple de 4 car les pixels sont, ici, traits par quatre
; videment, les deux blocs mmoire doivent avoir les tailles correspondantes... et doivent tre aligns sur 16 octets
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel}
; mov edi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination}
; call Mmx_AgrandirX2_RemplissageFondu_Sur_Place
;
; Retourne :
; rien
;
Mmx_AgrandirX2_RemplissageFondu_Sur_Place PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_
		shr eax,2
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; placer la hauteur de l'cran originel dans ebx
		shr ebx,1
		mov esi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut de la zone originelle dans esi
		add esi,eax
		add esi,eax
		add esi,eax
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut de la zone de destination dans edi
		neg ebx									;; on inverse ebx, qui sera notre compteur de boucle pour les lignes
		pxor MM7,MM7								;; effacer MM7
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
Label0:	lea edx,[edi+ebp]							;; edx = _Pointeur_ + _Largeur_Ecran_X4_
		lea edi,[edi+2*ebp]							;; edi = _Pointeur_ + _Largeur_Ecran_X4_*2
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, on traite la premire ligne (que l'on va doubler)
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label1:	movd MM1,DWORD PTR [ecx+esi]					;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq QWORD PTR [2*ecx+edx],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		add ecx,DWORD								;; augmenter ecx d'1 dword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
		inc ebx									;; incrmener ebx d'une ligne
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )

; maintenant que la premire ligne (double) a t calcule, on va pouvoir calculer les lignes intermediaires en plus...
Label2:	mov eax,edi								;; copier edi dans eax
		lea edx,[edi+ebp]							;; edx = _Pointeur_ + _Largeur_Ecran_X4_
		lea edi,[edi+2*ebp]							;; edi = _Pointeur_ + _Largeur_Ecran_X4_*2
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes

; ici, on traite les lignes
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label3:	movd MM1,DWORD PTR [ecx+esi]					;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		movq MM2,MM0								;; faire une copie de MM0 en MM2 (qui servira pour les lignes intermdiaires)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0

; ici, on traite les lignes intermediaires (les lignes juste au dessus de celles qui viennent d'tre traites)
		movq MM3,QWORD PTR [2*ecx+eax]				;; placer le qword de 2 lignes avant dans MM3
		movq MM4,MM3								;; recopier MM3 dans MM4
		punpcklbw MM3,MM7							;; placer 00XX00XX00XX00XX dans MM3
		punpckhbw MM4,MM7							;; placer 00XX00XX00XX00XX dans MM4
		paddw MM3,MM2								;; ajouter en parallle MM2  MM3
		paddw MM4,MM1								;; ajouter en parallle MM1  MM4
		psrlw MM3,1								;; diviser en parallle les words en MM3 par 2 (par un dcalage  droite de 2 bits)
		psrlw MM4,1								;; diviser en parallle les words en MM4 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM3,MM4							;; compacter les words de MM3 et MM4 en octets dans MM3
		movq QWORD PTR [2*ecx+edx],MM3				;; et recopier les deux couleurs casses dans edx+(ecx*2) (la ligne prcdente)
Label4:	add ecx,DWORD								;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
		inc ebx									;; incrmener ebx d'une ligne
		jnz Label2								;; tant que ebx est diffrent de 0, aller Label2

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AgrandirX2_RemplissageFondu_Sur_Place ENDP


ALIGN 16
;
; transformer les couleurs d'un bloc mmoire en noir et blanc (en fait, en tons de gris), avec prservation des
; alphas des couleurs (ici, au pire, il peut rester un pixel non trait si l'cran  un nombre de pixels impair...)
; note : MM0  MM6 sont modifis
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran  altrer}
; call Mmx_GriserEcran
;
; Retourne :
; rien
;
Mmx_GriserEcran PROC
		push edx									;; empiler edx
		push esi									;; empiler esi

		mov edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Taille_Du_Bloc_	;; placer la taille du bloc cran dans edx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse de dpart du bloc dans edi
; ici on traite les dwords
		and edx,11111111111111111111111111111000b		;; ne conserver que les qwords en edx (au pire, il ne restera qu'un dword...)
		jz Label2									;; si edx est gal  0, aller Label2
		add esi,edx								;; on ajoute edx  esi
		neg edx									;; inverser edx
		pxor MM0,MM0								;; MM0 = 0,0,0,0 , 0,0,0,0
		movq MM1,QWORD PTR _GMEE_Mmx_Masque_Alpha_		;; MM1 = A,0,0,0
		movq MM2,QWORD PTR _GMEE_Mmx_Masque_RVB_		;; MM2 = 0,R,V,B
Label1:	movq MM3,QWORD PTR [esi+edx]					;; MM3 = A,R,V,B
		movq MM5,MM3								;; MM5 = A,R,V,B
		pand MM5,MM2								;; MM5 = 0,R,V,B
		pand MM3,MM1								;; MM3 = A,0,0,0
		movq MM4,MM5								;; MM4 = 0,R,V,B
		punpcklbw MM4,MM0							;; MM4 = 0,0,0,R , 0,V,0,B
		punpckhbw MM5,MM0							;; MM5 = 0,0,0,R , 0,V,0,B
		movq MM6,MM4								;; MM6 = 0,0,0,R , 0,V,0,B
		pshufw MM4,MM4,0C6h							;; MM4 = 0,0,0,B , 0,V,0,R (ici c'est pour accentuer le vert, qui est visuellement la couleur dominante, comme a on pourra diviser par 4)
		paddd MM4,MM6								;; MM4 = 0+0 , R+B , V+V , R+B
		movq MM6,MM4								;; MM6 = 0+0 , R+B , V+V , R+B
		pshufw MM4,MM4,0D1h							;; MM4 = 0+0 , V+V , R+B , V+V
		paddd MM4,MM6								;; MM4 = 0+0+0+0 , R+V+V+B , R+V+V+B , R+V+V+B
		movq MM6,MM5								;; MM6 = 0,0,0,R , 0,V,0,B
		pshufw MM5,MM5,0C6h							;; MM5 = 0,0,0,B , 0,V,0,R (ici c'est pour accentuer le vert, qui est visuellement la couleur dominante, comme a on pourra diviser par 4)
		paddd MM5,MM6								;; MM5 = 0+0 , R+B , V+V , R+B
		movq MM6,MM5								;; MM6 = 0+0 , R+B , V+V , R+B
		pshufw MM5,MM5,0D1h							;; MM5 = 0+0 , V+V , R+B , V+V
		paddd MM5,MM6								;; MM5 = 0+0+0+0 , R+V+V+B , R+V+V+B , R+V+V+B
		psrlw MM5,2								;; MM5 = 0,0,0,R , 0,V,0,B
		psrlw MM4,2								;; MM4 = 0,0,0,R , 0,V,0,B
		packuswb MM4,MM5							;; MM4 = 0,R,V,B , 0,R,V,B
		por MM3,MM4								;; MM3 = A,R,V,B
		movq QWORD PTR [esi+edx],MM3					;; placer la couleur (le pixel)  l'adresse en esi+edx
		add edx,QWORD								;; on ajoute 4  edx (notre pas de boucle)
		jnz Label1								;; tant que edx est diffrent de 0, aller Label1
; ici on ne traite pas les octets puisqu'au minimum ce sont des dwords
Label2:
		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
Mmx_GriserEcran ENDP


ALIGN 16
;
; pastelliser les couleurs d'un bloc mmoire (les rapprocher du gris moyen), avec prservation des alphas des
; couleurs (ici, au pire, il peut rester un pixel non trait si l'cran  un nombre de pixels impair...)
; note : tous les registres MMx sont modifis
;
; Syntaxe :
; mov esi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran  altrer}
; call Mmx_PastelliserEcran
;
; Retourne :
; rien
;
Mmx_PastelliserEcran PROC
		push edx									;; empiler edx
		push esi									;; empiler esi

		mov edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Taille_Du_Bloc_	;; placer la taille du bloc cran dans edx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse de dpart du bloc dans edi
; ici on traite les dwords
		and edx,11111111111111111111111111111000b		;; ne conserver que les qwords en edx (au pire, il ne restera qu'un dword...)
		jz Label2									;; si edx est gal  0, aller Label2
		add esi,edx								;; on ajoute edx  esi
		neg edx									;; inverser edx
		pxor MM0,MM0								;; MM0 = 0,0,0,0 , 0,0,0,0
		movq MM1,QWORD PTR _GMEE_Mmx_Masque_Alpha_		;; MM1 = A,0,0,0
		movq MM2,QWORD PTR _GMEE_Mmx_Masque_RVB_		;; MM2 = 0,R,V,B
		movq MM3,QWORD PTR _GMEE_Mmx_Masque_Moitiee_unpck_	;; MM3 = 0,0,0,80h , 0,80h,0,80h
Label1:	movq MM4,QWORD PTR [esi+edx]					;; MM4 = A,R,V,B
		movq MM5,MM4								;; MM5 = A,R,V,B
		pand MM5,MM2								;; MM5 = 0,R,V,B
		pand MM4,MM1								;; MM4 = A,0,0,0
		movq MM6,MM5								;; MM6 = 0,R,V,B
		punpckhbw MM6,MM0							;; MM6 = 0,0,0,R , 0,V,0,B
		punpcklbw MM5,MM0							;; MM5 = 0,0,0,R , 0,V,0,B
; ici, a tend un peu trop sur le gris...
;		paddd MM5,MM3								;; MM5 = 0+0 , R+80h , V+80h , B+80h
;		paddd MM6,MM3								;; MM6 = 0+0 , R+80h , V+80h , B+80h
;		psrlw MM6,1								;; MM6 = 0,0,0,R , 0,V,0,B
;		psrlw MM5,1								;; MM5 = 0,0,0,R , 0,V,0,B
; alors on va plutt utiliser :
		movq MM7,MM5								;; MM7 = 0,0,0,R , 0,V,0,B
		paddd MM5,MM3								;; MM5 = 0+0 , R+80h , V+80h , B+80h
		paddd MM5,MM7								;; MM5 = 0+0 , R+R+80h , V+V+80h , B+B+B+80h
		paddd MM5,MM7								;; MM5 = 0+0 , R+R+R+80h , V+V+V+80h , B+B+B+80h
		movq MM7,MM6								;; MM7 = 0,0,0,R , 0,V,0,B
		paddd MM6,MM3								;; MM6 = 0+0 , R+80h , V+80h , B+80h
		paddd MM6,MM7								;; MM5 = 0+0 , R+R+80h , V+V+80h , B+B+80h
		paddd MM6,MM7								;; MM6 = 0+0 , R+R+R+80h , V+V+V+80h , B+B+B+80h
		psrlw MM6,2								;; MM6 = 0,0,0,R , 0,V,0,B
		psrlw MM5,2								;; MM5 = 0,0,0,R , 0,V,0,B
;
		packuswb MM5,MM6							;; MM5 = 0,R,V,B , 0,R,V,B
		por MM4,MM5								;; MM4 = A,R,V,B
		movq QWORD PTR [esi+edx],MM4					;; placer la couleur (le pixel)  l'adresse en esi+edx
		add edx,QWORD								;; on ajoute 4  edx (notre pas de boucle)
		jnz Label1								;; tant que edx est diffrent de 0, aller Label1
; ici on ne traite pas les octets puisqu'au minimum ce sont des dwords
Label2:
		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
Mmx_PastelliserEcran ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de redimensionnement (autre que *2)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Redimensionnement_Compteur_Lignes_		DWORD ?
_Redimensionnement_Hauteur_Ecran_			DWORD ?
_Redimensionnement_Largeur_Ecran_			DWORD ?
_Redimensionnement_Multiplicateur_Hauteur_	DWORD ?
_Redimensionnement_Multiplicateur_Largeur_	DWORD ?


.CODE
ALIGN 16
;
; crer et dfinir une table, pour retailler (changer l'echelle, pour eviter des multiplications et divisions
; multiples pendant le redimensionnement)
; note : ne pas oublier de supprimer la table de redimensionnement prcdente (s'il y en a une) avant d'en crer
; une nouvelle (le cumul injustifi causera un crash). et videment, il faut s'assurer qu'une instance mmoire a
; t cre
; NOTE : cette version turbo utilise des multiplicateurs "magiques", si ceux-ci manquent de prcision (arrondis)
; sur de grandes valeurs, il sont parfait pour de petites valeurs (sauf 0 et 1, l ca doit tre trait autrement).
; c'est test sans erreurs lorsque la valeur  diviser va de 0  65536, et que le diviseur va de de 2  65536
; (ce qui est amplement suffisant pour traiter des crans... ben ouip, des crans de plus de 65536 pixels en
; largeur ou en hauteur, ben j'en ai pas encore vu...)
; NOTE 2 : les "crans" de 0 ou 1 pixel en largeur ou en hauteur (ha... mais ils y en a qui en seraient capables)
; ne doivent pas tre traits par cette routine, mais par DefinirTableDeRedimensionnement
;
; Syntaxe :
; mov eax,{largeur de l'cran (en pixels) (la largeur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)}
; mov ebx,{hauteur de l'cran (en pixels) (la hauteur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)}
; mov ecx,{largeur de l'cran maximale (en pixels) (largeur de l'cran  afficher)}
; mov edx,{hauteur de l'cran maximale (en pixels) (hauteur de l'cran  afficher)}
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_ (parcequ'on en a besoin)}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de la table)}
; call DefinirTableDeRedimensionnement_Turbo
;
; Retourne :
; rien
;
DefinirTableDeRedimensionnement_Turbo PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde les entres, ca va reservir...
		mov _Redimensionnement_Largeur_Ecran_,eax		;; sauvegarder ecx dans _Redimensionnement_Largeur_Ecran_
		mov _Redimensionnement_Hauteur_Ecran_,ebx		;; sauvegarder edx dans _Redimensionnement_Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,ecx	;; sauvegarder ecx dans x._Largeur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,edx	;; sauvegarder edx dans x._Hauteur_Ecran_
; ici, on calcule nos multiplicateurs "magiques", pour la hauteur :
		mov ebx,edx								;; placer la hauteur dans ebx
		mov eax,0FFFFFFFFh							;; remplir le registre eax
		xor edx,edx								;; effacer edx pour la division qui suit
		div ebx									;; diviser eax par la hauteur
		inc eax									;; augmenter le rsultat obtenu de 1 (pour faire passer virtuellement FFFFFFFF  100000000)
		mov _Redimensionnement_Multiplicateur_Hauteur_,eax	;; sauvegarder le multiplicateur obtenu
; pour la largeur :
		mov ebx,ecx								;; placer la largeur dans ebx
		mov eax,0FFFFFFFFh							;; remplir le registre eax
		xor edx,edx								;; effacer edx pour la division qui suit
		div ebx									;; diviser eax par la largeur
		inc eax									;; augmenter le rsultat obtenu de 1 (pour faire passer virtuellement FFFFFFFF  100000000)
		mov _Redimensionnement_Multiplicateur_Largeur_,eax	;; sauvegarder le multiplicateur obtenu
; puis on calcul la taille mmoire  allouer...
		mov eax,ecx								;; placer la largeur maximale dans eax
		shl eax,2									;; multiplier x._Largeur_Ecran_ par 4 (1 dword)
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_,eax	;; placer eax dans x._Largeur_Ecran_X4_
		mul (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; multiplier x._Largeur_Ecran_*DWORD par x._Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h							;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
; on alloue l'espace mmoire (qui est en fait gal  la taille cran) pour la table (ce sera la zone de substitution de valeur)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
;		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Dbuffer_,eax	;; sauvegarder eax dans x._Pointeur_Dbuffer_
;		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Zbuffer_,eax	;; sauvegarder eax dans x._Pointeur_Zbuffer_ (ca vite des dsagrments de mauvaise utilisation CreerEcran/CreerEcranAvecZBuffer)
;		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_LimitesFace_,eax	;; sauvegarder eax dans x._Pointeur_LimitesFace_
; maintenant on va remplir chaque valeur de la premire ligne de notre table de substitution par la position relative dans l'cran originel
		mov esi,eax								;; copier x._Pointeur_ dans esi
;		mov ebx,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_	;; placer x._Largeur_Ecran_ dans ebx
		xor ecx,ecx								;; effacer ecx
; ici, on calcule les valeurs de substitution de la largeur
Label1:	mov eax,ecx								;; copier ecx dans eax
		mul _Redimensionnement_Largeur_Ecran_			;; multiplier eax par _Redimensionnement_Largeur_Ecran_
		mul _Redimensionnement_Multiplicateur_Largeur_	;; diviser par la largeur
		shl edx,2									;; multiplier le rsultat obtenu en edx par 4
		mov DWORD PTR [4*ecx+esi],edx					;; et le placer dans le dword en 4*ecx+esi
		inc ecx									;; incrmenter le pas de boucle
		cmp ecx,ebx								;; comparer ecx  x._Largeur_Ecran_
		jb Label1									;; tant que ecx est infrieur  x._Largeur_Ecran_, aller Label1
; ici, la premire ligne est calcule, on va la recopier dans toutes les autres lignes
		shl ebx,2									;; multiplier ebx par 4
		mov ebp,esi								;; recopier l'adresse en esi dans ebp
		add ebp,ebx								;; ajouter l'uivalent d'une ligne  ebp
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; placer x._Hauteur_Ecran_ (le nombre de lignes) dans eax
		dec eax									;; enlever une ligne  eax (ben oui, on en a dja calcul une...)
		neg eax									;; inverser eax
; ici on traite les owords
Label2:	mov ecx,ebx								;; copier x._Largeur_Ecran_ x4 dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add esi,ecx								;; on ajoute ecx  esi
		add ebp,ecx								;; et aussi  ebp, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label3:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR [ebp+ecx],edx					;; placer le dword en ebp+ecx
		mov edx,DWORD PTR [esi+ecx+4]					;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR [ebp+ecx+4],edx					;; placer le dword en ebp+ecx+4
		mov edx,DWORD PTR [esi+ecx+8]					;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR [ebp+ecx+8],edx					;; placer le dword en ebp+ecx+8
		mov edx,DWORD PTR [esi+ecx+12]				;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR [ebp+ecx+12],edx				;; placer le dword en ebp+ecx+12
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; ici on traite les dwords
Label4:	mov ecx,ebx								;; copier x._Largeur_Ecran_ x4 dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label6									;; si ecx est gal  0, aller Label6
		add esi,ecx								;; on ajoute ecx  esi
		add ebp,ecx								;; et aussi  ebp, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label5:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+edx dans edx
		mov DWORD PTR [ebp+ecx],edx					;; et le recopier en ebp+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label5								;; tant que ecx est sign, aller Label5
; ici on ne traite pas les octets (car au minimum ce sont des dwords)

Label6:	sub esi,ebx								;; soustraire la ligne copie  esi (pour retrouver l'adresse originelle)
		inc eax									;; incrmenter eax
		jnz Label2								;; tant que eax est diffrent de 0, aller Label2
; ici, notre table est remplie de premires ligne, on initialise la boucle pour la hauteur
		xor ecx,ecx								;; mettre ecx  0
; ici, on calcule les valeurs de substitution de la hauteur
Label7:	mov eax,ecx								;; copier ecx dans eax
		mul _Redimensionnement_Hauteur_Ecran_			;; multiplier eax par _Redimensionnement_Hauteur_Ecran_
		mul _Redimensionnement_Multiplicateur_Hauteur_	;; diviser par la hauteur
		mov eax,edx								;; placer le rsultat obtenu en edx dans eax
		mul _Redimensionnement_Largeur_Ecran_			;; et multiplier le rsultat en eax par une largeur de ligne
		shl eax,2									;; on multiplie eax par 4 (comme ca on a multipli par Largeur de ligne x4)
; ici, la hauteur est dfinie, on l'ajoute sur toutes les valeurs de la ligne, on traite les owords
		mov ebp,ebx								;; copier x._Largeur_Ecran_ x4 dans ebp
		and ebp,11111111111111111111111111110000b		;; ne conserver que les bits owords en ebp
		jz Label9									;; si ebp est gal  0, aller Label9
		add esi,ebp								;; on ajoute ebp  esi
		neg ebp									;; inverser ebp
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label8:	add DWORD PTR [esi+ebp],eax					;; placer le dword en esi+ebp
		add DWORD PTR [esi+ebp+4],eax					;; placer le dword en esi+ebp+4
		add DWORD PTR [esi+ebp+8],eax					;; placer le dword en esi+ebp+8
		add DWORD PTR [esi+ebp+12],eax				;; placer le dword en esi+ebp+12
		add ebp,16								;; on ajoute 16  ebp (notre pas de boucle)
		jnz Label8								;; tant que ebp est diffrent de 0, aller Label8
; ici on traite les dwords
Label9:	mov ebp,ebx								;; copier x._Largeur_Ecran_ x4 dans ebp
		and ebp,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ebp
		jz Label11								;; si ebp est gal  0, aller Label11
		add esi,ebp								;; on ajoute ebp  esi
		neg ebp									;; inverser ebp
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label10:	add DWORD PTR [esi+ebp],eax					;; placer le dword en esi+ebp
		add ebp,4									;; on ajoute 4  ebp (notre pas de boucle)
		jnz Label10								;; tant que ebp est sign, aller Label10
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label11:	inc ecx									;; incrmenter le pas de boucle
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; comparer ecx  x._Hauteur_Ecran_
		jb Label7									;; tant que ecx est infrieur  x._Hauteur_Ecran_, aller Label7

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DefinirTableDeRedimensionnement_Turbo ENDP


ALIGN 16
;
; dfinir les tailles de redimensionnement proportionnel
; note : il faut s'assurer que eax et ebx sont diffrents de 0, sinon il y aura division par 0...)
;
; Syntaxe :
; mov eax,{largeur de l'cran (en pixels)}
; mov ebx,{hauteur de l'cran (en pixels)}
; mov ecx,{largeur maximale de l'cran (en pixels)}
; mov edx,{hauteur maximale de l'cran (en pixels)}
; call DefinirTaillesRedimensionnement
;
; Retourne :
; ecx = largeur de l'image/l'cran que l'on veut obtenir
; edx = hauteur de l'image/l'cran que l'on veut obtenir
;
DefinirTaillesRedimensionnement PROC
		push eax									;; empiler eax
		push esi									;; empiler esi
		push edi									;; empiler edi

; on regarde si la largeur redimensionne est infrieure  la lageur maxi
		mov esi,eax								;; copier la largeur dans esi
		mov edi,edx								;; copier la hauteur maxi dans edi
		mul edi									;; multiplier la largeur par la hauteur maxi
		xor edx,edx								;; ) diviser par la hauteur
		div ebx									;; )
		cmp eax,ecx								;; comparer la largeur obtenue  la largeur maxi
		jl Label01								;; si c'est infrieur, aller Label01
; sinon, c'est que c'est la hauteur redimensionne qui est infrieure  la hauteur maxi
		mov eax,ebx								;; sinon, placer la hauteur dans eax
		mul ecx									;; multiplier par la largeur maxi
		xor edx,edx								;; ) diviser par la largeur
		div esi									;; )
		mov edx,eax								;; placer la hauteur obtenue dans edx
		jmp Label02								;; aller Label02

Label01:	mov ecx,eax								;; placer la largeur obtenue dans ecx
		mov edx,edi								;; replacer la hauteur maxi dans edx
Label02:
		pop edi									;; dsempiler edi
		pop esi									;; dsempiler esi
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
DefinirTaillesRedimensionnement ENDP


ALIGN 16
;
; retailler un cran (en fait on va substituer des valeurs  d'autres, pour eviter des multiplications et divisions multiples)
; videment, une table doit, au pralable, avoir t dfinie avec DefinirTableDeRedimensionnement
;
; Syntaxe :
; mov eax,{adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de la table)}
; mov esi,{adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran originel)}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran final)}
; call Redimensionner
;
; Retourne :
; rien
;
Redimensionner PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [eax])._Pointeur_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_ dans ebx
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [eax])._Hauteur_Ecran_	;; placer x._Hauteur_Ecran_ dans ebp
		mov eax,(_Bloc_Memoire_Ecran_ PTR [eax])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_ dans eax
		mov _Redimensionnement_Compteur_Lignes_,ebp		;; dfinir le compteur de lignes
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur source dans esi
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_ de l'cran destination dans ebp 
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer le pointeur destination dans edi
		sub ebp,eax								;; dfinir le complment (en pixels*dword) d'une ligne destination
; ici, on traite les owords
Label0:	mov ecx,eax								;; placer x._Largeur_Ecran_X4_ dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label2									;; si ecx est gal  0, aller Label2
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
		nop										;; ) alignement ncessaire pour un meilleur rendement
Label1:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		mov edx,DWORD PTR [ebx+ecx+4]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+4],edx					;; et la recopier dans edi+ecx+4
		mov edx,DWORD PTR [ebx+ecx+8]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+8],edx					;; et la recopier dans edi+ecx+8
		mov edx,DWORD PTR [ebx+ecx+12]				;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+12],edx				;; et la recopier dans edi+ecx+12
		add ecx,16								;; augmenter ecx d'1 oword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
; ici, on traite les dwords
Label2:	mov ecx,eax								;; placer x._Largeur_Ecran_X4_ dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
Label3:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		add ecx,4									;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; on ne traite pas les octets car il ne peut y avoir que des dwords (alpha,rouge,vert,bleu) au minimum
Label4:
		add edi,ebp								;; ajouter le complment de ligne de l'cran de destination  edi
		dec _Redimensionnement_Compteur_Lignes_			;; dcrmenter notre comteur de ligne de pixels trait
		jnz Label0								;; tant que c'est diffrent de 0, aller Label0

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Redimensionner ENDP


ALIGN 16
;
; supprimer une table de redimensionnement
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Syntaxe :
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)}
; call SupprimerTableDeRedimensionnement
;
; Retourne :
; rien
;
SupprimerTableDeRedimensionnement PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerTableDeRedimensionnement ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines capture cran
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
; les pointeurs
_Capturer_Pointeur_DC_Temporaire_		HDC ?
_Capturer_Pointeur_DC_Compatible_		HDC ?
_Capturer_Pointeur_Fichier_Temporaire_	HANDLE ?
_Capturer_Pointeur_Nouveau_Dib_		HBITMAP ?
_Capturer_Pointeur_Pixels_A_Capturer_	DWORD ?
; la structure du fichier
_Capturer_Entete_Fichier_Bitmap_		BITMAPFILEHEADER <?>
; note : la structure BITMAPINFO est dcompose, parcequ'il semble qu'il y ai des difficults pour assembler
; du code lorsque la premire valeur d'une structure est une autre structure...
_Capturer_Entete_Informations_Bitmap_	BITMAPINFOHEADER <?>
_Capturer_Palette_					RGBQUAD 256 dup (<?>)	;; strucutre RGBQUAD * 256
; les pixels
_Capturer_Nombre_BitsParPixels_		DWORD ?
_Capturer_Largeur_Capture_			DWORD ?
_Capturer_Hauteur_Capture_			DWORD ?
_Capturer_Taille_Bitmap_				DWORD ?
; la palette
_Capturer_Nombre_Couleurs_			DWORD ?
_Capturer_Taille_Palette_			DWORD ?
; divers
_Capturer_Numero_Capture_			DWORD ?
_Capturer_Complement_Alignement_		DWORD ?
_Capturer_Octets_Ecrits_				DWORD ?

_Capturer_Chaine_Display_				BYTE "DISPLAY",0
_Capturer_Chaine_Chemin_					BYTE MAX_PATH dup (?)	;; MAX_PATH = 260
_Capturer_Chaine_Validation_Chemin_		BYTE "\",0
_Capturer_Chaine_Nom_Chemin_				BYTE MAX_PATH dup (?)	;; MAX_PATH = 260
_Capturer_Chaine_Nom_Fichier_				BYTE "CaptureEcran",0
_Capturer_Chaine_Numero_Capture_			BYTE 0,0,0,0,0,0,0,0,0,0,0,0
_Capturer_Chaine_Extension_Bmp_			BYTE ".bmp",0
_Capturer_Chaine_Production_				BYTE "NightWare Production",0
_Capturer_Chaine_Alignement_				BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;_Capturer_Chaine_PasDeviceContext_			BYTE "Ne parviens pas  crer un device context.",0
;_Capturer_Chaine_PasDeviceCompatible_		BYTE "Ne parviens pas  crer un device context compatible.",0
;_Capturer_Chaine_PasBitmapCompatible_		BYTE "Ne parviens pas  crer un bitmap compatible.",0
;_Capturer_Chaine_PasSelectionnerBitmap_		BYTE "Ne parviens pas  slectionner le bitmap.",0
;_Capturer_Chaine_PasCopierBitmap_			BYTE "Ne parviens pas  copier le bitmap.",0
;_Capturer_Chaine_PasSauvegarderFichierBmp_	BYTE "Ne Parviens pas  sauvegarder le fichier bmp.",0
;_Capturer_Chaine_Travail_Effectue_			BYTE "L'cran a t captur et sauvegard.",0


.CODE
ALIGN 16
;
; capturer l'cran en cours, et le sauvegarder en fichier bmp
; ATTENtION : l'cran sauvegard possde les proprits de l'cran affich lors de la capture
; (1, 4, 8, 16, 24 ou 32 bits), il faut donc configurer l'affichage en fonction du rsultat voulu.
;
; Syntaxe :
; call CapturerEcran
;
; Retourne :
; rien, mais l'cran a t sauvegard (si aucun problme n'est survenu...)
;
CapturerEcran PROC

		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; lier le chemin et le nom du fichier
		mov esi,OFFSET _Capturer_Chaine_Chemin_			;; ) copier le chemin
		mov edi,OFFSET _Capturer_Chaine_Nom_Chemin_		;; )
		call Mmx_CopierChaineAscii					;; )
		mov esi,OFFSET _Capturer_Chaine_Nom_Fichier_		;;	) ajouter le nom du fichier
		add edi,eax								;;	)
		call FusionnerChainesAscii					;;	)
		add edi,eax								;; ajouter eax  edi ici, puisqu'on a dj la valeur
		mov eax,_Capturer_Numero_Capture_				;; ) convertir le numro de capture en chane
		mov esi,OFFSET _Capturer_Chaine_Numero_Capture_	;; )
		call ConvertirValeurEnChaineDecimale			;; )
		mov esi,OFFSET _Capturer_Chaine_Numero_Capture_	;;	) ajouter le numro de capture
		call FusionnerChainesAscii					;;	)
		mov esi,OFFSET _Capturer_Chaine_Extension_Bmp_	;; ) ajouter l'extension bmp
		add edi,eax								;; )
		call FusionnerChainesAscii					;; )
; crer un device context temporaire
;		mov ebp,OFFsET _Capturer_Chaine_PasDeviceContext_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke CreateDC,ADDR _Capturer_Chaine_Display_,NULL,NULL,NULL
		test eax,eax								;; fixer les flags de eax
		jz PasDeviceContext							;; si eax est gal  0 (erreur cration DC), aller PasDeviceContext
		mov _Capturer_Pointeur_DC_Temporaire_,eax		;; sauvegarder le pointeur obtenu
; obtenir les informations de l'cran  capturer
		invoke GetDeviceCaps,_Capturer_Pointeur_DC_Temporaire_,HORZRES	;; ) obtenir la largeur de l'cran
		mov _Capturer_Largeur_Capture_,eax							;; )
		invoke GetDeviceCaps,_Capturer_Pointeur_DC_Temporaire_,VERTRES	;;	) obtenir la hauteur de l'cran
		mov _Capturer_Hauteur_Capture_,eax							;;	)
		invoke GetDeviceCaps,_Capturer_Pointeur_DC_Temporaire_,BITSPIXEL	;; ) obtenir la profondeur (en plans) de l'cran
		mov _Capturer_Nombre_BitsParPixels_,eax						;; )
		cmp eax,8									;; comparer le nombre de bits par pixels  8
		ja PlusDe256Couleurs						;; si c'est suprieur, aller PlusDe256Couleurs
		invoke GetDeviceCaps,_Capturer_Pointeur_DC_Temporaire_,NUMCOLORS	;; sinon, rcuprer le nombre de couleurs
;		mov _Capturer_Nombre_Couleurs_,eax				;; ) ici, -1 peut etre retourn si il y a moins de 256 couleurs et une profondeur suprieur,
		mov _Capturer_Nombre_Couleurs_,256				;; ) on va donc mettre une palette de 256 couleurs par dfaut
		jmp NombreDeCouleursDefini					;; aller NombreDeCouleursDefini
PlusDe256Couleurs:
		mov _Capturer_Nombre_Couleurs_,0				;; placer 0 dans _Capturer_Nombre_Couleurs_ (plus rapide pour savoir s'il y a plus de 256 couleurs)
NombreDeCouleursDefini:
; crer un devic context compatible
;		mov ebp,OFFsET _Capturer_Chaine_PasDeviceCompatible_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke CreateCompatibleDC,_Capturer_Pointeur_DC_Temporaire_
		test eax,eax								;; fixer les flags de eax
		jz PasDeviceCompatible						;; si eax est gal  0 (erreur cration DC), aller PasDeviceCompatible
		mov _Capturer_Pointeur_DC_Compatible_,eax		;; sauvegarder le pointeur obtenu
; remplir la structure BITMAPINFOHEADER
		mov _Capturer_Entete_Informations_Bitmap_.biSize,SIZEOF BITMAPINFOHEADER	;; placer la taiile de la structure BITMAPINFOHEADER
		mov eax,_Capturer_Largeur_Capture_					;; ) placer la largeur
		mov _Capturer_Entete_Informations_Bitmap_.biWidth,eax	;; )
		mov eax,_Capturer_Hauteur_Capture_					;;	) placer la hauteur
		mov _Capturer_Entete_Informations_Bitmap_.biHeight,eax	;;	)
		mov _Capturer_Entete_Informations_Bitmap_.biPlanes,1	;; nombre de plans (doit tre gal  1)
		mov eax,_Capturer_Nombre_BitsParPixels_					;; ) placer le nombre de bits par pixels
		mov _Capturer_Entete_Informations_Bitmap_.biBitCount,ax	;; )
		mov _Capturer_Entete_Informations_Bitmap_.biCompression,BI_RGB	;; placer le format non comprss
		mov _Capturer_Entete_Informations_Bitmap_.biSizeImage,0	;; ) s'assurer que c'est vide
		mov _Capturer_Entete_Informations_Bitmap_.biXPelsPerMeter,0	;; )
		mov _Capturer_Entete_Informations_Bitmap_.biYPelsPerMeter,0	;; )
		mov eax,_Capturer_Nombre_Couleurs_						;;	) placer le nombre de couleurs
		mov _Capturer_Entete_Informations_Bitmap_.biClrUsed,eax	;;	)
		mov _Capturer_Entete_Informations_Bitmap_.biClrImportant,eax	;; placer le nombre des couleurs importantes
; crer un DIB
		invoke CreateDIBSection,_Capturer_Pointeur_DC_Temporaire_,ADDR _Capturer_Entete_Informations_Bitmap_,DIB_PAL_COLORS,ADDR _Capturer_Pointeur_Pixels_A_Capturer_,NULL,0
		test eax,eax								;; fixer les flags de eax
		jz PasBitmapCompatible						;; si eax est gal  0 (erreur cration DIB), aller PasBitmapCompatible
		mov _Capturer_Pointeur_Nouveau_Dib_,eax			;; sauvegarder le pointeur du nouveau DIB (dont les pixels se situent  l'adresse _Capturer_Pointeur_Pixels_A_Capturer_)
; slectionner l'objet
;		mov ebp,OFFsET _Capturer_Chaine_PasSelectionnerBitmap_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke SelectObject,_Capturer_Pointeur_DC_Compatible_,_Capturer_Pointeur_Nouveau_Dib_
		test eax,eax								;; fixer les flags de eax
		jz PasBitmapCompatible						;; si eax est gal  0 (erreur de selection), aller PasBitmapCompatible
		cmp eax,GDI_ERROR							;; comparer eax  GDI_ERROR
		je PasBitmapCompatible						;; si c'est une erreur GDI, aller PasBitmapCompatible
; ici, on va tester si la rcupration des pixels est possible
;		mov ebp,OFFsET _Capturer_Chaine_PasCopierBitmap_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke BitBlt,_Capturer_Pointeur_DC_Compatible_,0,0,_Capturer_Largeur_Capture_,_Capturer_Hauteur_Capture_,_Capturer_Pointeur_DC_Temporaire_,0,0,SRCCOPY
		test eax,eax								;; fixer les flags de eax
		jz PasBitmapCompatible						;; si eax est gal  0 (erreur de copie), aller PasBitmapCompatible
; rcuprer la palette (si c'est ncessaire)
		mov eax,_Capturer_Nombre_Couleurs_				;; placer le nombre de couleurs dans eax
		test eax,eax								;; fixer les flags de eax
		jz EviterRecupererPalette					;; si le nombre de couleurs est gal  0, aller EviterRecupererPalette
		invoke GetDIBColorTable,_Capturer_Pointeur_DC_Compatible_,0,_Capturer_Nombre_Couleurs_,ADDR _Capturer_Palette_
		mov _Capturer_Nombre_Couleurs_,eax				;; mise  jour du nombre de couleurs
EviterRecupererPalette:
; dfinir la taille de la palette
		mov eax,SIZEOF RGBQUAD						;; placer la taille de la structure RGBQUAD dans eax
		mul _Capturer_Nombre_Couleurs_				;; multiplier cette taille par le nombre de couleurs
		mov _Capturer_Taille_Palette_,eax				;; sauvegarder la taille de la palette
; dfinir la taille de l'entete du fichier  sauvegarder
		mov ebx,SIZEOF BITMAPFILEHEADER				;; placer la taille de l'entete dans ebx
		add ebx,SIZEOF BITMAPINFOHEADER				;; ajouter les informations
		add ebx,_Capturer_Taille_Palette_				;; ajouter la taille de la palette
		add ebx,(SIZEOF _Capturer_Chaine_Production_)-1	;; ajouter la chane concernant la production (moins le zro final)
		xor ecx,ecx								;; ) obtenir le complment pour un alignement sur 16 octets
		mov edx,ebx								;; )
		and edx,00000000Fh							;; )
		jz AlignementInutile						;; )
		mov ecx,000000010h							;; )
		sub ecx,edx								;; )
AlignementInutile:
		mov _Capturer_Complement_Alignement_,ecx		;; sauvegarder la taille du complment
		add ebx,ecx								;; ajouter le complement pour l'alignement
; dfinir la taille du bitmap du fichier  sauvegarder
		mov eax,_Capturer_Nombre_BitsParPixels_			;; lire le nombre de bits par pixels
		mul _Capturer_Largeur_Capture_				;; multiplier cette valeur par la largeur du bitmap
		mul _Capturer_Hauteur_Capture_				;; multiplier le rsultat par la hauteur du bitmap
		shr eax,3									;; diviser le rsultat par 8 (pour avoir la taille en octets)
		mov _Capturer_Taille_Bitmap_,eax				;; sauvegarder la taille du bitmap (reservira plus tard)
; dfinir la taille complte du fichier  sauvegarder
		add eax,ebx								;; ajouter l'entete du fichier
; remplir la structure BITMAPFILEHEADER
		mov _Capturer_Entete_Fichier_Bitmap_.bfType,4D42h	;; placer "MB" pour BitMap
		mov _Capturer_Entete_Fichier_Bitmap_.bfSize,eax	;; sauvegarder la taille du fichier
		mov _Capturer_Entete_Fichier_Bitmap_.bfReserved1,0	;; ) s'assurer que c'est vide
		mov _Capturer_Entete_Fichier_Bitmap_.bfReserved2,0	;; )
		mov _Capturer_Entete_Fichier_Bitmap_.bfOffBits,ebx	;; sauvegarder la taille de l'entte (pour pouvoir retrouver l'emplacement des pixels)
; une fois toutes les valeurs initialises, on va sauvegarder
;		mov ebp,OFFsET _Capturer_Chaine_PasSauvegarderFichierBmp_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke CreateFile,ADDR _Capturer_Chaine_Nom_Chemin_,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		cmp eax,INVALID_HANDLE_VALUE					;; comparer le pointeur obtenu  INVALID_HANDLE_VALUE
		je MessagePasSauvegarderFichierBmp				;; si c'est le cas, aller MessagePasSauvegarderFichierBmp
		mov _Capturer_Pointeur_Fichier_Temporaire_,eax	;; sinon, sauvegarder le _Capturer_Pointeur_Fichier_Temporaire_
; sauvegarder l'entte du fichier bmp
		invoke WriteFile,_Capturer_Pointeur_Fichier_Temporaire_,ADDR _Capturer_Entete_Fichier_Bitmap_,SIZEOF BITMAPFILEHEADER,ADDR _Capturer_Octets_Ecrits_,NULL
; sauvegarder les informations du fichier bmp 
		invoke WriteFile,_Capturer_Pointeur_Fichier_Temporaire_,ADDR _Capturer_Entete_Informations_Bitmap_,SIZEOF BITMAPINFOHEADER,ADDR _Capturer_Octets_Ecrits_,NULL
; sauvegarder (ventuellement) la palette du fichier bmp
		cmp _Capturer_Nombre_Couleurs_,0				;; comparer le nombre de couleurs  0
		je EviterSauvegarderPalette					;; si c'est le cas, aller EviterSauvegarderPalette
		invoke WriteFile,_Capturer_Pointeur_Fichier_Temporaire_,ADDR _Capturer_Palette_,_Capturer_Taille_Palette_,ADDR _Capturer_Octets_Ecrits_,NULL
EviterSauvegarderPalette:
; sauvegarder l'information de production 
		invoke WriteFile,_Capturer_Pointeur_Fichier_Temporaire_,ADDR _Capturer_Chaine_Production_,(SIZEOF _Capturer_Chaine_Production_)-1,ADDR _Capturer_Octets_Ecrits_,NULL
; sauvegarder le complment ncessaire  un alignement sur 16 octets (ce qui permettra d'utiliser ultrieurement les instructions simd directement sur les pixels)
		invoke WriteFile,_Capturer_Pointeur_Fichier_Temporaire_,ADDR _Capturer_Chaine_Alignement_,_Capturer_Complement_Alignement_,ADDR _Capturer_Octets_Ecrits_,NULL
; sauvegarder les pixels du fichier bmp 
		invoke WriteFile,_Capturer_Pointeur_Fichier_Temporaire_,_Capturer_Pointeur_Pixels_A_Capturer_,_Capturer_Taille_Bitmap_,ADDR _Capturer_Octets_Ecrits_,NULL
		invoke CloseHandle,_Capturer_Pointeur_Fichier_Temporaire_	;; supprimer _Capturer_Pointeur_Fichier_Temporaire_ (qui est devenu inutile...)
		inc _Capturer_Numero_Capture_					;; incrmenter le numro de la capture
;		invoke MessageBox,0,ADDR _Capturer_Chaine_Travail_Effectue_,NULL,0	;; n'activer que si l'on a besoin d'un message de confirmation
; on fini en supprimant ce qui a t temporairement utilis
		invoke DeleteObject,_Capturer_Pointeur_Nouveau_Dib_	;; ) supprimer les pointeurs/devices devenus inutiles
		invoke DeleteDC,_Capturer_Pointeur_DC_Compatible_		;; )
		invoke DeleteDC,_Capturer_Pointeur_DC_Temporaire_		;; )
Sortie:
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)

; la sortie, si une erreur est survenue
MessagePasSauvegarderFichierBmp:
		invoke DeleteObject,_Capturer_Pointeur_Nouveau_Dib_	;; ) supprimer les pointeurs/devices devenus inutiles
PasBitmapCompatible:									;; )
		invoke DeleteDC,_Capturer_Pointeur_DC_Compatible_		;; )
PasDeviceCompatible:									;; )
		invoke DeleteDC,_Capturer_Pointeur_DC_Temporaire_		;; )
PasDeviceContext:
;		invoke MessageBox,0,ebp,NULL,0
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
CapturerEcran ENDP


ALIGN 16
;
; dfinir le rpertoire des captures cran, (le rpertoire en cours)
;
; Syntaxe :
; call DefinirRepertoireCapture
;
; Retourne :
; rien
;
DefinirRepertoireCapture PROC

		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		invoke GetCurrentDirectory,MAX_PATH,ADDR _Capturer_Chaine_Chemin_
		mov esi,OFFSET _Capturer_Chaine_Validation_Chemin_
		mov edi,OFFSET _Capturer_Chaine_Chemin_
		call FusionnerChainesAscii

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DefinirRepertoireCapture ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines chargement/sauvegarde
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Fichier_Octets_Lus_					DWORD ?
_Fichier_Pointeur_Fichier_Temporaire_		DWORD ?
_Fichier_Octets_Ecrits_					DWORD ?
_Fichier_Complement_Alignement_			DWORD ?

_Fichier_Chaine_Chemin_Temporaire_			BYTE MAX_PATH dup (?)	;; MAX_PATH = 260
_Fichier_Chaine_Chemin_Temporaire_Ajout		BYTE "\Fichier",0
_Fichier_Chaine_Production_				BYTE "NightWare Production",0
_Fichier_Chaine_Alignement_				BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;Chaine_Filtre_De_Selection_Fichiers			BYTE "Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Clefs		BYTE "Clefs de cryptage/dcryptage (*.cuk)",0,"*.cuk",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Compresses	BYTE "Fichiers compresss (*.7z,*.lha,*.rar,*.zip)",0,"*.7z;*.lha;*.rar;*.zip",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Cryptes		BYTE "Fichiers crypts (*.crypted)",0,"*.crypted",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Donnees		BYTE "Donnes (*.dat,*.raw)",0,"*.dat;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Executables	BYTE "Executables (*.exe,*.hlp)",0,"*.exe;*.hlp",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Images		BYTE "Images (*.bmp,*.gif,*.jpg,*.raw)",0,"*.bmp;*.gif;*.jpg;*.raw",0,"Tous fichiers (*.*)",0,"*.*",0,0
;Chaine_Filtre_De_Selection_Fichiers_Textes		BYTE "Textes (*.asm,*.doc,*.inc,*.txt,*.x)",0,"*.asm;*.doc;*.inc;*.txt;*.x",0,"Tous fichiers (*.*)",0,"*.*",0,0

;Chaine_Extension_Clef_Par_Defaut			BYTE "cuk",0		;; abbrviation de "crypt uncrypt key"
;Chaine_Extension_Compresse_Par_Defaut		BYTE "zip",0
;Chaine_Extension_Crypte_Par_Defaut			BYTE "crypted",0	;; fichier crypt
;Chaine_Extension_Donnees_Par_Defaut		BYTE "dat",0
;Chaine_Extension_Executable_Par_Defaut		BYTE "exe",0
;Chaine_Extension_Image_Par_Defaut			BYTE "bmp",0
;Chaine_Extension_Texte_Par_Defaut			BYTE "txt",0
;
;Chaine_Type_De_Selection_Chargement_Fichier	BYTE "Dfinissez le fichier  charger.",0
;Chaine_Type_De_Selection_Sauvegarde_Fichier	BYTE "Dfinissez le fichier  sauvegarder.",0
;Chaine_Type_De_Selection_Chargement_Clef	BYTE "Dfinissez la clef  charger.",0
;Chaine_Type_De_Selection_Sauvegarde_Clef	BYTE "Dfinissez la clef  sauvegarder.",0

; les messages d'erreur
;_Fichier_Chaine_Message_Erreur_NonSelection_			BYTE "aucun fichier n'a t slectionn !",0
;_Fichier_Chaine_Message_Erreur_Taille_				BYTE "le fichier est trop volumineux !",0

ALIGN 16
_Fichier_Information_Selection_ OPENFILENAME <?>
;OPENFILENAME STRUCT
;	lStructSize		DWORD ?						;; taille de la structure (en octets)
;	hwndOwner			DWORD ?						;; intance de la fentre (HWnd)
;	hInstance			DWORD ?						;; intance d'une fenetre personalise (le flag OFN_ENABLETEMPLATEHANDLE doit tre slectionn)
;	lpstrFilter		DWORD ?						;; pointeur contenant une paire de filtre
;	lpstrCustomFilter	DWORD ?						;; pointeur contenant une paire de filtre personnalis (ignor si = 0)
;	nMaxCustFilter		DWORD ?						;; taille en octets des filtres personnalis (ignor si = 0)
;	nFilterIndex		DWORD ?						;; n du filtre par dfaut (le numro est fonction de l'ordre des filtres)
;	lpstrFile			DWORD ?						;; pointeur d'une chane (drive/chemin/fichier.extension)
;	nMaxFile			DWORD ?						;; taille maximale en octets de la chane (drive/chemin/fichier.extension)
;	lpstrFileTitle		DWORD ?						;; pointeur d'une chane (fichier.extension)
;	nMaxFileTitle		DWORD ?						;; taille maximale en octets de la chane (fichier.extension) (ignor si = 0)
;	lpstrInitialDir	DWORD ?						;; pointeur sur la chane (drive/chemin) (ou rpertoire actuel si = 0)
;	lpstrTitle		DWORD ?						;; pointeur de la chane qui apparaitra comme titre dans la barre de la boite de dialogue
;	Flags			DWORD ?						;; flags d'initialisation de la boite de dialogue
;	nFileOffset		WORD ?						;; position o se situe le nom du fichier dans la chane (drive/chemin/fichier.extension)
;	nFileExtension		WORD ?						;; position o se situe l'extension dans la chane (drive/chemin/fichier.extension)
;	lpstrDefExt		DWORD ?						;; pointeur d'une chane extension (sans le point) par dfaut qui sera appliqu si l'utilisateur n'en entre pas (ignor si = 0)
;	lCustData			DWORD ?						;; (ignor si lpfnHook est inactif)
;	lpfnHook			DWORD ?						;; (ignor si OFN_ENABLEHOOK n'est pas slectionn)
;	lpTemplateName		DWORD ?						;; (ignor si OFN_ENABLETEMPLATE n'est pas slectionn)
;OPENFILENAME ENDS

ALIGN 16
_Fichier_Information_Fichier_ WIN32_FIND_DATA <?>
;WIN32_FIND_DATA STRUCT
;	dwFileAttributes	DWORD ?						;; attributs du fichier ou du rpertoire
;; (FILE_ATTRIBUTE_ARCHIVE, FILE_ATTRIBUTE_COMPRESSED, FILE_ATTRIBUTE_DIRECTORY, FILE_ATTRIBUTE_HIDDEN,
;; FILE_ATTRIBUTE_NORMAL, FILE_ATTRIBUTE_OFFLINE, FILE_ATTRIBUTE_READONLY, FILE_ATTRIBUTE_SYSTEM, FILE_ATTRIBUTE_TEMPORARY)
;	ftCreationTime		FILETIME <?>					;; date concernant la cration du fichier
;	ftLastAccessTime	FILETIME <?>					;; date concernant le dernier accs au fichier
;	ftLastWriteTime	FILETIME <?>					;; date concernant la dernire modification du fichier
;	nFileSizeHigh		DWORD ?						;; ) taille du fichier
;	nFileSizeLow		DWORD ?						;; )
;	dwReserved0		DWORD ?						;;	) inutiliss pour le moment
;	dwReserved1		DWORD ?						;;	)
;	cFileName			BYTE MAX_PATH dup (?)			;; nom du fichier
;	cAlternateFileName	BYTE 14 dup (?)				;; nom coup dos (8+3) du fichier (ou 0 si cFileName est dj compatible dos)
;WIN32_FIND_DATA ENDS

;FILETIME STRUCT
;	dwLowDateTime		DWORD ?						;; ) valeur 64 bits reprsentant le nombre d'intervales
;	dwHighDateTime		DWORD ?						;; ) de 100 nanosecondes, depuis le 1er janvier 1601
;FILETIME ENDS

ALIGN 16
_Fichier_Entete_Fichier_Bitmap_ BITMAPFILEHEADER <?>
;BITMAPFILEHEADER STRUCT
;	bfType			WORD ?						;; type de fichier, doit tre BM
;	bfSize			DWORD ?						;; la taille en octets du fichier bitmap
;	bfReserved1		WORD ?						;; rserv, doit tre 0
;	bfReserved2		WORD ?						;; rserv, doit tre 0
;	bfOffBits			DWORD ?						;; spcifie l'adresse (offset) en octets, de la structure vers les pixels du bitmap
;BITMAPFILEHEADER ENDS 

ALIGN 16
_Fichier_Entete_Donnees_Bitmap_ BITMAPCOREHEADER <?>
;BITMAPCOREHEADER STRUCT
;	bcSize			DWORD ?						;; nombre d'octets requis par la structure
;	bcWidth			WORD ?						;; spcifie la largeur du bitmap en pixels
;	bcHeight			WORD ?						;; spcifie la hauteur du bitmap en pixels
;	bcPlanes			WORD ?						;; spcifie le nombre de plans pour le device de destination
;	bcBitCount		WORD ?						;; spcifie le nombre de bits utiliss par pixel (ce nombre doit tre 1,4,8 ou 24)
;BITMAPCOREHEADER ENDS


.CODE
ALIGN 16
;
; charger un fichier compress en mmoire (dans un bloc de mme taille) (ncessite comdlg32.lib)
;
; Receptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_ qui a t prcdemment cre pour recevoir le fichier
;
; Retourne :
; eax = nombre d'octets lus (ou zro s'il y a une erreur, ou -1 si impossible d'obtenir l'info concernant la taille)
;
; syntaxe : ChargerFichier
;
ChargerFichier PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

; obtenir la taille (en octets) du fichier
		invoke FindFirstFile,_Fichier_Information_Selection_.lpstrFile,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE					;; comparer eax  -1
		je Label02								;; si c'est gal (erreur pointeur), aller Label02
; sinon, le pointeur est valide
		invoke FindClose,eax						;; alors, supprimer le pointeur dont on n'a plus besion
;		cmp _Fichier_Information_Fichier_.nFileSizeHigh,0	;; ) fichier trop volumineux ?
;		jne Label03								;; )
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow	;; sinon, rcuprer la taille du fichier
; definir la taille du bloc mmoire ncessaire pour charger le fichier
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer cette taille dans x._Taille_Du_Bloc_
		add eax,000000011h							;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
; et ajouter 1 galement pour tre sr d'avoir 1 octet pour un zro final (ce qui est pratique pour du texte)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
; lire le fichier
		invoke CreateFile,_Fichier_Information_Selection_.lpstrFile,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax	;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke ReadFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_ PTR [edi])._Pointeur_,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Lus_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_	;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant
		mov eax,_Fichier_Octets_Lus_					;; retourne le nombre d'octets lus dans eax

Label02:
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
;; message d'erreur de fichier trop volumineux
;Label03:
;		pop edx									;; dsempiler edx
;		pop ecx									;; dsempiler ecx
;	ret											;; retourner (sortir de la procdure)
ChargerFichier ENDP


ALIGN 16
;
; charger un fichier bitmap en mmoire (dans un bloc de mme taille) (ncessite comdlg32.lib)
; la structure OPENFILENAME concernant le fichier doit avoir t mise  jour
;
; Syntaxe :
; mov ebx,{adresse (offset) de la chane contenant le chemin+nom du fichier (peut tre OPENFILENAME.lpstrFile)}
; mov ecx,{adresse (offset) d'une structure _Pointeurs_Structure_Bitmap_ qui recevra les pointeurs}
; mov esi,{adresse (offset) d'une structure _Informations_Memoire_}
; mov edi,{adresse (offset) d'une structure _Bloc_Memoire_ qui recevera le fichier}
; call ChargerFichier_Bmp
;
; Retourne :
; eax = nombre d'octets lus (ou zro s'il y a une erreur, ou -1 si impossible d'obtenir l'info concernant la taille)
;
ChargerFichier_Bmp PROC
		push edx									;; empiler edx
		push ecx									;; empiler ecx

; obtenir la taille (en octets) du fichier
		invoke FindFirstFile,ebx,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE					;; comparer eax  -1
		je PasDeFichierACharger						;; si c'est gal (erreur pointeur), aller PasDeFichierACharger
; sinon, le pointeur est valide
		invoke FindClose,eax						;; alors, supprimer le pointeur dont on n'a plus besion
;		cmp _Fichier_Information_Fichier_.nFileSizeHigh,0	;; ) fichier trop volumineux ?
;		jne Label03								;; )
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow	;; sinon, rcuprer la taille du fichier
; definir la taille du bloc mmoire ncessaire pour charger le fichier
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer cette taille dans x._Taille_Du_Bloc_
		add eax,000000011h							;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
; et ajouter 1 galement pour tre sr d'avoir 1 octet pour un zro final (ce qui est pratique pour du texte)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
; lire le fichier
		invoke CreateFile,ebx,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax	;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke ReadFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_ PTR [edi])._Pointeur_,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Lus_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_	;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant

		pop ecx									;; dsempiler ecx, pour restaurer l'adresse de la structure _Pointeurs_Structure_Bitmap_
; obtenir les pointeurs pour la structure _Pointeurs_Structure_Bitmap_
		mov eax,(_Bloc_Memoire_ PTR [edi])._Pointeur_	;; placer l'adresse de dbut du fichier dans esi
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Entete_Bitmap_,eax	;; sauvegarder le pointeur Pointeur_Entete_Bitmap
		add eax,SIZEOF BITMAPFILEHEADER				;; ajouter la longueur de l'entete
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Informations_Bitmap_,eax	;; sauvegarder l'adresse des informations du bitmap
		add eax,SIZEOF BITMAPINFOHEADER				;; ajouter la longueur des informations
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Palette_Bitmap_,eax	;; sauvegarder l'adresse de la palette du bitmap
		mov eax,(_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Entete_Bitmap_	;; replacer l'adresse de dbut du fichier dans eax
		add eax,(BITMAPFILEHEADER PTR [eax]).bfOffBits	;; ajouter le nombre d'octets qui spare l'adresse de l'entete du dpart des pixels
		mov (_Pointeurs_Structure_Bitmap_ PTR [ecx])._Pointeur_Pixels_Du_Bitmap_,eax	;; sauvegarder l'adresse du dpart des pixels
		mov eax,_Fichier_Octets_Lus_					;; retourne le nombre d'octets lus dans eax

;		pop ecx									;; dsempiler ecx (fait auparavant)
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)

; cas o il n'y a rien  charger...
PasDeFichierACharger:

		pop ecx									;; dsempiler ecx (pas fait auparavant)
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
ChargerFichier_Bmp ENDP


ALIGN 16
;
; dfinir la slection du fichier (en dfinissant les adresses : du titre de la fentre, du nom du fichier,
; des filtres utiliss, etc...)
;
; Receptionne :
; eax = instance de la fentre (HWnd/HWndDlg/etc...)
; ebx = adresse (offset) de la chaine du titre de slection
; ecx = adresse (offset) de la chaine du nom (a recevoir, ou  dfinir)
; edx = adresse (offset) de la chaine des filtres de slection
; esi = adresse (offset) de la chaine de l'extension (sans le point) par dfaut
;
; Retourne :
; rien
;
; syntaxe : DefinirTypeFichier
;
DefinirTypeFichier PROC

		mov _Fichier_Information_Selection_.hWndOwner,eax			;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ebx		;; titre de la boite de dialogue
		mov _Fichier_Information_Selection_.lpstrFileTitle,ecx		;; dfini par les fonctions Open et Close
		mov _Fichier_Information_Selection_.lpstrFilter,edx		;; filtres utilis
		mov _Fichier_Information_Selection_.lpstrDefExt,esi		;; l'extension par dfaut
		mov _Fichier_Information_Selection_.lStructSize,SIZEOF OPENFILENAME	;; taille de la structure
		mov _Fichier_Information_Selection_.lpstrFile,OFFSET _Fichier_Chaine_Chemin_Temporaire_	;; adresse de la chaine chemin+nom de rception
		mov _Fichier_Information_Selection_.nMaxFile,MAX_PATH
		mov _Fichier_Information_Selection_.nMaxFileTitle,MAX_PATH
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ; or OFN_HIDEREADONLY

	ret											;; retourner (sortir de la procdure)
DefinirTypeFichier ENDP


ALIGN 16
;
; effacer un fichier (ici, la structure OPENFILENAME doit avoir t mise  jour)
;
; Rceptionne :
; rien
;
; Retourne :
; rien
;
; syntaxe : EffacerFichier
;
EffacerFichier PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke DeleteFile,_Fichier_Information_Selection_.lpstrFile	;; effacer le fichier

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
EffacerFichier ENDP


ALIGN 16
;
; effacer fichier occupant la mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) de la structure _Bloc_Memoire_ qui est utilise pour le fichier
;
; Retourne :
; rien
;
; syntaxe : EffacerFichierEnMemoire
;
EffacerFichierEnMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
EffacerFichierEnMemoire ENDP


ALIGN 16
;
; initialiser la selection de fichier (en dfinissant les adresses : du titre de la fentre, du chemin du fichier,
; du nom du fichier, des filtres utiliss, etc... doit tre utilis une fois, ensuite on utilise DefinirTypeFichier)
;
; Rceptionne :
; eax = instance de l'application
; ebx = instance de la fentre (HWnd/HWndDlg/etc...)
; ecx = adresse (offset) de la chaine du titre de slection par dfaut
; edx = adresse (offset) de la chaine du nom du fichier (a recevoir, ou  dfinir)
; esi = adresse (offset) de la chaine des filtres de slection par dfaut
;
; Retourne :
; rien
;
; syntaxe : InitialiserSelectionFichier
;
InitialiserSelectionFichier PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi
		push edi									;; empiler edi

		mov _Fichier_Information_Selection_.hInstance,eax			;; instance de l'application
		mov _Fichier_Information_Selection_.hWndOwner,ebx			;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ecx
		mov _Fichier_Information_Selection_.lpstrFileTitle,edx		;; dfini par les fonctions Open et Close
		mov _Fichier_Information_Selection_.lpstrFilter,esi		;; filtre utilis
		mov _Fichier_Information_Selection_.lStructSize,SIZEOF OPENFILENAME	;; taille de la structure
		mov _Fichier_Information_Selection_.lpstrFile,OFFSET _Fichier_Chaine_Chemin_Temporaire_	;; dfini par les fonctions Open et Close
		mov _Fichier_Information_Selection_.nMaxFile,MAX_PATH
		mov _Fichier_Information_Selection_.nMaxFileTitle,MAX_PATH
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ; or OFN_HIDEREADONLY
		mov _Fichier_Information_Selection_.lpstrCustomFilter,0
		mov _Fichier_Information_Selection_.nMaxCustFilter,0
		mov _Fichier_Information_Selection_.nFilterIndex,0
		mov _Fichier_Information_Selection_.lpstrInitialDir,0
		mov _Fichier_Information_Selection_.nFileOffset,0
		mov _Fichier_Information_Selection_.nFileExtension,0
		mov _Fichier_Information_Selection_.lpstrDefExt,0			;; l'extension par dfaut
		mov _Fichier_Information_Selection_.lCustData,0
		mov _Fichier_Information_Selection_.lpfnHook,0
		mov _Fichier_Information_Selection_.lpTemplateName,0
		invoke GetCurrentDirectory,MAX_PATH,ADDR _Fichier_Chaine_Chemin_Temporaire_
		mov esi,OFFSET _Fichier_Chaine_Chemin_Temporaire_Ajout
		mov edi,OFFSET _Fichier_Chaine_Chemin_Temporaire_
		call FusionnerChainesAscii

		pop edi									;; dsempiler edi
		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
InitialiserSelectionFichier ENDP


ALIGN 16
;
; obtenir le nom du fichier  charger en mmoire
;
; Receptionne :
; eax = instance de la fentre (HWnd/HWndDlg/etc...)
; ebx = adresse (offset) de la chaine du titre de slection
; ecx = adresse (offset) de la chaine du nom (a recevoir, ou  dfinir)
; edx = adresse (offset) de la chaine des filtres de slection
; esi = adresse (offset) de la chaine de l'extension (sans le point) par dfaut
;
; Retourne :
; eax = zro si aucun fichier n'est slectionn, ou s'il y a une erreur
;
; syntaxe : ObtenirNomFichierACharger
;
ObtenirNomFichierACharger PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov _Fichier_Information_Selection_.hWndOwner,eax			;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ebx		;; adresse de la chaine du titre de la fentre de slection
		mov _Fichier_Information_Selection_.lpstrFileTitle,ecx		;; adresse de la chaine du nom du fichier  obtenir, dfini par la fonction
		mov _Fichier_Information_Selection_.lpstrFilter,edx		;; adresse des chaines de filtre de slection
		mov _Fichier_Information_Selection_.lpstrDefExt,esi		;; adresse de la chane de l'extension par dfaut
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ;or OFN_HIDEREADONLY
		invoke GetOpenFileName,ADDR _Fichier_Information_Selection_	;; obtenir le nom

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
ObtenirNomFichierACharger ENDP


ALIGN 16
;
; obtenir le nom du fichier  sauvegarder
;
; Receptionne :
; eax = instance de la fentre (HWnd/HWndDlg/etc...)
; ebx = adresse (offset) de la chaine du titre de slection
; ecx = adresse (offset) de la chaine du nom (a recevoir, ou  dfinir)
; edx = adresse (offset) de la chaine des filtres de slection
; esi = adresse (offset) de la chaine de l'extension (sans le point) par dfaut
;
; Retourne :
; eax = zro si aucun fichier n'est slectionn, ou s'il y a une erreur
;
; syntaxe : ObtenirNomFichierACharger
;
ObtenirNomFichierASauvegarder PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov _Fichier_Information_Selection_.hWndOwner,eax			;; instance de la fentre
		mov _Fichier_Information_Selection_.lpstrTitle,ebx		;; adresse de la chaine du titre de la fentre de slection
		mov _Fichier_Information_Selection_.lpstrFileTitle,ecx		;; adresse de la chaine du nom du fichier, doit avoir t dfini auparavant
		mov _Fichier_Information_Selection_.lpstrFilter,edx		;; adresse de la chaine du nom du fichier  obtenir, dfini par la fonction
		mov _Fichier_Information_Selection_.lpstrDefExt,esi		;; adresse de la chane de l'extension par dfaut
		mov _Fichier_Information_Selection_.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST ;or OFN_HIDEREADONLY
		invoke GetSaveFileName,ADDR _Fichier_Information_Selection_	;; obtenir le nom

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
ObtenirNomFichierASauvegarder ENDP


ALIGN 16
;
; obtenir la taille non-dcompresse (en octets) du fichier trait prcdemment (dont les variables de
; _Fichier_Information_Selection_ ont t mises  jour)
;
; Rceptionne :
; rien, mais les informations on dus tre dfinis au pralable dans les variables de _Fichier_Information_Selection_
;
; Retourne :
; eax = la taille (non dcomprsse) du fichier, ou -1 si il y a une erreur
;
; syntaxe : ObtenirTailleFichier
;
ObtenirTailleFichier PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke FindFirstFile,_Fichier_Information_Selection_.lpstrFile,ADDR _Fichier_Information_Fichier_ ;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE					;; comparer eax  -1
		je Label02								;; si c'est gal (erreur pointeur), aller Label02
; sinon, le pointeur est valide
		invoke FindClose,eax						;; alors, supprimer le pointeur dont on n'a plus besion
		mov eax,_Fichier_Information_Fichier_.nFileSizeLow	;; et rcuprer la taille du fichier
Label02:
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
ObtenirTailleFichier ENDP


ALIGN 16
;
; sauvegarder un fichier sur disque (ncessite comdlg32.lib)
;
; Receptionne :
; edi = adresse (offset) de la structure _Bloc_Memoire_ qui est utilise pour le fichier
;
; Retourne :
; eax = nombre d'octets crits (ou zro, s'il y a une erreur)
;
; syntaxe : SauvegarderFichier
;
SauvegarderFichier PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke CreateFile,_Fichier_Information_Selection_.lpstrFile,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax	;; sauvegarder le pointeur obtenu dans _Fichier_Pointeur_Fichier_Temporaire_
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_ PTR [edi])._Pointeur_,(_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Ecrits_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_	;; fermer _Fichier_Pointeur_Fichier_Temporaire_, devenu inutile maintenant
		mov eax,_Fichier_Octets_Ecrits_				;; retourne le nombre de bits crits dans eax

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
SauvegarderFichier ENDP


ALIGN 16
;
; sauvegarder un fichier bmp sur disque (ncessite comdlg32.lib)
; note : la structure OPENFILENAME concernant le fichier doit avoir t mise  jour si on utilise cette structure
;
; Syntaxe :
; mov ebx,{adresse (offset) de la chane contenant le chemin+nom du fichier (peut tre OPENFILENAME.lpstrFile)}
; mov esi,{adresse (offset) de la structure BITMAPINFOHEADER qui est utilise pour le bitmap}
; mov edi,{adresse (offset) de la structure _Bloc_Memoire_Ecran_ qui est utilise pour les pixels du bitmap}
; call SauvegarderFichier_Bmp
;
; Retourne :
; eax = nombre d'octets crits (ou zro, s'il y a une erreur)
;
SauvegarderFichier_Bmp PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

; dfinir la taille de l'entete du fichier  sauvegarder
		mov eax,SIZEOF BITMAPFILEHEADER				;; placer la taille de l'entete dans eax
		add eax,SIZEOF BITMAPINFOHEADER				;; ajouter les informations
		add eax,(SIZEOF _Fichier_Chaine_Production_)-1	;; ajouter la chane concernant la production (moins le zro final)
		xor ecx,ecx								;; ) obtenir le complment pour un alignement sur 16 octets
		mov edx,eax								;; )
		and edx,00000000Fh							;; )
		jz AlignementInutile						;; )
		mov ecx,000000010h							;;	) ajouter un alignement
		sub ecx,edx								;;	)
AlignementInutile:
		mov _Fichier_Complement_Alignement_,ecx			;; sauvegarder la taille du complment
		add eax,ecx								;; ajouter le complement pour l'alignement
; dfinir la taille du bitmap du fichier  sauvegarder
		mov edx,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; placer le nombre d'octets du bitmap
; dfinir la taille complte du fichier  sauvegarder
		add edx,eax								;; ajouter l'entete du fichier
; remplir la structure BITMAPFILEHEADER
		mov _Fichier_Entete_Fichier_Bitmap_.bfType,4D42h	;; placer "MB" pour BitMap
		mov _Fichier_Entete_Fichier_Bitmap_.bfSize,edx	;; sauvegarder la taille du fichier
		mov _Fichier_Entete_Fichier_Bitmap_.bfReserved1,0	;; ) s'assurer que c'est vide
		mov _Fichier_Entete_Fichier_Bitmap_.bfReserved2,0	;; )
		mov _Fichier_Entete_Fichier_Bitmap_.bfOffBits,eax	;; sauvegarder la taille de l'entte (pour pouvoir retrouver l'emplacement des pixels)
; une fois toutes les valeurs initialises, on va sauvegarder
		invoke CreateFile,ebx,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		cmp eax,INVALID_HANDLE_VALUE					;; comparer le pointeur obtenu  INVALID_HANDLE_VALUE
		je PasDeFichierASauvegarder					;; si c'est le cas, aller PasDeFichierASauvegarder
		mov _Fichier_Pointeur_Fichier_Temporaire_,eax	;; sinon, sauvegarder le _Fichier_Pointeur_Fichier_Temporaire_
; sauvegarder l'entte du fichier bmp
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,ADDR _Fichier_Entete_Fichier_Bitmap_,SIZEOF BITMAPFILEHEADER,ADDR _Fichier_Octets_Ecrits_,NULL
; sauvegarder les informations du fichier bmp 
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,esi,SIZEOF BITMAPINFOHEADER,ADDR _Fichier_Octets_Ecrits_,NULL
; sauvegarder l'information de production 
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,ADDR _Fichier_Chaine_Production_,(SIZEOF _Fichier_Chaine_Production_)-1,ADDR _Fichier_Octets_Ecrits_,NULL
; sauvegarder le complment ncessaire  un alignement sur 16 octets (ce qui permettra d'utiliser ultrieurement les instructions simd directement sur les pixels)
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,ADDR _Fichier_Chaine_Alignement_,_Fichier_Complement_Alignement_,ADDR _Fichier_Octets_Ecrits_,NULL
; sauvegarder les pixels du fichier bmp 
		invoke WriteFile,_Fichier_Pointeur_Fichier_Temporaire_,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,(_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,ADDR _Fichier_Octets_Ecrits_,NULL
		invoke CloseHandle,_Fichier_Pointeur_Fichier_Temporaire_	;; supprimer _Fichier_Pointeur_Fichier_Temporaire_ (qui est devenu inutile...)
		mov eax,_Fichier_Octets_Ecrits_				;; retourne le nombre de bits crits dans eax
PasDeFichierASauvegarder:

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
SauvegarderFichier_Bmp ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines graphiques 2D
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; crer un effet blur statique (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Syntaxe :
; mov eax,{Largeur en pixels  traiter (doit tre infrieur ou gal  la largeur de l'cran)}
; mov ebx,{Hauteur en pixels  traiter (doit tre infrieur ou gal  la hauteur de l'cran)}
; mov ecx,{position X (en pixel, de 0  Largeur) de dbut de l'effet fondu}
; mov edx,{position Y (en pixel, de 0  hauteur) de dbut de l'effet fondu}
; mov esi,{adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)}
; call Mmx_EffetFonduPartielStatique
;
; Retourne :
; rien
;
Mmx_EffetFonduPartielStatique PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		shl ecx,2									;; multiplier ecx par 4 pour avoir la position X x4
		shl eax,2									;; multiplier eax par 4 pour avoir la largeur x4
		mov edi,eax								;; sauvegarder eax dans edi
		mov eax,edx								;; copier edx dans eax
		mul (_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; multiplier eax par la largeur d'une ligne
		add eax,ecx								;; ajouter la position X x4 au rsultat
		mov ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans ecx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		add esi,eax								;; ajouter la position de dpart  esi
		mov eax,edi								;; puis on restaure eax
		sub ecx,eax								;; soustraire la largeur x4  traiter  la largeur cran x4
		mov ebp,ecx								;; placer le rsultat dans ebp
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour les lignes)
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)

; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		add esi,eax								;; on ajoute le rsultat  esi
		mov edx,esi								;; copier esi dans edx
		sub edx,eax								;; soustraire _Largeur_Ecran_A_Traiter_X4_  edx
		sub edx,ebp								;; soustraire _Fondu_Complement_Largeur_Ecran_X4_  edx
		mov edi,esi								;; copier esi dans edi
		add edi,eax								;; ajouter _Largeur_Ecran_A_Traiter_X4_  edi
		add edi,ebp								;; ajouter _Fondu_Complement_Largeur_Ecran_X4_  edi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter
		movd MM1,DWORD PTR [esi+ecx-DWORD]				;; placer le dword en esi dans MM1 (n'est effectu qu'une seule fois)
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7

; ici, commence la boucle pour une ligne
Label2:	movd MM0,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM0
		movd MM2,DWORD PTR [edx+ecx]					;; placer le dword en esi dans MM2
		movd MM3,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM3
; transformer les octets en words
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7
		punpcklbw MM3,MM7							;; entrelacer les octets suprieurs de MM3 et MM7
; faire la somme des valeurs
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		movq MM1,MM0								;; transferer MM0 dans MM1 (ce qui vitera de le relire)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		add esi,ebp								;; ajouter le complment d'une ligne  esi
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1
		shr eax,2									;; pour retrouver la valeur originelle en eax

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduPartielStatique ENDP


ALIGN 16
;
; fond les couleurs d'un cran (ne tiens pas compte des couleurs de remplissage existantes, et effectue un
; remplissage par fondu, sauf pour la dernire ligne)
; note : la largeur et la hauteur de l'cran doivent tre multiple de 2
;
; Rceptionne :
; edi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran dont on va fondre les couleurs
;
; retourne :
; rien
;
; syntaxe : Mmx_RemplissageFondu
;
Mmx_RemplissageFondu PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_	;; placer la hauteur de l'cran originel dans ebx
		mov ebp,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut de la zone dans edi

		and ebp,0FFFFFFF8h							;; pour tre sr que la largeur est un multiple de 2...
		shr ebx,1									;; diviser la hauteur cran par 2 (puisqu'on va traiter les lignes par 2, et du mme coup on s'assure que la hauteur est un multiple de 2)
		neg ebx									;; on inverse ebx, qui sera notre compteur de boucle pour les lignes
		pxor MM7,MM7								;; effacer MM7
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
Label0:	lea esi,[edi+ebp]							;; esi = _Pointeur_ + _Largeur_Ecran_X4_
		lea edi,[edi+2*ebp]							;; edi = _Pointeur_ + _Largeur_Ecran_X4_*2
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, c'est pour doubler la premire valeur des 2 premires lignes
		movd MM0,DWORD PTR [edi+ecx+DWORD]				;; placer la deuxime couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
; ici, on traite les 2 premires lignes
Label1:	movd MM1,DWORD PTR [edi+ecx+DWORD]				;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movd DWORD PTR [edi+ecx],MM0					;; et recopier les 2 couleurs dans edi+ecx
		movq QWORD PTR [esi+ecx],MM0					;; placer la premire couleur dans esi+ecx
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		add ecx,DWORD*2							;; augmenter ecx de 2 dwords
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
		inc ebx									;; incrmener ebx d'une ligne
		jz Label5									;; si ebx est gal  0, aller Label5 (la sortie)
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )

; maintenant que la premire ligne (double) a t calcule, on va pouvoir calculer les lignes intermediaires en plus...
Label2:	mov edx,edi								;; copier l'adresse edi actuelle dans edx
		lea esi,[edi+ebp]							;; esi = _Pointeur_ + _Largeur_Ecran_X4_
		lea edi,[edi+2*ebp]							;; edi = _Pointeur_ + _Largeur_Ecran_X4_*2
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, c'est pour doubler la premire valeur des lignes
		movd MM0,DWORD PTR [edi+ecx+DWORD]				;; placer la deuxime couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
; ici, on traite les lignes
Label3:	movd MM1,DWORD PTR [edi+ecx+DWORD]				;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		psrlw MM0,1								;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		movq MM2,MM0								;; faire une copie de MM0 en MM2 (qui servira pour les lignes intermdiaires)
		packuswb MM0,MM1							;; compacter les words de MM0 et MM1 en octets dans MM0
		movd DWORD PTR [edi+ecx],MM0					;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la premire couleur qui devient la deuxime) dans MM0
; ici, on traite les lignes intermediaires (les lignes juste au dessus de celles qui viennent d'tre traites)
		movq MM3,QWORD PTR [edx+ecx]					;; placer le qword de 2 lignes avant dans MM3
		movq MM4,MM3								;; recopier MM3 dans MM4
		punpcklbw MM3,MM7							;; placer 00XX00XX00XX00XX dans MM3
		punpckhbw MM4,MM7							;; placer 00XX00XX00XX00XX dans MM4
		paddw MM3,MM2								;; ajouter en parallle MM2  MM3
		paddw MM4,MM1								;; ajouter en parallle MM1  MM4
		psrlw MM3,1								;; diviser en parallle les words en MM3 par 2 (par un dcalage  droite de 2 bits)
		psrlw MM4,1								;; diviser en parallle les words en MM4 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM3,MM4							;; compacter les words de MM3 et MM4 en octets dans MM3
		movq QWORD PTR [esi+ecx],MM3					;; et recopier les deux couleurs casses dans esi+(ecx*2) (la ligne prcdente)
Label4:	add ecx,DWORD*2							;; augmenter ecx de 2 dwords
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
		inc ebx									;; incrmener ebx d'une ligne
		jnz Label2								;; tant que ebx est diffrent de 0, aller Label2
Label5:
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_RemplissageFondu ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine de traitement de chanes
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
;
; tables pour obtenir les caractres quivalents minuscules/majuscules (fait 1 ko)
; (cette table est francise pour les accents, cdilles, etc...)
;
_ChChAs_NSC_	BYTE 000,001,002,003,004,005,006,007,008,009,010,011,012,013,014,015
			BYTE 016,017,018,019,020,021,022,023,024,025,026,027,028,029,030,031
			BYTE 032,033,034,035,036,037,038,039,040,041,042,043,044,045,046,047
			BYTE 048,049,050,051,052,053,054,055,056,057,058,059,060,061,062,063
			BYTE 064,097,098,099,100,101,102,103,104,105,106,107,108,109,110,111
			BYTE 112,113,114,115,116,117,118,119,120,121,122,091,092,093,094,095
			BYTE 096,065,066,067,068,069,070,071,072,073,074,075,076,077,078,079
			BYTE 080,081,082,083,084,085,086,087,088,089,090,123,124,125,126,127
			BYTE 135,085,069,065,065,065,065,067,069,069,069,073,073,073,132,134
			BYTE 130,146,145,079,079,079,085,085,089,148,129,155,156,156,158,159
			BYTE 065,073,079,085,165,164,166,167,168,169,170,171,172,173,173,175
			BYTE 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
			BYTE 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
			BYTE 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
			BYTE 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
			BYTE 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255


.CODE
ALIGN 16
;
; trouver une chaine de caractres dans une chane/un texte ascii (la premire occurrence)
;
; Rceptionne :
; eax = position de dpart dans la chane
; esi = adresse de la chaine  trouver
; edi = adresse de la chaine/du texte  tester
;
; Retourne :
; eax = -1 si la chane de caractres n'est pas trouve, sinon eax contient la position o se situe cette chane
;
; syntaxe : ChercherChaineAscii_Ascendante
;
ChercherChaineAscii_Ascendante PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		add eax,edi								;; on ajoute la position  l'adresse de la chane
; on stocke le premier octet  trouver
		mov dh,BYTE PTR [esi]						;; placer le premier octet  trouver dans dh
		dec eax									;; enlever 1  l'adresse ( cause de la ligne qui suit...)
		nop										;; ) alignement ncessaire pour un meilleur rendement
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )

; maintenant, recherche du premier caractre identique
Label1:	inc eax									;; augmenter l'adresse de loctet  comparer
		mov dl,BYTE PTR [eax]						;; lire l'octet  comparer, et le placer dans dl
		test dl,dl								;; fixer les flags de dl
		jz Label4									;; si c'est gal  0, aller Label4
		cmp dh,dl									;; sinon, comparer l'octet lu  celui en dh
		jne Label1								;; si c'est diffrent, on continu la recherche, aller Label1

; sinon, on teste les caractres suivants 
		xor ecx,ecx								;; effacer ecx
Label2:	inc ecx									;; augmenter ecx d'1
		mov dl,BYTE PTR [esi+ecx]					;; placer l'octet suivant dans dl
		test dl,dl								;; fixer les flags de dl
		jz Label3									;; si c'est gal  0, aller Label3
		cmp dl,BYTE PTR [eax+ecx]					;; et le comparer  l'octet suivant  comparer
		je Label2									;; si c'est gal  0, aller Label2
		jmp Label1								;; aller Label1

; ici la chane est trouve, alors on defini eax qui contiendra l'adresse 
Label3:	sub eax,edi								;; on soustrait l'adresse de la chane pour obtenir la position trouve dans la chane
		jmp Label5								;; aller Label5
Label4:	mov eax,-1								;; sinon on met -1 (chane non trouve dans eax)

Label5:
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
ChercherChaineAscii_Ascendante ENDP


ALIGN 16
;
; trouver une chaine de caractres dans une chane/un texte ascii (la premire occurrence)
;
; Rceptionne :
; eax = position de dpart dans la chane
; esi = adresse de la chaine  trouver
; edi = adresse de la chaine/du texte  tester
;
; Retourne :
; eax = -1 si la chane de caractres n'est pas trouve, sinon eax contient la position o se situe cette chane
;
; syntaxe : ChercherChaineAscii_Descendante
;
ChercherChaineAscii_Descendante PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		add eax,edi								;; on ajoute la position  l'adresse de la chane
; on stocke le premier octet  trouver
		mov dh,BYTE PTR [esi]						;; placer le premier octet  trouver dans dh
		inc eax									;; ajouter 1  l'adresse ( cause de la ligne qui suit...)
		nop										;; ) alignement ncessaire pour un meilleur rendement
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )

; maintenant, recherche du premier caractre identique
Label1:	dec eax									;; enlever 1  l'adresse de loctet  comparer
		cmp eax,edi								;; comparer eax  edi (l'adresse minimale)
		jb Label4									;; si c'est infrieur, aller Label4
		mov dl,BYTE PTR [eax]						;; lire l'octet  comparer, et le placer dans dl
		cmp dh,dl									;; sinon, comparer l'octet lu  celui en dh
		jne Label1								;; si c'est diffrent, on continu la recherche, aller Label1

; sinon, on teste les caractres suivants 
		xor ecx,ecx								;; effacer ecx
Label2:	inc ecx									;; augmenter ecx d'1
		mov dl,BYTE PTR [esi+ecx]					;; placer l'octet suivant dans dl
		test dl,dl								;; fixer les flags de dl
		jz Label3									;; si c'est gal  0, aller Label3
		cmp dl,BYTE PTR [eax+ecx]					;; et le comparer  l'octet suivant  comparer
		je Label2									;; si c'est gal  0, aller Label2
		jmp Label1								;; aller Label1

; ici la chane est trouve, alors on defini eax qui contiendra l'adresse 
Label3:	sub eax,edi								;; on soustrait l'adresse de la chane pour obtenir la position trouve dans la chane
		jmp Label5								;; aller Label5
Label4:	mov eax,-1								;; sinon on met -1 (chane non trouve dans eax)
Label5:
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
ChercherChaineAscii_Descendante ENDP


ALIGN 16
;
; trouver une chaine de caractres dans une chane/un texte ascii (la premire occurrence)
;
; Rceptionne :
; eax = position de dpart dans la chane
; esi = adresse de la chaine  trouver
; edi = adresse de la chaine/du texte  tester
;
; Retourne :
; eax = -1 si la chane de caractres n'est pas trouve, sinon eax contient la position o se situe cette chane
;
; syntaxe : ChercherChaineAscii_NonSensibleCasse_Ascendante
;
ChercherChaineAscii_NonSensibleCasse_Ascendante PROC
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		add eax,edi								;; on ajoute la position  l'adresse de la chane
; on stocke le premier octet  trouver
		movzx ebx,BYTE PTR [esi]						;; placer le premier octet  trouver dans bl
		mov bh,BYTE PTR [_ChChAs_NSC_+ebx]				;; placer l'quivalence de la table dans bh
		dec eax									;; enlever 1  l'adresse ( cause de la ligne qui suit...)

; maintenant, recherche du premier caractre identique
Label1:	inc eax									;; ajouter 1  l'adresse de loctet  comparer
		mov dl,BYTE PTR [eax]						;; lire l'octet  comparer, et le placer dans dl
		test dl,dl								;; fixer les flags de dl
		jz Label5									;; si c'est gal  0, aller Label5
		cmp dl,bl									;; sinon, comparer l'octet lu  celui en bl
		je Label2									;; si c'est gal, on va tester les caractres suivant, aller Label2
		cmp dl,bh									;; comparer ensuite  l'quivalence dans la table
		jne Label1								;; si c'est diffrent, on continu la recherche, aller Label1

; sinon, on teste les caractres suivants 
Label2:	xor ecx,ecx								;; effacer ecx
Label3:	inc ecx									;; augmenter ecx d'1
		movzx edx,BYTE PTR [esi+ecx]					;; placer l'octet suivant dans dl
		mov dh,BYTE PTR [_ChChAs_NSC_+edx]				;; placer l'quivalence de la table dans dh
		test dl,dl								;; fixer les flags de dl
		jz Label4									;; si c'est gal  0, aller Label4
		cmp dl,BYTE PTR [eax+ecx]					;; et le comparer  l'octet suivant  comparer
		je Label3									;; si c'est gal  0, aller Label3
		cmp dh,BYTE PTR [eax+ecx]					;; comparer  l'quivalence de la table
		je Label3									;; si c'est gal  0, aller Label3
		jmp Label1								;; aller Label1

; ici la chane est trouve, alors on defini eax qui contiendra l'adresse 
Label4:	sub eax,edi								;; on soustrait l'adresse de la chane pour obtenir la position trouve dans la chane
		jmp Label6								;; aller Label6
Label5:	mov eax,-1								;; sinon on met -1 (chane non trouve dans eax)
Label6:
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
ChercherChaineAscii_NonSensibleCasse_Ascendante ENDP


ALIGN 16
;
; comparer une chane de caractres  une autre, sans tenir compte de la casse de caractres
;
; Rceptionne :
; esi = adresse de la premire chane
; edi = adresse de la deuxime chane
;
; Retourne :
; eax = -1 si les chanes sont semblables, sinon eax contient la position (l'octet du bloc) o se situe la premire diffrence
;
; syntaxe : ComparerChainesAscii_NonSensibleCasse
;
ComparerChainesAscii_NonSensibleCasse PROC

		push ebx									;; empiler ebx
		push ecx									;; empiler ecx

		mov ebx,OFFSET _ChChAs_NSC_					;; placer l'adresse de la table dans ebx
		mov ecx,-1								;; placer -1 dans ecx
		nop										;; ) alignement ncessaire pour un meilleur rendement
		nop										;; )
		nop										;; )
		nop										;; )
		nop										;; )
Label1:	inc ecx									;; ajouter 1  l'adresse en ecx
		mov al,BYTE PTR [esi+ecx]					;; placer l'octet en esi+ecx dans al
		cmp al,BYTE PTR [edi+ecx]					;; comparer al  l'octet en edi+ecx
		je Label2									;; si c'est semblable, aller Label2
		xlatb									;; changer al avec l'quivalence dans la table
		cmp al,BYTE PTR [edi+ecx]					;; comparer l'quivalence de la table  l'octet en edi+ecx
		jne Label3								;; si c'est diffrent, aller Label3
Label2:	test al,al								;; sinon, c'est semblable alors on va fixer les flags de al
		jnz Label1								;; si al est diffrent de 0, on retourne Label1
		mov eax,-1								;; placer -1 (pas de diffrence trouve) dans eax

		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)

Label3:	mov eax,ecx								;; ici on place ecx dans eax (pour obtenir l'endroit de la diffrence)

		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)

ComparerChainesAscii_NonSensibleCasse ENDP


ALIGN 16
;
; convertir un dword en texte au format dcimale (routine la plus stable pour le job)
; note : cette routine n'est pas de moi, je sais plus o je l'ai rcupre, mais si je me souviens bien,
; c'est une adaption d'un algo cr par pdixon/michealw (ou quelque chose comme c... au dbut, j'aimait pas
; trop le bidouillage qui faisait passer le +1 en eax dans le multiplicateur, mais aprs tout, si ca fait le job,
; pourquoi pas...)
;
; Rceptionne :
; eax = la valeur
; esi = adresse de la chaine de caractres  crer
;
; Retourne :
; rien
;
; syntaxe : ConvertirValeurEnChaineDecimale
;
ConvertirValeurEnChaineDecimale PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi

		mov ecx,eax								;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768							;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx									;; multiplier eax par 2814749768
		shr edx,16								;; dcaler edx de 16 bits  droite
		mov eax,100000								;; placer 100000 dans eax
		mov ebx,edx								;; copier edx dans ebx
		mul edx									;; multiplier edx par 100000
		sub ecx,eax								;; soustraire le rsultat en eax  ecx
		test ebx,ebx								;; fixer les flags de ebx
		mov edx,ebx								;; replacer ebx dans edx
		mov ebx,10								;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01								;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497								;; on remplace eax par 429497
		mul edx									;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02								;; s'il existe un dpassement, aller Label02
		mul ebx									;; multiplier eax par 10
		jc Label03								;; s'il existe un dpassement, aller Label03
		mul ebx									;; multiplier eax par 10
		jc Label04								;; s'il existe un dpassement, aller Label04
		mul ebx									;; multiplier eax par 10
		jc Label05								;; s'il existe un dpassement, aller Label05
		mul ebx									;; multiplier eax par 10
		jc Label06								;; s'il existe un dpassement, aller Label06
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07								;; s'il existe un dpassement, aller Label07
		mul ebx									;; multiplier eax par 10
		jc Label08								;; s'il existe un dpassement, aller Label08
		mul ebx									;; multiplier eax par 10
		jc Label09								;; s'il existe un dpassement, aller Label09
		mul ebx									;; multiplier eax par 10
		jc Label10								;; s'il existe un dpassement, aller Label10
		mul ebx									;; multiplier eax par 10
		jmp Label11								;; aller Label11
; maintenant on va calculer et copier chaque octets/caractres
Label02:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label03:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label04:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label05:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx


		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label06:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi

		mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)

		inc esi									;; ajouter 1 octet  l'adresse en esi
Label07:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label08:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label09:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label10:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label11:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mov BYTE PTR [esi+1],0						;; placer le 0 final  l'adresse en esi+1
		xor eax,eax								;; effacer eax

		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


ALIGN 16
;
; fusionner des chaines de caractres
;
; Rceptionne :
; esi = adresse de la chane source que l'on ajoutera
; edi = adresse de la chane de destination
;
; Retourne :
; eax = la taille de la nouvelle chaine obtenue
;
; syntaxe : FusionnerChainesAscii
;
FusionnerChainesAscii PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push edi									;; empiler edi

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]						;; placer le motlong de l'adresse actuelle dans eax
		add edi,4									;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]						;; placer eax (- 1  chaque octets du motlong) dans edx
		xor eax,edx								;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h							;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1									;; si le filtrage est gal  0, aller Label1
		and eax,edx								;; ne conserver en eax que les bits positionns en edx
		jz Label1									;; si le filtrage est gal  0, aller Label1
		bsf edx,eax								;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4									;; soustraire 4 au numro du bit obtenu
		shr edx,3									;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]							;; placer edi + edx - 1 dword dans edi

; et on effectue la copie
		xor eax,eax								;; effacer eax (notre compteur d'octets)
		jmp Label3								;; aller Label3
Label2:	add ecx,01010101h							;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx					;; placer cette valeur  l'adresse de destination
		add eax,4									;; incrmenter esi (l'adresse) de 4 (un dword)
Label3:	mov edx,DWORD PTR [esi+eax]					;; placer le motlong de l'adresse actuelle dans eax
		lea ecx,[edx-01010101h]						;; placer eax (- 1  chaque octets du motlong) dans ecx
		xor edx,ecx								;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h							;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label2									;; si le filtrage est gal  0, aller Label2
		and edx,ecx								;; ne conserver en eax que les bits positionns en ecx
		jz Label2									;; si le filtrage est gal  0, aller Label2
		add ecx,01010101h							;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl							;; placer cl  l'adresse en edi+eax
		test cl,cl								;; fixer les flags de cl
		jz Label6									;; si c'est gal  0, aller Label5
		mov [edi+eax+1],ch							;; placer ch  l'adresse en edi+eax+1
		test ch,ch								;; fixer les flags de ch
		jz Label5									;; si c'est gal  0, aller Label4
		shr ecx,16								;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl							;; placer cl  l'adresse en edi+eax+2
		test cl,cl								;; fixer les flags de cl
		jz Label4									;; si c'est gal  0, aller Label3
		mov [edi+eax+3],ch							;; placer ch  l'adresse en edi+eax+3
		inc eax									;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label4:	inc eax									;; ajouter 1  eax )
Label5:	inc eax									;; ajouter 1  eax )
Label6:	add eax,edi								;; ajouter edi  eax

		pop edi									;; dsempiler edi
		sub eax,edi								;; et on soustrait l'adresse originelle  eax pour obtenir la nouvelle taille de la chane
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
FusionnerChainesAscii ENDP


ALIGN 16
;
; fusionner des chaines de caractres
;
; Rceptionne :
; edi = adresse de la chane de destination
; le nombre de chaines  ajouter (1 au minimum) (qui servira de compteur)
; et les adresses des diffrentes chanes sources que l'on ajoutera
;
; Retourne :
; eax = la taille de la nouvelle chaine obtenue
;
; syntaxe : FusionnerMultiplesChainesAscii [nombre de chaines  ajouter],[adresse de la chane source1],[adresse de la chane source2],...
;
FusionnerMultiplesChainesAscii PROC C _Compteur_:DWORD,_Adresse_Sources_:VARARG
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi
		push edi									;; empiler edi

		lea esi,_Adresse_Sources_					;; placer l'adresse de la premire chane source dans esi
		nop										;; alignement ncessaire pour un meilleur rendement

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]						;; placer le motlong de l'adresse actuelle dans eax
		add edi,4									;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]						;; placer eax (- 1  chaque octets du motlong) dans edx
		xor eax,edx								;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h							;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1									;; si le filtrage est gal  0, aller Label1
		and eax,edx								;; ne conserver en eax que les bits positionns en edx
		jz Label1									;; si le filtrage est gal  0, aller Label1
		bsf edx,eax								;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4									;; soustraire 4 au numro du bit obtenu
		shr edx,3									;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]							;; placer edi + edx - 1 dword dans edi

; ensuite on va prparer nos copie de chaines
		xor ebx,ebx								;; effacer ebx (notre compteur de chanes)
Label2:	push ebx									;; empiler ebx (parcequ'on  plus de registres libres)
		mov ebx,[4*ebx+esi]							;; placer l'adresse de la nouvelle source dans ebx
		xor eax,eax								;; effacer eax (notre compteur d'octets)
		jmp Label4								;; aller Label4

; et on effectue nos copies
Label3:	add ecx,01010101h							;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx					;; placer cette valeur  l'adresse de destination
		add eax,4									;; incrmenter eax (notre compteur d'octets) de 4 (un dword)
Label4:	mov edx,DWORD PTR [ebx+eax]					;; placer le motlong de l'adresse actuelle dans edx
		lea ecx,[edx-01010101h]						;; placer eax (- 1  chaque octets du motlong) dans ecx
		xor edx,ecx								;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h							;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label3									;; si le filtrage est gal  0, aller Label3
		and edx,ecx								;; ne conserver en edx que les bits positionns en ecx
		jz Label3									;; si le filtrage est gal  0, aller Label3
		add ecx,01010101h							;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl							;; placer cl  l'adresse en edi+eax
		test cl,cl								;; fixer les flags de cl
		jz Label7									;; si c'est gal  0, aller Label7
		mov [edi+eax+1],ch							;; placer ch  l'adresse en edi+eax+1
		test ch,ch								;; fixer les flags de ch
		jz Label6									;; si c'est gal  0, aller Label6
		shr ecx,16								;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl							;; placer cl  l'adresse en edi+eax+2
		test cl,cl								;; fixer les flags de cl
		jz Label5									;; si c'est gal  0, aller Label5
		mov [edi+eax+3],ch							;; placer ch  l'adresse en edi+eax+3
		inc eax									;; ajouter 1  eax
Label5:	inc eax									;; ajouter 1  eax
Label6:	inc eax									;; ajouter 1  eax
Label7:	lea edi,[edi+eax]							;; ajouter eax+1  edi

; l on va tester s'il y a une autre source  ajouter
		pop ebx									;; dsempiler ebx (pour r-obtenir notre compteur de sources)
		inc ebx									;; ajouter 1 au nombre de source
		cmp ebx,_Compteur_							;; et le comparer  Compteur
		jne Label2								;; si c'est diffrent, aller Label2

; ici, on calcul la nouvelle taille de la chane...
		mov eax,edi								;; placer edi dans eax

		pop edi									;; dsempiler edi
		sub eax,edi								;; et soustraire AdresseDestination  eax pour obtenir la nouvelle taille de la chane
		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
FusionnerMultiplesChainesAscii ENDP


ALIGN 16
;
; copier une chane de caractres dans une autre chane
; note : les chanes sources et destination doivent tre aligne sur 8/16 octets (pour une meilleure vitesse)
; et videment, les tailles doivent tre valides pour les chanes source et destination
;
; Rceptionne :
; esi = adresse de la chane source.
; edi = adresse dans la chane de destination
;
; Retourne :
; eax = nombre de caractres copis (c-a-d la taille de la chane)
;
; syntaxe : Mmx_CopierChaineAscii
;
Mmx_CopierChaineAscii PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov eax,-16								;; placer -8 dans eax
		pxor MM2,MM2								;; ) effacer MM2 et MM3 (ce sera nos registres de comparaison)
		pxor MM3,MM3								;; )
		jmp Label2								;; aller Label2
		nop										;; ) alignement ncessaire pour un meilleur rendement
		nop										;; )
Label1:	movq QWORD PTR [edi+eax],MM0					;; copier MM0  l'adresse en edi+eax
		movq QWORD PTR [edi+eax+8],MM1				;; copier MM1  l'adresse en edi+eax+8
Label2:	add eax,16								;; ajouter 16  eax (notre pas de progression)
		movq MM0,QWORD PTR [esi+eax]					;; placer le qword  l'adresse en esi+eax dans MM0
		movq MM1,QWORD PTR [esi+eax+8]				;; placer le qword  l'adresse en esi+eax+8 dans MM1
		pcmpeqb MM2,MM0							;; comparer les octets en parallle, pour voir si l'un de ceux en MM0 est gal  0
		pcmpeqb MM3,MM1							;; comparer les octets en parallle, pour voir si l'un de ceux en MM1 est gal  0
		por MM2,MM3								;; fusionner MM2 et MM3 dans MM2
		pmovmskb edx,MM2							;; gnrer le masque de MM2 dans edx
		test edx,edx								;; fixer les flags de edx
		jz Label1									;; si c'est gal  0, aller Label1
		jmp Label4								;; aller Label4
Label3:	add edx,01010101h							;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],edx					;; placer cette valeur  l'adresse de destination
		add eax,4									;; incrmenter esi (l'adresse) de 4 (un dword)
Label4:	mov ecx,DWORD PTR [esi+eax]					;; placer le motlong de l'adresse actuelle dans eax
		lea edx,[ecx-01010101h]						;; placer eax (- 1  chaque octets du motlong) dans edx
		xor ecx,edx								;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and ecx,80808080h							;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label3									;; si le filtrage est gal  0, aller Label3
		and ecx,edx								;; ne conserver en eax que les bits positionns en edx
		jz Label3									;; si le filtrage est gal  0, aller Label3
		add edx,01010101h							;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de ecx
		mov [edi+eax],dl							;; placer dl  l'adresse en edi+eax
		test dl,dl								;; fixer les flags de dl
		jz Label7									;; si c'est gal  0, aller Label7
		mov [edi+eax+1],dh							;; placer dh  l'adresse en edi+eax+1
		test dh,dh								;; fixer les flags de dh
		jz Label6									;; si c'est gal  0, aller Label6
		shr edx,16								;; dcaler edx  droite de 16 bits
		mov [edi+eax+2],dl							;; placer dl  l'adresse en edi+eax+2
		test dl,dl								;; fixer les flags de dl
		jz Label5									;; si c'est gal  0, aller Label5
		mov [edi+eax+3],dh							;; placer dh  l'adresse en edi+eax+3
		inc eax									;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label5:	inc eax									;; ajouter 1  eax )
Label6:	inc eax									;; ajouter 1  eax )
Label7:
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_CopierChaineAscii ENDP


ALIGN 16
;
; obtenir la taille relle d'une chane de caractres
; note : la chane doit tre aligne sur 8/16 octets (pour une meilleure vitesse)
;
; Rceptionne :
; esi = adresse la chane dont on veut obtenir la taille
;
; Retourne :
; eax = la taille relle de la chane dans eax
;
; syntaxe : Mmx_ObtenirTailleChaineAscii
;
Mmx_ObtenirTailleChaineAscii PROC
		push edx									;; empiler edx

		xor eax,eax								;; effacer eax
		pxor MM5,MM5								;; effacer MM5 (ce sera notre registre de comparaison)

; ici, on teste un bloc de 32 caractres, pour voir s'il existe un 0
Label1:	movq MM0,QWORD PTR [esi+eax]					;; placer le qword  l'adresse en esi+eax dans MM0
		movq MM1,QWORD PTR [esi+eax+8]				;; placer le qword  l'adresse en esi+eax+8 dans MM1
		movq MM2,QWORD PTR [esi+eax+16]				;; placer le qword  l'adresse en esi+eax+16 dans MM2
		movq MM3,QWORD PTR [esi+eax+24]				;; placer le qword  l'adresse en esi+eax+24 dans MM3
		pcmpeqb MM0,MM5							;; comparer les octets en MM0  ceux en MM5 pour voir si l'un d'eux est gal  0
		pcmpeqb MM1,MM5							;; comparer les octets en MM1  ceux en MM5 pour voir si l'un d'eux est gal  0
		pcmpeqb MM2,MM5							;; comparer les octets en MM2  ceux en MM5 pour voir si l'un d'eux est gal  0
		pcmpeqb MM3,MM5							;; comparer les octets en MM3  ceux en MM5 pour voir si l'un d'eux est gal  0
		add eax,32								;; ajouter 32 (notre pas de progression)  eax
		movq MM4,MM0								;; placer MM0 dans MM4
		por MM4,MM1								;; fusionner MM1 dans MM4
		por MM4,MM2								;; fusionner MM2 dans MM4
		por MM4,MM3								;; fusionner MM3 dans MM4
		pmovmskb edx,MM4							;; gnrer le masque de MM4 dans edx
		test edx,edx								;; fixer les flags de edx
		jz Label1									;; si c'est gal  0 (pas de 0 trouv), aller Label1
		sub eax,32								;; sinon (un 0 est trouv), enlever 32 (la dernire progression)  eax

; ici, on va chercher le 0 dans le bloc de 32 caractres
		pmovmskb edx,MM0							;; gnrer le masque de MM0 dans edx
		test edx,edx								;; fixer les flags de edx
		jnz Label2								;; si c'est gal  0, aller Label2
		add eax,8									;; ajouter 8  eax (notre pas de progression)
		pmovmskb edx,MM1							;; gnrer le masque de MM1 dans edx
		test edx,edx								;; fixer les flags de edx
		jnz Label2								;; si c'est gal  0, aller Label2
		add eax,8									;; ajouter 8  eax (notre pas de progression)
		pmovmskb edx,MM2							;; gnrer le masque de MM2 dans edx
		test edx,edx								;; fixer les flags de edx
		jnz Label2								;; si c'est gal  0, aller Label2
		add eax,8									;; ajouter 8  eax (notre pas de progression)
		pmovmskb edx,MM3							;; gnrer le masque de MM3 dans edx
Label2:	bsf edx,edx								;; scanner le premier bit arm  partir de la droite
		add eax,edx								;; ajouter edx  eax pour obtenir la taille finale

		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
Mmx_ObtenirTailleChaineAscii ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de chaines de caractres graphiques
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Chaine_Position_Ecran_X_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Position_Ecran_Y_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Boucle_Largeur_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Adresse_Police_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Couleur_Police_			DWORD 000FFFFFFh,?,?,?	;; (align 16) blanc par dfaut
_Chaine_Couleur_Fond_			DWORD 000000000h,?,?,?	;; (align 16) noir par dfaut
_Chaine_Adresse_Caractere_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Largeur_Caractere_X4_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Passage_Caractere_Suivant_	DWORD ?,?,?,?			;; (align 16)
_Chaine_Hauteur_Police_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Mmx_Masque_Alpha_movd_	DWORD 0FF000000h,0FF000000h,0FF000000h,0FF000000h
_Chaine_Mmx_Masque_ARVB_unpck_	DWORD 000FF00FFh,000FF00FFh,000FF00FFh,000FF00FFh
; note : ici, toutes les variables sont alignes sur 16 octets pour une question de rapidit


.CODE
ALIGN 16
;
; Afficher une chane de caractres (largeur maximale des caractres de la police = 32 pixels, (ce qui est suffisant
; dans la plupart des cas...))
; (cette version considre que les alphas de la couleur de la police = FF, ce qui est gnralement le cas...)
;
; Syntaxe :
; mov eax,{position X (largeur en pixels) de dpart}
; mov ebx,{position Y (hauteur en pixels) de dpart}
; mov edx,{adresse de la police de caratres  utiliser}
; mov esi,{adresse de la chaine  afficher}
; mov edi,{adresse (offset) de la structure cran}
; call Mmx_AfficherChaine_Alpha_Turbo
;
; Retourne :
; rien, mais la chaine est affiche  l'cran (attention, tous les registre MMx sont modifis)
;
Mmx_AfficherChaine_Alpha_Turbo PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; on initialise les variables que l'on va utiliser
		mov ebp,edi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
		mov _Chaine_Adresse_Police_,edx				;; sauvegarder l'adresse de la police utilise
		mov _Chaine_Adresse_Caractere_,esi				;; sauvegarder l'adresse du caractre  afficher
		mov esi,DWORD PTR [edx]						;; placer la hauteur de la police dans esi
		mov _Chaine_Hauteur_Police_,esi				;; placer la hauteur de la police dans _Chaine_Hauteur_Police_
; calculer la position X
		shl eax,2									;; multiplier la position X par 4
		mov _Chaine_Position_Ecran_X_,eax				;; sauvegarder la position dans la variable _Chaine_Position_Ecran_X_
; calculer la zone cran
		mov ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans ecx
		mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; placer l'adresse de dpart de l'cran dans edi
; calculer la position Y
		mov eax,ecx								;; placer la largeur d'une ligne cran x4 dans eax
		imul ebx									;; multiplier par la hauteur
; on dfini la position Y dans l'cran
		add edi,eax								;; ajouter la position Y  l'adresse de dpart
; calculer le dcalage cran pour passer au caractre suivant
		mov eax,ecx								;; placer la largeur d'une ligne cran x4 dans eax
		mul _Chaine_Hauteur_Police_					;; multiplier par la hauteur de la police
		mov _Chaine_Passage_Caractere_Suivant_,eax		;; sauvegarder le dcalage
		mov ebx,_Chaine_Position_Ecran_X_				;; placer la position  crire dans ebx
		movd MM5,_Chaine_Couleur_Police_
		movd MM6,_Chaine_Couleur_Fond_				;; MM6 = A,R,V,B
		movd MM2,_Chaine_Couleur_Fond_				;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Chaine_Mmx_Masque_Alpha_movd_	;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Chaine_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0

;ALIGN 16
; on traite la chane de caractres, pour commencer on teste si c'est la fin de chane
Label01:	mov edx,_Chaine_Adresse_Caractere_				;; placer l'adresse du caractre  afficher dans edi
		movzx eax,BYTE PTR [edx]						;; placer le caractre  afficher dans eax
		test eax,eax								;; fixer les flags de eax
		jz Label14								;; si eax est gal  zro (fin de chane), aller Label14 (la sortie)
; sinon, on teste la validit du caractre
		cmp eax,32								;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label07								;; si c'est infrieur  32, aller Label07
		mov esi,_Chaine_Adresse_Police_				;; placer l'adresse de la police dans esi
		mov ecx,DWORD PTR [esi]						;; et lire la hauteur des caractres
		shl ecx,2									;; multiplier ecx par 4 (puisque, ici, on lit des dwords)
		cmp eax,DWORD PTR [esi+4]					;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02								;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127								;; sinon, placer 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32								;; enlever les 32 caractres "non affichables"  eax
; on cherche l'emplacement des donnes du caractre  afficher
		add ecx,4									;; ajouter le dword correspondant  la largeur du caractre
		mul ecx									;; multiplier le caractre en eax par la "hauteur" des caractres
		add esi,eax								;; ajouter le rsultat obtenu  l'adresse de dpart de la police
; ici, esi+8 = largeur du caractre, et esi+12 = adresse des donnes du caractre
		mov eax,DWORD PTR [esi+8]					;; placer la largeur du caractre dans eax
		shl eax,2									;; multiplier cette largeur par 4 (puisqu'on lit des dwords)
		mov _Chaine_Largeur_Caractere_X4_,eax			;; sauvegarder la largeur du caractre *4 en cours de traitement
; on dfini la boucle pour la hauteur
		mov eax,_Chaine_Hauteur_Police_				;; lire la hauteur des caractres
		shl eax,2									;; multiplier cette hauteur par 4, (puisqu'on lit des dwords)
		add esi,eax								;; ajouter eax  esi
		neg eax									;; inverser eax (qui devient notre compteur de boucle pour la hauteur)

; on teste si le caractre est pleinement dans l'cran
		mov edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; ) test de prsence cran Y
		mov ecx,edi								;; )
		sub ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp ecx,edx								;; )
		jae Label08								;; )
		add ecx,_Chaine_Passage_Caractere_Suivant_		;; )
		cmp ecx,edx								;; )
		jae Label08								;; )
		mov edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;;	) test de presence cran X
		mov ecx,ebx								;;	)
		cmp ecx,edx								;;	)
		jae Label08								;;	)
		add ecx,_Chaine_Largeur_Caractere_X4_			;;	)
		cmp ecx,edx								;;	)
		jae Label08								;;	)

;ALIGN 16
; ici, le caractre est entirement dans l'cran, boucle pour la hauteur, on dfini la boucle pour la largeur
Label03:	mov ecx,DWORD PTR [esi+eax+12]				;; placer le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la hauteur, le dword du caractre maxi et le dword de la largeur du caractre)
		mov edx,_Chaine_Largeur_Caractere_X4_			;; placer la largeur du caractre *4 dans edx
		mov _Chaine_Boucle_Largeur_,edx				;; et la recopier dans _Chaine_Boucle_Largeur_ (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label04:	shl ecx,1									;; sinon, tester les bits "de 31  31-largeur"
		jnc Label05								;; si le flag carry n'est pas positionn, aller Label05
		movd DWORD PTR [edi+ebx],MM5					;; placer la couleur (le pixel)  l'adresse en edi+esi
		jmp Label06								;; aller Label06
Label05:	movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
; ici, application de la transparence alpha sur le pixel
		movd MM0,DWORD PTR [edi+ebx]					;; MM0 = A,R,V,B (lire la couleur de fond)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
Label06:	add ebx,4									;; pour aller traiter le pixel suivant de la ligne
; fin boucle largeur
		sub _Chaine_Boucle_Largeur_,4					;; enlever 1 pixel  notre compteur de boucle
		jnz Label04								;; tant que c'est diffrent de 0, aller Label04
; sinon, on passe  la ligne suivante
		sub ebx,_Chaine_Largeur_Caractere_X4_			;; soustraire la largeur traite, pour paser  la ligne suivante
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,4									;; incrmenter d'1 dword le compteur de boucle pour la hauteur
		jnz Label03								;; tant que eax n'est pas gal  zro, aller Label03
; sinon, on passe au caractre  afficher suivant
		sub edi,_Chaine_Passage_Caractere_Suivant_		;; soustraire le dcalage  edi
		add ebx,_Chaine_Largeur_Caractere_X4_			;; ajouter la largeur du caractre trait  ebx
; fin boucle caractres
Label07:	inc _Chaine_Adresse_Caractere_				;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01

;ALIGN 16
; ici, le caractre n'est pas entirement dans l'cran, boucle pour la hauteur
Label08:	mov ecx,edi								;; ) test de prsence cran Y
		sub ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; )
		jae Label13								;; )
; sinon, on dfini la boucle pour la largeur
		mov ecx,DWORD PTR [esi+eax+12]				;; sinon, placer le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la hauteur, le dword du caractre maxi et le dword de la largeur du caractre)
		mov edx,_Chaine_Largeur_Caractere_X4_			;; placer la largeur du caractre *4 dans edx
		mov _Chaine_Boucle_Largeur_,edx				;; et la recopier dans _Chaine_Boucle_Largeur_ (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label09:	shl ecx,1									;; sinon, tester les bits "de 31  31-largeur"
		jnc Label10								;; si le flag carry n'est pas positionn, aller Label10
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de presence cran X
		jae Label12								;; )
		movd DWORD PTR [edi+ebx],MM5					;; placer la couleur (le pixel)  l'adresse en edi+esi
		jmp Label12								;; aller Label11
Label10:	cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de presence cran X
		jae Label12								;; )
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
; ici, application de la transparence alpha sur le pixel
Label11:	movd MM0,DWORD PTR [edi+ebx]					;; MM0 = A,R,V,B (lire la couleur de fond)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
Label12:	add ebx,4									;; pour aller traiter le pixel suivant de la ligne
; fin boucle largeur
		sub _Chaine_Boucle_Largeur_,4					;; enlever 1 pixel  notre compteur de boucle
		jnz Label09								;; tant que c'est diffrent de 0, aller Label09
; sinon, on passe  la ligne suivante
		sub ebx,_Chaine_Largeur_Caractere_X4_			;; soustraire la largeur traite, pour paser  la ligne suivante
Label13:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,4									;; incrmenter d'1 dword le compteur de boucle pour la hauteur
		jnz Label08								;; tant que eax n'est pas gal  zro, aller Label08
; sinon, on passe au caractre  afficher suivant
		sub edi,_Chaine_Passage_Caractere_Suivant_		;; soustraire le dcalage  edi
		add ebx,_Chaine_Largeur_Caractere_X4_			;; ajouter la largeur du caractre trait  ebx
		inc _Chaine_Adresse_Caractere_				;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01
Label14:
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AfficherChaine_Alpha_Turbo ENDP


ALIGN 16
;
; dfinir les couleurs (caractres + fond) d'une chane de caractres
; note : ca peut paraitre stupide de crer une procdure avec seulement 2 instructions, mais ca permet d'eviter
; de rpeter cette opration systmatiquement dans AfficherChaine (gain de vitesse), et c'est aussi quelque chose
; qui peut tre appel un nombre de fois considrable (donc, une macro prendrai beucoup plus d'espace mmoire)
;
; Rceptionne :
; eax = couleur de la police de caractres
; ebx = couleur de fond de la police de caractres
;
; Retourne :
; rien, mais les variables _Chaine_Couleur_Police_ et _Chaine_Couleur_Fond_ qui servent pour AfficherChaine est dfinie
;
; Syntaxe : DefinirCouleursChaine
;
DefinirCouleursChaine PROC
		mov _Chaine_Couleur_Police_,eax				;; sauvegarder la couleur de la police
		mov _Chaine_Couleur_Fond_,ebx					;; sauvegarder la couleur de fond de la police
	ret											;; retourner (sortir de la procdure)
DefinirCouleursChaine ENDP
